;---FSERVE SCRIPT by mr.man (c) 2007---

;---VARIOUS ALIASES---

alias fserver {
  dialog -m fserve fserve
}

alias -l inifile {
  return $+(",$scriptdir,settings\fserve.ini,")
}

alias -l savesettings {
  if (!%restart) {
    if ($hget(fserve)) {
      hsave -i fserve $inifile Settings
    }
  }
}

alias -l loadsettings {
  var %t = fserve
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
  else {
    makedefsettings
  }
}

alias -l makedefsettings {
  hadd fserve trigger +trig
  hadd fserve maxsends 1
  hadd fserve lowcps 1024
  hadd fserve home c:\
  hadd fserve channels #fserve
  hadd fserve adtimer 600
  hadd fserve autoad $false
  hadd fserve timeout 600
  savesettings
}

;---SOME EVENTS---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

;---DIALOG STUFF---

dialog fserve {
  title "FServe Settings"
  size -1 -1 447 388
  option pixels
  tab "FServe", 1, 4 74 438 281
  box "Channels", 2, 13 232 202 109, tab 1
  check "FServe Active", 3, 7 361 93 20, tab 1
  list 5, 23 250 180 78, tab 1 size
  box "Advertise", 20, 224 100 209 58, tab 1
  check "Auto Ad every", 21, 236 123 90 20, tab 1
  edit "", 22, 326 120 40 23, tab 1
  text "Seconds", 23, 371 126 41 16, tab 1
  box "MOTD Editor", 6, 224 232 209 109, tab 1
  edit "", 7, 236 250 185 78, tab 1 multi return vsbar
  box "Idle Timeout", 25, 224 164 209 63, tab 1
  box "Settings", 4, 13 100 202 128, tab 1
  edit "", 8, 86 118 117 23, tab 1 autohs
  edit "", 9, 86 143 117 23, tab 1 autohs
  edit "", 10, 86 168 117 23, tab 1 autohs
  edit "", 11, 86 193 92 23, tab 1 autohs
  button "...", 24, 181 196 22 18, tab 1
  text "Kick user after", 26, 236 193 70 16, tab 1
  edit "", 27, 309 188 40 23, tab 1
  text "Seconds Idle", 28, 354 193 69 16, tab 1
  text "Trigger:", 12, 25 123 60 16, tab 1
  text "Max Sends:", 13, 25 147 60 16, tab 1
  text "Low CPS:", 14, 25 172 60 16, tab 1
  text "Home Dir:", 15, 25 197 60 16, tab 1
  button "OK", 16, 368 360 75 22, ok
  icon 17, -2 0 450 64, $scriptdir $+ libraries\icons\fserveheader.png, noborder
}

on *:dialog:fserve:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 5 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 5 1 headerdims 155:1
  did -i $dname 5 1 headertext 0 Channels
  if ($hget(fserve,active)) {
    did -c $dname 3
  }
  else {
    did -u $dname 3
  }
  did -ar $dname 8 $hget(fserve,trigger)
  did -ar $dname 9 $hget(fserve,maxsends)
  did -ar $dname 10 $hget(fserve,lowcps)
  did -ar $dname 11 $hget(fserve,home)
  if ($hget(fserve,autoad)) {
    did -c $dname 21
    did -b $dname 22
  }
  else {
    did -u $dname 21
    did -e $dname 22
  }
  did -ar $dname 22 $hget(fserve,adtimer)
  fillfschans
  did -ar $dname 27 $hget(fserve,timeout)
  loadmotd
}

on *:dialog:fserve:sclick:3:{
  if ($did($dname,3).state == 0) {
    hadd fserve active $false
    fserveoff
  }
  else if ($did($dname,3).state == 1) {
    hadd fserve active $true
    fserveon
  }
}

on *:dialog:fserve:sclick:5:{
  if ($gettok($did($dname,5,1),1,32) == rclick) {
    fspop $did(5).sel $gettok($gettok($did(5).seltext,6,32),1,9)
  }
}

on *:dialog:fserve:sclick:16:{
  hadd fserve trigger $did($dname,8)
  hadd fserve maxsends $did($dname,9)
  hadd fserve lowcps $did($dname,10)
  hadd fserve home $did($dname,11)
  hadd fserve adtimer $did($dname,22)
  hadd fserve timeout $did($dname,27)
  savemotd
  savesettings
}

on *:dialog:fserve:sclick:21:{
  if ($did($dname,22)) {
    if ($did($dname,21).state == 0) {
      did -e $dname 22
      hadd fserve autoad $false
      .timerad off
    }
    else if ($did($dname,21).state == 1) {
      did -b $dname 22
      hadd fserve autoad $true
      .timerad 0 $did($dname,22) fservead
    }
  }
}

on *:dialog:fserve:sclick:24:{
  var %dir = $sdir(c:\,Select Folder to Serve)
  if (%dir) { did -ar $dname 11 %dir }
  hadd fserve home %dir
}

alias loadmotd {
  var %l = 1, %motd = $+(",$scriptdir,settings\motd.txt,")
  while (%l <= $lines(%motd)) {
    var %r = $read(%motd,%l)
    if (%r) {
      did -a fserve 7 %r $+ $crlf
    }
    else {
      did -a fserve 7 $crlf
    }
    inc %l
  }
}

alias savemotd {
  var %l = 1, %motd = $+(",$scriptdir,settings\motd.txt,")
  write -c %motd
  while (%l <= $did(fserve,7).lines) {
    var %m = $did(fserve,7,%l)
    if (%m) {
      write %motd %m
    }
    else {
      write %motd $crlf
    }
    inc %l
  }
  if (!$read(%motd,$lines(%motd))) {
    write -d %motd
  }
}

alias fillfschans {
  var %l = 1, %chans = $sorttok($hget(fserve,channels),44)
  while (%l <= $numtok(%chans,44)) {
    var %chan = $gettok(%chans,%l,44) 
    did -a fserve 5 + 0 0 0 %chan
    inc %l
  }
}

alias fspop {
  popups New fspop 16 16
  popups SetMetrics fspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem fspop end + Add $cr addfschan
  popups AddItem fspop end + Delete $cr delfschan $1 $2
  popup fspop $mouse.dx $mouse.dy
}

alias addfschan {
  var %chan = $input(Please enter a new Channel name.,equ,Query...,$null)
  hadd fserve channels $addtok($hget(fserve,channels),%chan,44)
  did -r fserve 5
  fillfschans
}

alias delfschan {
  did -d fserve 5 $1
  hadd fserve channels $remtok($hget(fserve,channels),$2,44)
}

alias fscontrol {
  if (!$dialog(fscontrol)) {
    dialog -m fscontrol fscontrol
    loadlog
  }
}

dialog fscontrol {
  title "FServe Control"
  size -1 -1 482 415
  option pixels
  tab "Control", 1, 5 74 470 305
  box "Messages", 3, 16 101 449 262, tab 1
  button "", 5, 27 119 426 231, tab 1
  button "OK", 4, 401 385 75 22, ok
  icon 2, -2 0 485 64, $scriptdir $+ libraries\icons\fsctrlheader.png, noborder
}

on *:dialog:fscontrol:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 5 window > $dlg
  fserveshow
  did -a $dname 5 grab $window(@fserve).hwnd @fserve
}

on *:dialog:fscontrol:sclick:4:{
  savelog
}

;---FSERVE ALIASES---

alias fserveon {
  .enable #fserve
  if (!$isfile($+(",$scriptdir,settings\motd.txt,"))) {
    write $+(",$scriptdir,settings\motd.txt,") There is no MOTD!
  }
}

alias fserveoff {
  .disable #fserve
}

alias fservead {
  hadd fserve adsends $send(0)
  var %q = $readini($+(",$scriptdir,settings\fserve.ini,"),queue,number)
  if (%q == $null) {
    var %q = 0
  }
  hadd fserve adqueue %q
  var %s = 1
  while (%s <= $scon(0)) {
    scon %s
    var %l = 1
    while (%l <= $numtok($hget(fserve,channels),44)) {
      var %c = $gettok($hget(fserve,channels),%l,44)
      var %trigger $hget(fserve,trigger)
      var %maxsends $hget(fserve,maxsends)
      var %adsends $hget(fserve,adsends)
      var %adqueue $hget(fserve,adqueue)
      if (%c ischan) && ($hget(fserve,active)) {
        msg %c $s.head(FServe Active) $s.sep $s.head(Trigger) $s.encleft $+ $s.value(%trigger) $+ $s.encright $s.sep $s.head(Current Sends) $s.encleft $+ $s.value(%adsends) $+ $s.encright $s.sep $s.head(Max Sends) $s.encleft $+ $s.value(%maxsends) $+ $s.encright $s.sep $s.head(Queue) $s.encleft $+ $s.value(%adqueue $+ /99) $+ $s.encright $s.head(Taken)
      }
      inc %l
    }
    inc %s
  }
  return 
}

alias clearq {
  writeini $+(",$scriptdir,settings\fserve.ini,") queue number 0
}

alias fservecps {
  var %l = 0
  while (%l <= $send(0)) {
    if ($send(%l).cps < $hget(fserve,lowcps)) && ($send(%l).pc > 10) {
      hadd fserve nick $send(%l)
      close -s $send(%l)
      if ($readini($inifile,queue,number) > 0) { 
        dcc send $readini($inifile,queue,1)
        hadd fserve new 1
        hadd fserve old 0
        remini $inifile queue $hget(fserve,new)
        remini $inifile queue2 $hget(fserve,new)
        :queue
        hinc fserve new | hinc fserve old
        if ($readini($inifile,queue,$hget(fserve,new) == $null) {
          remini $inifile queue $hget(fserve,old)
          remini $inifile queue2 $hget(fserve,old)
          hdec fserve old
          writeini $inifile queue number $hget(fserve,old)
          hadd fserve queue $hget(fserve,old) | goto end
        }
        hadd fserve move $readini($inifile,queue,$hget(fserve,new)
        hadd fserve move2 $readini($inifile,queue2,$hget(fserve,new)
        writeini $inifile queue $hget(fserve,old) $hget(fserve,move)
        writeini $inifile queue2 $hget(fserve,old) $hget(fserve,move2)
        goto queue
        :end
      }
      if ($hget(fserve,nick) != $null) {
        ;notice $hget(fserve,nick) DCC transfer rate dropped below $hget(fserve,lowcps) $+ cps
      }
      if ($sock(nxgfserve. [ $+ [ $hget(fserve,nick) ] ] ).status != active) { return } 
      sockwrite -n nxgfserve. [ $+ [ $hget(fserve,nick) ] ] file transfer dropped below $hget(fserve,lowcps) $+ cps!
    }
    inc %l
  }
}

alias fserveshow {
  var %fserves = 1, %win = @fserve
  if (!$window(%win)) {
    window -hdael9kS %win
  } 
  clear -l %win
  while (%fserves <= $sock(nxgfserve.*,0)) {
    aline -l %win $remove($sock(nxgfserve.*,%fserves),nxgfserve.)  
    inc %fserves
  }
}

menu @fserve {
  dclick {
    if ($sline(@fserve,1)) && ($active == @fserve) {
      var %nick = $sline(@fserve,1)
      .timer $+ %nick $+ idler off
      if ($sock(nxgfserve. [ $+ [ %nick ] ] ).status == active) { 
        sockwrite -n nxgfserve. [ $+ [ %nick ] ] Boing!
      } 
      echo @fserve %nick has been kicked from the FServe
      var %n = 0
      while (%n <= $line(@fserve,0,1)) {
        if ($line(@fserve,%n,1) == %nick) {
          dline -l @fserve %n

        }
        inc %n
      }
      var %p = 1
      while (%p <= $sock(nxgfserve.*,%p)) {
        sockwrite -n $sock(nxgfserve.*,%p) %nick was kicked from the FServe.
        inc %p
      }
      sockclose nxgfserve. [ $+ [ %nick ] ] 
    }
  }
  Directory:if ($sline(@fserve,1) != $null) { echo -a $sline(@fserve,1) is currently in: $remove($sock(nxgfserve. [ $+ [ $sline(@fserve,1) ] ] ).mark,nxgfserve.) }
  -
  Clear:clear | write -c $+(",$scriptdir,settings\fserve.log,")
  Close:dialog -x fscontrol
}

on *:text:*:#: {
  if ($1 == $hget(fserve,trigger)) && ($chan isin $hget(fserve,channels)) {
    if (!$hget(fserve,active)) {
      .notice $nick Sorry $nick $+ , $hget(fserve,owner) $+ 's FServe is currently down. Please try later.
      return
    }
    else {
      close -m $nick
      theme.text $s.head(User) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(has triggered the FServe. Press Ctrl+F11 to open Control))
      if ([ $sock(nxgfs. [ $+ [ $nick ] ] ) $+ $sock(nxgfserve. [ $+ [ $nick ] ] ) ] != $null) {
        .raw -q notice $nick : $+ sorry, you currently have an fserve session running
        return
      }
      if ($window(@fserve)) {
        echo @fserve $nick has triggered the FServer.
      } 
      :loop
      var %prstart = $gettok($readini($mircini,options,n4),13,44)
      var %prend = $gettok($readini($mircini,options,n4),26,44)
      var %port = $rand(%prstart,%prend) 
      if ($portfree(%port) != $true) { goto loop } 
      raw -q PRIVMSG $nick :DCC CHAT CHAT $longip($ip) %port $+  
      sockclose nxgfs. [ $+ [ $nick ] ] 
      .timer $+ $nick 1 30 fservetimeout nxgfs. [ $+ [ $nick ] ] $nick 
      socklisten nxgfs. [ $+ [ $nick ] ] %port
    }
  }
}

alias savelog {
  savebuf @fserve $+(",$scriptdir,settings\fserve.log,")
}

alias loadlog {
  if ($exists($+(",$scriptdir,settings\fserve.log,"))) {
    loadbuf -pi5 @fserve $+(",$scriptdir,settings\fserve.log,")
  }
}

#fserve off

alias fservetimeout {
  if ($sock($1) == $null) { return } 
  sockclose $1
  if ($window(@fserve)) {
    echo @fserve $2 timed out
    return
  }
}

alias fservekick {
  if ($window(@fserve)) {
    echo @fserve $remove($1,nxgfserve.) idle $hget(fserve,timeout) Seconds... Closing Connection
    var %d = 1
    while (%d <= $line(@fserve,0,1)) {
      if ($line(@fserve,%d,1) == $remove($1,nxgfserve.)) {
        dline -l @fserve %d
      } 
      inc %d
    }
    sockwrite -n $1 -
    sockwrite -n $1 Idle for $hget(fserve,timeout) Seconds...
    sockwrite -n $1 Closing connection
    var %p = 1
    while (%p <= $sock(nxgfserve.*,0)) {
      sockwrite -n $sock(nxgfserve.*,%p) $remove($1,nxgfserve.) left the FServer (idle)
      inc %p
    }
    sockclose $1
  }
}

on *:input:@fserve: { 
  echo @fserve ( $+ $me $+ ) $1-
  var %t = 1
  while (%t <= $sock(nxgfserve.*,0)) {
    sockwrite -n $sock(nxgfserve.*,%t) $1-
    inc %t
  }
} 

on *:socklisten:nxgfs.*: {
  sockaccept $replace($sockname,nxgfs.,nxgfserve.) 
  sockmark $replace($sockname,nxgfs.,nxgfserve.) $hget(fserve,home) 
  .timer [ $+ [ $remove($sockname,nxgfs.) ] ] off
  if ($window(@fserve)) { 
    aline -l @fserve $remove($sockname,nxgfs.)
  } 
  var %conn = $replace($sockname,nxgfs.,nxgfserve.) 
  sockwrite -n %conn Welcome to $hget(fserve,owner) $+ 's FServe
  sockwrite -n %conn Commands: help cd dir get queue motd quit
  sockwrite -n %conn -
  var %f = $+(",$scriptdir,settings\motd.txt,")
  if ($isfile(%f)) {
    var %m = 1
    while (%m <= $lines(%f)) {
      sockwrite -n %conn $read(%f,%m)
      inc %m
    }
  }
  else {
    sockwrite -n %conn MOTD Missing
  }
  sockwrite -n %conn -
  if ($window(@fserve)) {
    echo @fserve $remove(%conn,nxgfserve.) has connected to the FServe. 
  } 
  var %p = 1
  while (%p <= $sock(nxgfserve.*,0)) {
    sockwrite -n $sock(nxgfserve.*,%p) $remove(%conn,nxgfserve.) has joined the chat line.
    inc %p
  }
  .timer $+ $remove(%conn,nxgfserve.) $+ idler 1 $hget(fserve,timeout) fservekick %conn
  sockclose $sockname
}

on *:sockread:nxgfserve.*: { 
  if ($sockerr > 0) { return } 
  var %read 
  sockread %read
  var %nicko = $remove($sock($sockname),nxgfserve.) 
  if ($window(@fserve)) {
    echo @fserve ( $+ %nicko $+ ) %read
  }
  .timer $+ %nicko $+ idler off
  .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
  if ($len($remove(%read,$lf,$cr)) != $len(%read)) || ($asc(%read) == 32) { return }
  if ($gettok(%read,1,32) == help) {
    .timer $+ %nicko $+ idler off
    .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
    sockwrite -n $sockname -
    sockwrite -n $sockname Commands: 
    sockwrite -n $sockname help (listing of commands)
    sockwrite -n $sockname cd <dir> (moves between directories)
    sockwrite -n $sockname cd.. (moves back one directory)
    sockwrite -n $sockname dir (gets contents of directory) 
    sockwrite -n $sockname get <filename.ext> (initiate dcc transfer of file) 
    sockwrite -n $sockname queue (show the current queue)
    sockwrite -n $sockname motd (displays the message of the day)
    sockwrite -n $sockname quit (exit fserve)
    sockwrite -n $sockname -
    return
  }
  if ($gettok(%read,1,32) == cd) || ($gettok(%read,1,32) == cd..) {
    .timer $+ %nicko $+ idler off
    .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
    var %olddir = $sock($sockname).mark
    if ($gettok(%read,2,32) == ..) || ($gettok(%read,1,32) == cd..) {
      if ($isdir(%olddir) == $true) && ($len($hget(fserve,home)) < $len(%olddir)) { 
        %olddir = $gettok(%olddir,1- [ $+ [ $calc($gettok(%olddir,0,92) - 1) ] ] ,92)
      } 
      sockmark $sockname %olddir
      if ($sock($sockname).mark == $hget(fserve,home)) {
        sockwrite -n $sockname $chr(91) $+ \ $+ $chr(93)
      } 
      if ($sock($sockname).mark != $hget(fserve,home)) {
        sockwrite -n $sockname $chr(91) $+ \ $+ $remove(%olddir,$hget(fserve,home)) $+ $chr(93)
      }
      return
    }
    if (/ isin $gettok(%read,2-,32)) || (\ isin $gettok(%read,2-,32))  { 
      if ($sock($sockname).mark == $hget(fserve,home)) {
        sockwrite -n $sockname $chr(91) $+ \ $+ $chr(93)
      } 
      if ($sock($sockname).mark != $hget(fserve,home)) {
        sockwrite -n $sockname please don't use slashes
        sockwrite -n $sockname $chr(91) $+ \ $+ $remove(%olddir,$hget(fserve,home)) $+ $chr(93)
      }
      return
    }
    var %newdir = %olddir $+ \ $+ $gettok(%read,2-,32)
    if ($isdir(%newdir) == $true) { 
      %olddir = %newdir  
    }
    sockmark $sockname %olddir
    if ($sock($sockname).mark == $hget(fserve,home)) {
      sockwrite -n $sockname $chr(91) $+ \ $+ $chr(93)
    } 
    if ($sock($sockname).mark != $hget(fserve,home)) {
      sockwrite -n $sockname $chr(91) $+ \ $+ $remove(%olddir,$hget(fserve,home)) $+ $chr(93)
    }
    return
  }
  if ($gettok(%read,1,32) == dir) { 
    .timer $+ %nicko $+ idler off
    .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
    if ($sock($sockname).mark == $hget(fserve,home)) {
      sockwrite -n $sockname $chr(91) $+ \ $+ *.* $+ $chr(93)
    } 
    if ($sock($sockname).mark != $hget(fserve,home)) {
      sockwrite -n $sockname $chr(91) $+ $remove($sock($sockname).mark,$hget(fserve,home),\\) $+ \*.* $+ $chr(93)
    }
    if ($finddir($sock($sockname).mark,*.*,0,1) == 0) && ($findfile($sock($sockname).mark,*.*,0,1) == 0) { 
      sockwrite -n $sockname -
      sockwrite -n $sockname No files or directories found 
      sockwrite -n $sockname -
      return
    }
    window -hls @dirs
    window -hls @files
    noop $finddir($sock($sockname).mark,*.*,0,1,@dirs)
    noop $findfile($sock($sockname).mark,*.*,0,1,@files)
    var %d = 1
    while (%d <= $line(@dirs,0)) {
      sockwrite -n $sockname < $+ $nopath($line(@dirs,%d)) $+ >
      inc %d
    }
    var %f = 1
    while (%f <= $line(@files,0)) {
      sockwrite -n $sockname $nopath($line(@files,%f))
      inc %f
    }
    sockwrite -n $sockname - 
    window -c @dirs
    window -c @files
    return
  }
  if ($gettok(%read,1,32) == get) { 
    .timer $+ %nicko $+ idler off
    .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
    .timer $+ cpskick 0 5 fservecps
    var %get = $sock($sockname).mark $+ \ $+ $gettok(%read,2-,32)
    if ($gettok(%read,2,32) == $null) {
      sockwrite -n $sockname usage: .get <filename.ext>
      return
    } 
    if ($isfile(%get) != $true) {
      sockwrite -n $sockname -
      sockwrite -n $sockname file not found
      sockwrite -n $sockname -
      return
    }
    if ($send(0) >= $hget(fserve,maxsends)) { 
      if ($hget(fserve,queue) == $null) {
        hadd fserve queue 0
      }
      hinc fserve queue
      if ($hget(fserve,queue) >= 99) {
        hdec fserve queue
        sockwrite -n $sockname -
        sockwrite -n $sockname Sorry, there are no available DCC or Queue slots
        sockwrite -n $sockname Please try again later
        sockwrite -n $sockname -
        return
      }
      writeini $inifile queue $hget(fserve,queue) $remove($sockname,nxgfserve.) " $+ %get $+ " 
      writeini $inifile queue2 $hget(fserve,queue) $remove($sockname,nxgfserve.) $+ : $nopath(%get) 
      writeini $inifile queue number $hget(fserve,queue) 
      sockwrite -n $sockname -
      sockwrite -n $sockname Sorry, there are no available DCC slots 
      sockwrite -n $sockname Your file has been placed in the queue 
      sockwrite -n $sockname $hget(fserve,queue) $+ . $nopath(%get) 
      sockwrite -n $sockname To view the queue, type .queue 
      sockwrite -n $sockname -
      return
    } 
    sockwrite -n $sockname -
    sockwrite -n $sockname $nopath(%get) is on its way...
    sockwrite -n $sockname -
    dcc send $remove($sockname,nxgfserve.) $+(",%get,") 
    return 
  }
  if ($gettok(%read,1,32) == queue) {
    .timer $+ %nicko $+ idler off
    .timer $+ %nicko $+ idler 1 $hget(fserve,timeout) fservekick $sockname
    sockwrite -n $sockname -
    var %qi = 0
    :loop
    inc %qi
    if ($readini($inifile,queue2,%qi) == $null) {
      sockwrite -n $sockname end of queue
      sockwrite -n $sockname -
      return
    }
    sockwrite -n $sockname %qi $+ . $readini($inifile,queue2,%qi)
    goto loop
  }
  if ($gettok(%read,1,32) == quit) {  
    .timer $+ %nicko $+ idler off  
    if ($window(@fserve)) { 
      var %d = 1
      while (%d <= $line(@fserve,0,1)) {
        if ($line(@fserve,%d,1) == $remove($1,nxgfserve.)) {
          dline -l @fserve %d
        } 
        inc %d
      }
    }
    sockwrite -n $sockname Bye Bye!
    var %p = 1
    while (%p <= $sock(nxgfserve.*,0)) {
      sockwrite -n $sock(nxgfserve.*,%p) $remove($sockname,nxgfserve.) left the FServe.
      inc %p
    }
    var %n = $remove($sockname,nxgfserve.) 
    if ($window(@fserve)) {
      echo @fserve FServe: %n has left the FServe.
      var %d = 1
      while (%d <= $line(@fserve,0,1)) {
        if ($line(@fserve,%d,1) == %n) {
          dline -l @fserve %d
        } 
        inc %d
      }
    }
    sockclose $sockname 
    return
  }
  if ($gettok(%read,1,32) == motd) {
    var %f = $+(",$scriptdir,settings\motd.txt,")
    if ($isfile(%f)) {
      sockwrite -n $sockname Message of the Day
      var %m = 1
      while (%m <= $lines(%f)) {
        sockwrite -n $sockname $read(%f,%m)
        inc %m
      }
    }
    else {
      sockwrite -n $sockname MOTD Missing
    }
  }
  return
}

on *:sockclose:nxgfserve.*: { 
  if ($window(@fserve)) { 
    var %d = 1
    while (%d <= $line(@fserve,0,1)) {
      if ($line(@fserve,%d,1) == $remove($1,nxgfserve.)) {
        dline -l @fserve %d
      } 
      inc %d
    }
  }
  var %inick = $remove($sockname,nxgfserve.)  
  .timer $+ %inick $+ idler off
  if ($window(@fserve)) {
    echo @fserve %inick has left the FServe.
  }
  var %p = 1
  while (%p <= $sock(nxgfserve.*,0)) {
    sockwrite -n $sock(nxgfserve.*,%p) $remove($sockname,nxgfserve.) left the FServe.
    inc %p
  }
}

on *:filesent:*: { 
  if ($readini($inifile,queue,number) > 0) { 
    dcc send $readini($inifile,queue,1) 
    var %new = 1, %old = 0
    remini $inifile queue %new
    remini $inifile queue2 %new
    :loop
    inc %new
    inc %old
    if ($readini($inifile,queue,%new == $null) {
      remini $inifile queue %old
      remini $inifile queue2 %old
      dec %old
      writeini $inifile queue number %old
      hadd fserve queue %old
      goto end
    }
    var %move = $readini($inifile,queue,%new)
    var %move2 $readini($inifile,queue2,%new)
    writeini $inifile queue %old %move
    writeini $inifile queue2 %old %move2
    goto loop
    :end
  }
  if ($nick != $null) {
    ;.notice $nick DCC of $nopath($filename) complete!
  }
  if ($sock(nxgfserve. [ $+ [ $nick ] ] ).status != active) {
    return
  } 
  sockwrite -n nxgfserve. [ $+ [ $nick ] ] File transfer complete!
}

on *:sendfail:*: { 
  if ($readini($inifile,queue,number) > 0) { 
    dcc send $readini($inifile,queue,1) 
    var %new = 1, %old = 0
    remini $inifile queue %new
    remini $inifile queue2 %new
    :loop
    inc %new
    inc %old
    if ($readini($inifile,queue,%new == $null) {
      remini $inifile queue %old
      remini $inifile queue2 %old
      dec %old
      writeini $inifile queue number %old
      hadd fserve queue %old
      goto end
    }
    var %move = $readini($inifile,queue,%new)
    var %move2 = $readini($inifile,queue2,%new)
    writeini $inifile queue %old %move
    writeini $inifile queue2 %old %move2
    goto loop
    :end
  }
  if ($nick != $null) {
    ;.notice $nick DCC of $nopath($filename) incomplete!
  }
  if ($sock(nxgfserve. [ $+ [ $nick ] ] ).status != active) {
    return
  } 
  sockwrite -n nxgfserve. [ $+ [ $nick ] ] File transfer incomplete! 
}

on *:disconnect:{
  close -s
  hadd fserve queue 0
  var %read = 0 
  :loop 
  inc %read 
  if ($sock(nxgfserve.*,%read) == $null) { 
    if ($window(@fserve)) { window -c @fserve } 
    sockclose nxgfs* 
    return
  } 
  sockwrite -n $sock(nxgfserve.*,%read) - 
  sockwrite -n $sock(nxgfserve.*,%read) Disconnected from server 
  sockwrite -n $sock(nxgfserve.*,%read) Closing all connections
  goto loop
}

#fserve end
