;---FTP Client for NeXtGenIRC by mr.man (c) 2008---

on *:start: {
  loadsettings
  dcx xSignal 1 +t
}

on *:exit: {
  savesettings
}

;---ALIASES---

alias ftpc {
  if (!$dialog(ftpclient)) {
    dialog -md ftpclient ftpclient
    .timerftpc 0 1 updatesbar
  }
}

alias -l inifile {
  return $+(",$scriptdir,settings\ftpclient.ini,")
}

alias -l savesettings {
  if (!%restart) {
    var %t = ftpc
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = ftpc
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
  else {
    makedefsettings
  }
}

alias -l makedefsettings {
  hadd ftpc email user@nextgenirc.net
  hadd ftpc defdldir C:/
  hadd ftpc retry 120
  hadd ftpc retrycount 10
  hadd ftpc dataconn 0
  hadd ftpc localport 1
  hadd ftpc portstart 1024
  hadd ftpc portend 2048
  hadd ftpc portip 127.0.0.1
  hadd ftpc xfermode 2
  hadd ftpc div1 200
  hadd ftpc div2 200
  hadd ftpc div3 200
  hadd ftpc col1 100 100
  hadd ftpc col2 100 100 100
  hadd ftpc col3 100 100
  hadd ftpc axx $!null
  hadd ftpc downlarger 2
  hadd ftpc downsame 2
  hadd ftpc downsmaller 2
  hadd ftpc uplarger 2
  hadd ftpc upsame 2
  hadd ftpc upsmaller 2
}

alias -l updatetoolbar {
  if ($hget(ftpc,connected) == 1) {
    xdid -i ftpclient 4 1 2
    xdid -q ftpclient 4 1 Disconnect
  }
  else {
    xdid -i ftpclient 4 1 1
    xdid -q ftpclient 4 1 Connect
  }
}

alias -l updatesbar {
  var %activity = $hget(ftpc,action), %progress = $null, %dspeed = $null, %complete = $null
  if ($sock(ftpdata)) {
    var %datasock = ftpdata
  }
  else {
    var %datasock = ftp.data
  }
  if ($hget(ftpc,action) == Downloading) {
    var %complete = $round($calc($calc($sock(%datasock).rcvd / $hget(ftpc,filesize)) * 100),0) $+ %
    var %dspeed = $bytes($calc($sock(%datasock).rcvd / $sock(%datasock).to)).suf $+ /Sec
    var %progress = $bytes($sock(%datasock).rcvd).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
  }
  else if ($hget(ftpc,action) == Resuming D/L) {
    var %recieved = $hget(ftpc,filegot)
    var %complete = $round($calc($calc($calc($sock(%datasock).rcvd + %recieved) / $hget(ftpc,filesize)) * 100),0) $+ %
    var %dspeed = $bytes($calc($sock(%datasock).rcvd / $sock(%datasock).to)).suf $+ /Sec
    var %progress = $bytes($calc($sock(%datasock).rcvd + %recieved)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
  }
  else if ($hget(ftpc,action) == Uploading) {
    var %recieved = $hget(ftpc,filegot)
    var %complete = $round($calc($calc($calc($sock(%datasock).sent) / $hget(ftpc,filesize)) * 100),0) $+ %
    var %dspeed = $bytes($calc($sock(%datasock).sent / $sock(%datasock).to)).suf $+ /Sec
    var %progress = $bytes($calc($sock(%datasock).sent)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
  }
  else if ($hget(ftpc,action) == Resuming U/L) {
    var %sent = $hget(ftpc,sentbytes)
    var %complete = $round($calc($calc($calc($sock(%datasock).sent + %sent) / $hget(ftpc,filesize)) * 100),0) $+ %
    var %dspeed = $bytes($calc($sock(%datasock).sent / $sock(%datasock).to)).suf $+ /Sec
    var %progress = $bytes($calc($sock(%datasock).sent + %sent)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
  }
  xdid -t ftpclient 12 1 + 0 %activity $+ ...
  xdid -t ftpclient 12 2 + 0 %progress
  xdid -t ftpclient 12 3 + 0 %complete
  xdid -t ftpclient 12 4 + 0 %dspeed
  if (%activity != Idle) && ($hget(ftpc,tray) == 1) {
    xtray -T 1 NXG FTP %activity %progress %complete %dspeed
  }
}

;---MAIN DIALOG STUFF---

dialog ftpclient {
  size -1 -1 500 400
  title "FTP Client"
}

menu @ftpclog {
  Clear:clear @ftpclog
}

on *:dialog:ftpclient:init:*:{
  dcx Mark $dname ftpc_events
  set -u1 %init $true
  window -dh @ftpclog Terminal 12
  xdialog -b $dname +btyz
  xdialog -c $dname 1 divider 0 0 497 400 notheme
  xdid -l $dname 1 25 0 $chr(9) 2 rebar 0 0 500 24 tooltips notheme varheight noresize
  xdid -a $dname 2 0 +ge 0 150 220 0 $null $chr(9) 4 toolbar 0 0 400 25 nodivider list flat tooltips $chr(9) tooltip
  xdid -l $dname 4 16
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\connect.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\disconnect.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\settings.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\siteedit.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\ftpc.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\chat.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\xfer.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\cancel.ico
  xdid -w $dname 4 +nh 0 $scriptdir $+ libraries\icons\mode.ico
  xdid -a $dname 4 5 +l 24 1 $null $chr(9) Connect
  xdid -a $dname 4 6 + 0 - - -
  xdid -a $dname 4 7 +l 24 3 $null $chr(9) Settings
  xdid -a $dname 4 8 +l 24 4 $null $chr(9) Site Editor
  xdid -a $dname 4 10 + 0 - - -
  xdid -a $dname 4 11 +l 24 5 $null $chr(9) Minimize to Tray
  xdid -a $dname 4 12 + 0 - - -
  xdid -a $dname 4 13 +l 24 6 $null $chr(9) Send Message
  xdid -a $dname 4 14 + 0 - - -
  xdid -a $dname 4 15 +l 24 7 $null $chr(9) Start Transfer
  xdid -a $dname 4 16 +l 24 8 $null $chr(9) Cancel Transfer
  xdid -a $dname 4 17 + 0 - - -
  xdid -a $dname 4 18 +lk 24 9 $null $chr(9) Mode
  xdid -r $dname 1 10 0 $chr(9) 5 divider 0 25 497 300 notheme
  xdid -r $dname 5 10 0 $chr(9) 6 divider 0 0 0 0 vertical notheme
  xdid -l $dname 5 10 0 $chr(9) 7 divider 0 0 0 0 vertical notheme
  xdid -l $dname 6 10 0 $chr(9) 8 panel 0 0 0 0
  xdid -r $dname 6 10 0 $chr(9) 9 panel 0 0 0 0
  xdid -c $dname 8 22 listview 0 0 250 95 report fullrow
  xdid -c $dname 9 21 window 0 0 276 95 @ftpclog
  xdid -l $dname 7 10 0 $chr(9) 10 divider 0 0 0 0
  xdid -l $dname 10 27 0 $chr(9) 14 rebar 0 0 250 27 tooltips notheme varheight
  xdid -a $dname 14 0 +ge 0 24 65 $null $chr(9) 15 toolbar 0 0 70 0 nodivider list flat tooltips
  xdid -a $dname 14 0 +ge 0 24 220 $null $chr(9) 16 comboex 0 0 200 0 dropedit
  xdid -l $dname 15 16
  xdid -w $dname 15 +nh 0 $scriptdir $+ libraries\icons\favourites.ico
  xdid -w $dname 15 +nh 0 $scriptdir $+ libraries\icons\updir.ico
  xdid -a $dname 15 1 +l 24 1 $null $chr(9) Favourites
  xdid -a $dname 15 2 +l 24 2 $null $chr(9) Parent Directory
  xdid -r $dname 10 10 0 $chr(9) 13 listview 0 0 0 0 report fullrow
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\floppy.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\hd.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\hdn.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\cd.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\file.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\folder.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\zip.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\rar.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\txt.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\bat.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\exe.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\gif.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\jpg.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\htm.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\bmp.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\pdf.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\wav.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\mus.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\mov.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\doc.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\xls.ico
  xdid -w $dname 13 +nh 0 $scriptdir $+ libraries\icons\ppt.ico
  xdid -f $dname 13 + ansi 8 Tahoma
  xdid -f $dname 16 + ansi 8 Tahoma
  xdid -r $dname 7 10 0 $chr(9) 11 divider 0 0 0 0
  xdid -l $dname 11 27 0 $chr(9) 17 rebar 0 0 250 27 tooltips notheme varheight
  xdid -a $dname 17 0 +ge 0 24 65 $null $chr(9) 18 toolbar 0 0 70 0 nodivider list flat tooltips
  xdid -a $dname 17 0 +ge 0 24 220 $null $chr(9) 19 comboex 0 0 200 0 dropedit
  xdid -r $dname 11 10 0 $chr(9) 20 listview 0 0 0 0 report fullrow
  xdid -f $dname 19 + ansi 8 Tahoma
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\file.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\folder.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\zip.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\rar.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\txt.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\bat.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\exe.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\gif.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\jpg.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\htm.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\bmp.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\pdf.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\wav.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\mus.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\mov.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\doc.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\xls.ico
  xdid -w $dname 20 +nh 0 $scriptdir $+ libraries\icons\ppt.ico
  xdid -f $dname 20 + ansi 8 Tahoma
  xdid -l $dname 18 16
  xdid -w $dname 18 +nh 0 $scriptdir $+ libraries\icons\favourites.ico
  xdid -w $dname 18 +nh 0 $scriptdir $+ libraries\icons\updir.ico
  xdid -a $dname 18 1 +l 24 1 $null $chr(9) Favourites
  xdid -a $dname 18 2 +l 24 2 $null $chr(9) Parent Directory
  xdid -t $dname 22 +l 0 50 Action $chr(9) +l 0 130 Name $chr(9) +l 0 70 Size
  xdid -f $dname 22 + ansi 8 Tahoma
  xdid -t $dname 13 +l 0 130 Name $chr(9) +l 0 70 Size
  xdid -t $dname 20 +l 0 125 Name $chr(9) +l 0 70 Size $chr(9) +l 0 60 Attributes
  xdialog -l $dname root $chr(9) +p 1 0 0 0
  xdialog -l $dname cell root $chr(9) +li 1 1 0 0
  xdid -n $dname 13 0 +m $hget(ftpc,col1)
  xdid -n $dname 20 0 +m $hget(ftpc,col2)
  xdid -n $dname 22 0 +m $hget(ftpc,col3)
  xdialog -c $dname 12 statusbar 0 0 500 20 grip
  xdid -f $dname 12 + ansi 8 Tahoma
  xdid -l $dname 12 100 120 40 120 -1
  ftpctrllog Welcome to NXG's FTP Client
  .timer 1 0 listfiles $hget(ftpc,defdldir)
  .timer 1 0 xdid -a ftpclient 16 -1 0 0 0 0 $hget(ftpc,defdldir)
  .timer 1 0 xdid -v $dname 5 $calc($hget(ftpc,div3) + 30)
  xdid -v $dname 6 $hget(ftpc,div2)
  xdid -v $dname 7 $hget(ftpc,div1)
  xdid -v $dname 1 26
  xdid -v $dname 10 28
  xdid -v $dname 11 28
  xdialog -a $dname +b 200
  xdialog -l $dname update
  .timer 1 0 xdialog -S $dname $hget(ftpc,xpos) $hget(ftpc,ypos) $hget(ftpc,width) $hget(ftpc,height)
  if ($hget(ftpc,dataconn) == 1) {
    xdid -q ftpclient 4 13 Change to PORT mode
    xdid -t ftpclient 4 13 +x
  }
  if ($hget(ftpc,dataconn) == 0) {
    xdid -q ftpclient 4 13 Change to PASV mode
  }
  .timer -m 1 100 sizeupdate
}

alias sizeupdate {
  tokenize 32 $xdid(ftpclient,9).dpos
  xdid -p ftpclient 21 0 0 $3 $calc($4 - 22)
  tokenize 32 $xdid(ftpclient,8).dpos
  xdid -p ftpclient 22 0 0 $3 $calc($4 - 22)
  xdialog -j ftpclient 12
}

alias ftpc_events {
  if ($2 == sizing) && ($istok(0.8.9,$3,46)) && (!%init) {
    sizeupdate
  }
  if ($2 == rclick) {
    if ($3 == 13) {
      homepopup $xdid(ftpclient,13).seltext
    }
    else if ($3 == 20) {
      var %files = 1
      if ($left($xdid(ftpclient,20,3).seltext,1) != d) {
        remotefilepopup $xdid(ftpclient,20,0).sel
      }
      else {
        remotedirpopup $xdid(ftpclient,20,1).seltext
      }
    }
    else if ($3 == 22) {
      var %item = $xdid(ftpclient,22,2).seltext
      if (%item) {
        queueremitempopup %item
      }
      else {
        queuepopup
      }
    }
  }
  if ($2 == sclick) {
    if ($3 == 15) {
      if ($4 == 1) {
        localfavspopup
      }
      if ($4 == 2) {
        if ($hget(ftpc,currentdir)) {
          var %m = $numtok($hget(ftpc,currentdir),47)
          if (%m > 1) {
            hadd ftpc currentdir $gettok($hget(ftpc,currentdir),$+(1-,$calc(%m - 1)),47) $+ /
            xdid -a ftpclient 16 -1 0 0 0 0 $hget(ftpc,currentdir)
            listfiles $hget(ftpc,currentdir)
          }
          else {
            hadd ftpc currentdir /
            xdid -a ftpclient 16 -1 0 0 0 0 $hget(ftpc,currentdir)
            listdisks
          }
        }
      }
    }
    else if ($3 == 18) {
      if ($4 == 1) {
        remotefavspopup
      }
      if ($4 == 2) {
        if ($sock(ftp.ctrl)) {
          var %response = CDUP
          ftpctrllog < %response    
          sockwrite -n ftp.ctrl %response
        }
      }
    }
    else if ($3 == 4) {
      if ($4 == 1) {
        if ($hget(ftpc,connected) == 0) {
          ftpcpop
        }
        else {
          ftpcdisconnect
        }
      }
      else if ($4 == 3) {
        ftpcsetup
      }
      else if ($4 == 4) {
        ftpcsitemgr
      }
      else if ($4 == 6) {
        hadd ftpc tray 1
        xdialog -h ftpclient
        xtray -c 1 + 0 $scriptdir $+ libraries\icons\ftpc.ico $chr(9) NXG FTP Client
      }
      else if ($4 == 8) {
        ftpcsendmsg
      }
      else if ($4 == 10) {
        dotransfer
      }
      else if ($4 == 11) {
        canceltransfer
      }
      else if ($4 == 13) {
        togglemode
      }
      else if ($4 == 15) {
        ftpcfileexists
      }
    }
  }
  if ($2 == dclick) {
    if ($3 == 13) {
      var %sel = $xdid(ftpclient,13).seltext, %drive, %dir = $xdid(ftpclient,16,0).text $+ / $+ %sel
      %dir = $replace(%dir,//,/)
      if ($isdir(%dir)) {
        xdid -a ftpclient 16 -1 0 0 0 0 %dir
        listfiles %dir
      }
      else if ($isfile(%dir)) {
        homequeue
      }
      else {
        %drive = $remove($gettok($gettok(%sel,1,9),$numtok($gettok(%sel,1,9),32),32),$chr(40),$chr(41))
        if ($isdir(%drive)) {
          xdid -a ftpclient 16 -1 0 0 0 0 %drive
        }
        listfiles %drive
      }
    }
    else if ($3 == 20) {
      var %type = $xdid(ftpclient,20,3).seltext
      var %sel = $xdid(ftpclient,20,1).seltext
      if ($left(%type,1) == d) {
        hadd ftpc command CWD
        var %response = CWD %sel
        ftpctrllog < %response    
        sockwrite -n ftp.ctrl %response
      }
    }
  }
  if ($2 == close) {
    .timerftpc off
    .timer 1 0 window -c @ftpclog
    tokenize 32 $xdid(ftpclient,13).dpos
    hadd ftpc div1 $3
    hadd ftpc div3 $4
    tokenize 32 $xdid(ftpclient,8).dpos
    hadd ftpc div2 $3
    hadd ftpc xpos $dialog(ftpclient).x
    hadd ftpc ypos $dialog(ftpclient).y
    hadd ftpc width $dialog(ftpclient).cw
    hadd ftpc height $dialog(ftpclient).ch
    hadd ftpc connected 0
    sockclose ftp.ctrl
    hadd ftpc col1 $xdid(ftpclient,13).hwidth
    hadd ftpc col2 $xdid(ftpclient,20).hwidth
    hadd ftpc col3 $xdid(ftpclient,22).hwidth
    savesettings
  }
}

alias togglemode {
  if ($hget(ftpc,dataconn) == 0) {
    hadd ftpc dataconn 1
    xdid -q ftpclient 4 13 Change to PORT mode
  }
  else {
    hadd ftpc dataconn 0
    xdid -q ftpclient 4 13 Change to PASV mode
  }
}

alias remotefavspopup {
  popups New remotefavspop 16 16
  popups SetMetrics remotefavspop iconpad 0 0 contentpad 0 0 spacing 1 0
  var %axx = $sorttok($hget(ftpc,axx),96)
  var %a = $numtok(%axx,96), %l = 1
  while (%l <= %a) {
    var %acc = $gettok(%axx,%l,96)
    popups AddItem remotefavspop end + %acc $cr ftpcconnect $hget(ftpc,%acc) %acc
    inc %l
  }
  popup remotefavspop $mouse.dx $mouse.dy
}

alias localfavspopup {
  popups New localfavspop 16 16
  popups SetMetrics localfavspop iconpad 0 0 contentpad 0 0 spacing 1 0
  var %favs = $sorttok($hget(ftpc,favs),96)
  var %f = $numtok(%favs,96), %l = 1
  while (%l <= %f) {
    var %fav = $gettok(%favs,%l,96)
    popups AddItem localfavspop end + %fav $cr listfiles %fav
    inc %l
  }
  popups AddItem localfavspop end +
  popups AddItem localfavspop end + Add to Favourites... $cr addlocalfav
  popups AddItem localfavspop end +
  popups AddItem localfavspop end + Clear Favourites $cr clearlocalfavs
  popup localfavspop $mouse.dx $mouse.dy
}

alias clearlocalfavs {
  hadd ftpc favs $null
}

alias addlocalfav {
  if ($xdid(ftpclient,16,0).text != /) {
    hadd ftpc favs $addtok($hget(ftpc,favs),$xdid(ftpclient,16,0).text,96)
  }
}

alias homepopup {
  popups New homepop 16 16
  popups SetMetrics homepop iconpad 0 0 contentpad 0 0 spacing 1 0
  if ($isfile($replace($xdid(ftpclient,16,0).text $+ / $+ $1-,//,/))) {
    popups AddItem homepop end + Add to Queue $cr homequeue
    popups AddItem homepop end + Upload $qt($1-) $cr uploadfile $1-
    popups AddItem homepop end +
    popups AddItem homepop end + Open $qt($1-) $cr openfile $1-
    popups AddItem homepop end + Delete $qt($1-) $cr deletefile $1-
    popup homepop $mouse.dx $mouse.dy
  }
  else if ($1-) && ($isdir($replace($xdid(ftpclient,16,0).text $+ / $+ $1-,//,/))) {
    popups AddItem homepop end + Explore $qt($1-) $cr openfolder $1-
    popup homepop $mouse.dx $mouse.dy
  }  
}

alias remotefilepopup {
  popups New remotepop 16 16
  popups SetMetrics remotepop iconpad 0 0 contentpad 0 0 spacing 1 0
  if ($xdid(ftpclient,20,1).seltext) {
    popups AddItem remotepop end + Add to Queue $cr remotequeue $1-
    popups AddItem remotepop end + Transfer $qt($xdid(ftpclient,20,1).seltext) $cr transferfile
    popups AddItem remotepop end + 
    popups AddItem remotepop end + Delete File(s)... $cr deleteremotefiles
    popup remotepop $mouse.dx $mouse.dy
  }
  else {
    if ($sock(ftp.ctrl)) {
      popups AddItem remotepop end + Make Dir $cr makeremotedir
      popup remotepop $mouse.dx $mouse.dy
    }
  }
}

alias remotedirpopup {
  popups New remotepop 16 16
  popups SetMetrics remotepop iconpad 0 0 contentpad 0 0 spacing 1 0
  if ($xdid(ftpclient,20,1).seltext) {
    popups AddItem remotepop end + Delete Folder $cr deleteremotedir $1-
    popup remotepop $mouse.dx $mouse.dy
  }
}

alias deleteremotefiles {
  var %d = $input(Do you wish to delete selected files?,yuq,Query...)
  if (%d) {
    var %c = 1
    tokenize 44 $xdid(ftpclient,20).sel
    while (%c <= $0) {
      var %files = %files $+ * $+ $xdid(ftpclient,20,$($ $+ %c,2)).text
      inc %c
    }
    var %l = 1
    while (%l <= $numtok(%files,42)) {
      var %response = DELE $gettok(%files,%l,42)
      ftpctrllog < %response    
      sockwrite -n ftp.ctrl %response
      inc %l
    }
  }
}

alias makeremotedir {
  var %d = $input(Please enter a name for the folder you wish to create,euq,Query...)
  if (%d) {
    var %response = MKD %d
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
    inc %l
  }
}

alias deleteremotedir {
  var %response = RMD $1-
  ftpctrllog < %response    
  sockwrite -n ftp.ctrl %response
}

alias queueremitempopup {
  popups New queueripop 16 16
  popups SetMetrics queueripop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem queueripop end + Remove $qt($1-) from Queue $cr delqueueitem $1-
  popup queueripop $mouse.dx $mouse.dy
}

alias queuepopup {
  popups New queuepop 16 16
  popups SetMetrics queuepop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem queuepop end + Clear Queue $cr clearqueue
  popup queuepop $mouse.dx $mouse.dy
}

alias uploadfile {
  homequeue
  dotransfer
}

alias transferfile {
  remotequeue
  dotransfer
}

alias openfile {
  .run $replace($xdid(ftpclient,16,0).text $+ / $+ $1-,//,/)
}

alias openfolder {
  .run $replace($xdid(ftpclient,16,0).text $+ / $+ $1-,//,/)
}

alias deletefile {
  .remove $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $1-,//,/),")
  listfiles $hget(ftpc,currentdir)
}

alias delqueueitem {
  xdid -d ftpclient 22 $xdid(ftpclient,22).sel
}

alias clearqueue {
  xdid -r ftpclient 22
}

alias homequeue {
  xdid -a ftpclient 22 0 0 + 5 0 0 0 0 0 U/L $chr(9) + 0 -1 0 0 $replace($xdid(ftpclient,16,0).text $+ / $+ $xdid(ftpclient,13,1).seltext,//,/) $chr(9) + 0 -1 0 0 $xdid(ftpclient,13,2).seltext
}

alias remotequeue {
  var %c = 1
  tokenize 44 $xdid(ftpclient,20).sel
  while (%c <= $0) {
    xdid -a ftpclient 22 0 0 + 5 0 0 0 0 0 D/L $chr(9) + 0 -1 0 0 $xdid(ftpclient,20,$($ $+ %c,2),1).text $chr(9) + 0 -1 0 0 $xdid(ftpclient,20,$($ $+ %c,2),2).text
    inc %c
  }
}

alias canceltransfer {
  if ($hget(ftpc,connected) == 1) {
    sockclose ftp.data
    sockclose ftpdata
    var %response = ABOR
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
    hadd ftpc action Listing
    .timer 1 0 dolist
  }
}

alias dolist {
  if ($hget(ftpc,dataconn) == 0) {
    var %port = $rand($hget(ftpc,portstart),$hget(ftpc,portend))
    var %response = PORT $replace($hget(ftpc,portip),$chr(46),$chr(44)) $+ , $+ $replace($fromport(%port),$chr(46),$chr(44))
    sockclose ftp.data
    socklisten ftp.data %port
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
  }
  else if ($hget(ftpc,dataconn) == 1) {
    var %response = PASV
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
  }        
  hadd ftpc action Listing
}

alias -l listdisks {
  xdid -r ftpclient 13
  var %d = 1, %type, %label, %tmp, %size, %free
  while (%d <= $disk(0)) {
    %type = $disk(%d).type
    %label = $disk(%d).label
    %size = $disk(%d).size
    %free = $disk(%d).free
    if (%type == removable) {
      xdid -a ftpclient 13 0 0 + 1 0 0 0 0 0 $iif(%label,%label $+($chr(40),$disk(%d).path,$chr(41)),Floppy $+($chr(40),$disk(%).path,$chr(41)))
    }
    if (%type == fixed) {
      xdid -a ftpclient 13 0 0 + 2 0 0 0 0 0 $iif(%label,%label $+($chr(40),$replace($disk(%d).path,\,/),$chr(41)),$+($chr(40),$disk(%d).path,$chr(41))) $chr(9) + 0 -1 0 0 $bytes(%size).suf
    }
    if (%type == remote) {
      xdid -a ftpclient 13 0 0 + 3 0 0 0 0 0 $gettok($disk(%d).unc,2,92) $+($chr(40),$replace($disk(%d).path,\,/),$chr(41)) $chr(9) + 0 -1 0 0 $bytes(%size).suf
    }
    if (%type == cdrom) {
      xdid -a ftpclient 13 0 0 + 4 0 0 0 0 0 $iif(%label,%label $+($chr(40),$replace($disk(%d).path,\,/),$chr(41)),CDROM $+($chr(40),$replace($disk(%d).path,\,/),$chr(41))) $chr(9) + 0 -1 0 0 $bytes(%size).suf
    }
    inc %d
  }
}

alias listfiles {
  xdid -a ftpclient 16 -1 0 0 0 0 $1-
  window -lsh @listdirs
  window -lsh @listfiles
  xdid -r ftpclient 13
  hadd ftpc currentdir $1-
  var %dir = $1-, %entry
  noop $finddir(%dir,*.*,0,1,aline @listdirs $1-)
  var %l = 1
  while (%l <= $line(@listdirs,0)) {
    %entry = $line(@listdirs,%l)
    if ($isdir(%entry)) {
      xdid -a ftpclient 13 0 0 + 6 0 0 0 0 0 $nopath(%entry)
    }
    inc %l
  }
  noop $findfile(%dir,*.*,0,1,aline @listfiles $1-)
  var %l = 1
  while (%l <= $line(@listfiles,0)) {
    %entry = $line(@listfiles,%l)
    if ($isfile(%entry)) {
      if ($right(%entry,4) == .zip) {
        var %icon = 7
      }
      else if ($right(%entry,4) == .rar) {
        var %icon = 8
      }
      else if (.r* iswm $right(%entry,4)) && ($right(%entry,2) isnum) {
        var %icon = 8
      }
      else if ($right(%entry,4) == .tar) {
        var %icon = 8
      }
      else if ($right(%entry,4) == .txt) {
        var %icon = 9
      }
      else if ($right(%entry,4) == .bat) {
        var %icon = 10
      }
      else if ($right(%entry,4) == .exe) {
        var %icon = 11
      }
      else if ($right(%entry,4) == .gif) {
        var %icon = 12
      }
      else if ($right(%entry,4) == .htm) {
        var %icon = 14
      }
      else if ($right(%entry,4) == .jpg) {
        var %icon = 13
      }
      else if ($right(%entry,4) == .bmp) {
        var %icon = 15
      }
      else if ($right(%entry,4) == .pdf) {
        var %icon = 16
      }
      else if ($right(%entry,4) == .wav) {
        var %icon = 17
      }
      else if ($right(%entry,4) == .m3u) {
        var %icon = 17
      }
      else if ($right(%entry,4) == .mp3) {
        var %icon = 18
      }
      else if ($right(%entry,4) == .mov) {
        var %icon = 19
      }
      else if ($right(%entry,4) == .mpg) {
        var %icon = 19
      }
      else if ($right(%entry,4) == .avi) {
        var %icon = 19
      }
      else if ($right(%entry,4) == .flv) {
        var %icon = 19
      }
      else if ($right(%entry,4) == .wmv) {
        var %icon = 19
      }
      else if ($right(%entry,4) == .doc) {
        var %icon = 20
      }
      else if ($right(%entry,5) == .docx) {
        var %icon = 20
      }
      else if ($right(%entry,4) == .xls) {
        var %icon = 21
      }
      else if ($right(%entry,5) == .xlsx) {
        var %icon = 21
      }
      else if ($right(%entry,4) == .ppt) {
        var %icon = 22
      }
      else if ($right(%entry,5) == .pptx) {
        var %icon = 22
      }
      else if ($right(%entry,4) == .pps) {
        var %icon = 22
      }
      else if ($right(%entry,5) == .ppsx) {
        var %icon = 22
      }
      else {
        var %icon = 5
      }
      xdid -a ftpclient 13 0 0 + %icon 0 0 0 0 0 $nopath(%entry) $chr(9) + 0 -1 0 0 $bytes($file(%entry).size).suf
    }    
    inc %l
  }
  window -c @listdirs
  window -c @listfiles
}

alias dotransfer {
  if ($hget(ftpc,connected) == 1) && ($hget(ftpc,action) != Downloading) {
    if ($xdid(ftpclient,22).num) {
      if ($xdid(ftpclient,22,1,1).text == U/L) {
        upload $xdid(ftpclient,22,1,2).text
      }
      else if ($xdid(ftpclient,22,1,1).text == D/L) {
        download $xdid(ftpclient,22,1,2).text
      }
    }
  }
}

alias -l download {
  xdid -d ftpclient 22 1
  hadd ftpc currentfile $1-
  var %response = TYPE I
  ftpctrllog < %response
  sockwrite -n ftp.ctrl %response
  hadd ftpc action Downloading
}

alias -l upload {
  xdid -d ftpclient 22 1
  hadd ftpc currentfile $1-
  hadd ftpc filesize $file($1-).size
  var %file = $nopath($1-), %l = 1, %size = 0
  while (%l <= $line(@filesizes,0)) {
    tokenize 32 $line(@filesizes,%l)
    if (%file == $2-) {
      var %size = $1
      hadd ftpc sentbytes $1
    }
    inc %l
  }
  if (%size == 0) {
    ;---DOSEN'T EXIST---
    hadd ftpc action Uploading
    var %response = TYPE I
    ftpctrllog < %response
    sockwrite -n ftp.ctrl %response
  }
  else if (%size > 0) && (%size < $hget(ftpc,filesize)) {
    ;---SMALLER THAN DESTINATION---
    var %action = $hget(ftpc,upsmaller)
    if (%action == 1) {
      ;---SKIP---
      ftpctrllog Skipping $nopath($hget(ftpc,currentfile))
      hadd ftpc action Idle
      dotransfer
      halt
    }
    else if (%action == 2) {
      ;---RESUME---
      hadd ftpc action Resuming U/L
      hadd ftpc size %size
      var %response = TYPE I
      ftpctrllog < %response
      sockwrite -n ftp.ctrl %response
      dotransfer
    }
    else if (%action == 3) {
      ;---OVERWRITE---
      hadd ftpc action Uploading
      hadd ftpc size 0
      var %response = TYPE I
      ftpctrllog < %response
      sockwrite -n ftp.ctrl %response
      dotransfer
    }
  }
  else if (%size == $hget(ftpc,filesize)) {
    ;---SAME SIZE---
    var %action = $hget(ftpc,upsame)
    if (%action == 1) {
      ;---SKIP---
      ftpctrllog Skipping $nopath($hget(ftpc,currentfile))
      hadd ftpc action Idle
      dotransfer
      halt
    }
    else if (%action == 2) {
      ;---OVERWRITE---
      hadd ftpc action Uploading
      ;hadd ftpc filesize 0
      var %response = TYPE I
      ftpctrllog < %response
      sockwrite -n ftp.ctrl %response
      dotransfer
    }
  }
  else if (%size > $hget(ftpc,filesize)) {
    ;---FILE LARGER---
    var %action = $hget(ftpc,uplarger)
    if (%action == 1) {
      ;---SKIP---
      ftpctrllog Skipping $nopath($hget(ftpc,currentfile))
      hadd ftpc action Idle
      dotransfer
      halt
    }
    else if (%action == 2) {
      ;---OVERWRITE---
      hadd ftpc action Uploading
      ;hadd ftpc size 0
      var %response = TYPE I
      ftpctrllog < %response
      sockwrite -n ftp.ctrl %response
      dotransfer
    }
  }
}

alias ftpcconnect {
  hadd ftpc connected 1
  updatetoolbar
  sockclose ftp.ctrl
  var %user = $gettok($gettok($1,1,64),1,58)
  var %pass = $replace($gettok($gettok($1,1,64),2,58),;,@)
  var %addr = $gettok($gettok($1,2,64),1,58)
  var %port = $gettok($gettok($1,2,64),2,58)
  hadd ftpc currentuser %user
  hadd ftpc currentpass %pass
  sockopen ftp.ctrl %addr %port
  dialog -t ftpclient FTP Client - Connecting to %addr
  hadd ftpc recent $+(%user,:,$replace(%pass,@,;),@,%addr,:,%port)
}

alias ftpcdisconnect {
  hadd ftpc connected 0
  updatetoolbar
  var %response = QUIT
  ftpctrllog < %response    
  if ($sock(ftp.ctrl)) {
    sockwrite -n ftp.ctrl %response
  }
  hadd ftpc connected 0
  xdid -r ftpclient 20
  hadd ftpc action Idle
}

alias ftpctrllog {
  if ($dialog(ftpclient)) {
    aline -p @ftpclog $1-
  }
}

alias ftpcsendmsg {
  if ($hget(ftpc,connected) == 1) {
    var %msg = $input(Enter Message...,eoqu,Input Request,$null)
    ftpctrllog < SITE %msg
    sockwrite -n ftp.ctrl SITE %msg
  }
}

;---SOCKET STUFF---

on *:sockopen:ftp.ctrl: {
  if ($sockerr) {
    var %response = Unable to connect to $sock(ftp.ctrl).ip
    ftpctrllog %response
    dialog -t ftpclient FTP Client
    return
  }
  ftpctrllog Connected to $sock($sockname).ip
  dialog -t ftpclient FTP Client - Connected to $sock(ftp.ctrl).ip
}

on *:sockread:ftp.ctrl:{
  if ($sockerr > 0) return
  :loop
  sockread %com
  if ($sockbr == 0) return
  if (%com == $null) %com = -
  tokenize 32 %com
  unset %com
  ftpctrllog > $1-
  if ($1 == 220) {
    var %response = USER $hget(ftpc,currentuser)
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 331) {
    var %response = PASS $hget(ftpc,currentpass)
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 230) {
    var %response = SYST
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 215) {
    var %response = REST 0
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 350) {
    if ($hget(ftpc,action) == Resuming D/L) {
      var %response = RETR $hget(ftpc,currentfile)
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
    else if ($hget(ftpc,action) == Downloading) {
      var %response = RETR $hget(ftpc,currentfile)
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
    else if ($hget(ftpc,action) == Resuming U/L) {
      var %response = STOR $nopath($hget(ftpc,currentfile))
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
    else {
      var %response = PWD
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
  }
  if ($1 == 257) {
    var %response = TYPE A
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 200) && ($2 == Type) {
    if (A* iswm $5) {
      if ($hget(ftpc,dataconn) == 0) {
        var %port = $rand($hget(ftpc,portstart),$hget(ftpc,portend))
        var %response = PORT $replace($hget(ftpc,portip),$chr(46),$chr(44)) $+ , $+ $replace($fromport(%port),$chr(46),$chr(44))
        sockclose ftp.data
        socklisten ftp.data %port
        ftpctrllog < %response    
        sockwrite -n $sockname %response
      }
      else if ($hget(ftpc,dataconn) == 1) {
        var %response = PASV
        ftpctrllog < %response    
        sockwrite -n $sockname %response
      }
    }
    else if (I* iswm $5) {
      if ($hget(ftpc,action) == Downloading) {
        var %response = SIZE $hget(ftpc,currentfile)
        ftpctrllog < %response    
        sockwrite -n $sockname %response
      }
      else if ($hget(ftpc,action) == Uploading) {
        if ($hget(ftpc,dataconn) == 0) {
          var %port = $rand($hget(ftpc,portstart),$hget(ftpc,portend))
          var %response = PORT $replace($hget(ftpc,portip),$chr(46),$chr(44)) $+ , $+ $replace($fromport(%port),$chr(46),$chr(44))
          sockclose ftp.data
          socklisten ftp.data %port
          ftpctrllog < %response    
          sockwrite -n $sockname %response
        }
        else if ($hget(ftpc,dataconn) == 1) {
          var %response = PASV
          ftpctrllog < %response    
          sockwrite -n $sockname %response
        }
      }
      else if ($hget(ftpc,action) == Resuming U/L) {
        if ($hget(ftpc,dataconn) == 0) {
          var %port = $rand($hget(ftpc,portstart),$hget(ftpc,portend))
          var %response = PORT $replace($hget(ftpc,portip),$chr(46),$chr(44)) $+ , $+ $replace($fromport(%port),$chr(46),$chr(44))
          sockclose ftp.data
          socklisten ftp.data %port
          ftpctrllog < %response    
          sockwrite -n $sockname %response
        }
        else if ($hget(ftpc,dataconn) == 1) {
          var %response = PASV
          ftpctrllog < %response    
          sockwrite -n $sockname %response
        }        
      }    
    }
  }
  if ($1 == 200) && ($2 == Port) {
    if ($hget(ftpc,action) == Downloading) {
      var %response = RETR $hget(ftpc,currentfile)
    }
    else if ($hget(ftpc,action) == Resuming D/L) {
      var %file = $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),"))
      var %response = REST $file(%file).size
    }
    else if ($hget(ftpc,action) == Uploading) {
      var %response = STOR $nopath($hget(ftpc,currentfile))
      .timer 1 1 ftpupload $hget(ftpc,currentfile)
    }
    else if ($hget(ftpc,action) == Resuming U/L) {
      var %response = REST $hget(ftpc,size)
      .timer 1 1 ftpupload $hget(ftpc,currentfile)
    }
    else {
      var %response = LIST -al
      hadd ftpc action Listing
    }
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 227) && ($3 == Passive) {
    if ($hget(ftpc,action) == Downloading) {
      var %response = RETR $hget(ftpc,currentfile)
    }
    else if ($hget(ftpc,action) == Resuming D/L) {
      var %file = $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),"))
      var %response = REST $file(%file).size
    }
    else if ($hget(ftpc,action) == Uploading) {
      var %response = STOR $nopath($hget(ftpc,currentfile))
      ftpupload $hget(ftpc,currentfile)
    }
    else if ($hget(ftpc,action) == Resuming U/L) {
      var %response = REST $hget(ftpc,size)
      .timer 1 1 ftpupload $hget(ftpc,currentfile)
    }
    else {
      var %response = LIST -al
      hadd ftpc action Listing
    }
    sockclose ftp.data
    tokenize 44 $remove($5,$chr(40),$chr(41),$chr(46))
    var %ip = $+($1,.,$2,.,$3,.,$4)
    var %port = $toport($5 $+ . $+ $6)
    sockopen ftp.data %ip %port
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 250)  {
    var %response = PWD
    ftpctrllog < %response    
    sockwrite -n $sockname %response
  }
  if ($1 == 213)  {
    hadd ftpc filesize $2
    var %file = $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),"))
    if ($isfile(%file)) {
      if ($file(%file).size < $hget(ftpc,filesize)) {
        ;---SMALLER---
        var %action = $hget(ftpc,downsmaller)
        if (%action == 1) {
          ;---SKIP---
          ftpctrllog Skipping $nopath(%file)
          hadd ftpc action Idle
          dotransfer
          halt
        }
        if (%action == 2) {
          ;---RESUME---
          ftpctrllog Resuming D/L $nopath(%file)
          hadd ftpc filegot $file(%file).size
          hadd ftpc action Resuming D/L
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
        if (%action == 3) {
          ;---OVERWRITE---
          ftpctrllog Overwriting $nopath(%file)
          .remove %file
          hadd ftpc filegot 0
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
        if (%action == 4) {
          ;---RENAME---
          ftpctrllog Renaming Existing $nopath(%file)
          .rename %file " $+ $nofile(%file) $+ Copy of $nopath(%file) $+ "
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
      }
      if ($file(%file).size == $hget(ftpc,filesize)) {
        ;---SAME---
        var %action = $hget(ftpc,downsame)
        if (%action == 1) {
          ;---SKIP---
          ftpctrllog Skipping $nopath(%file)
          hadd ftpc action Idle
          dotransfer
          halt
        }
        if (%action == 2) {
          ;---OVERWRITE---
          ftpctrllog Overwriting $nopath(%file)
          .remove %file
          hadd ftpc filegot 0
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
        if (%action == 3) {
          ;---RENAME---
          ftpctrllog Renaming Existing $nopath(%file)
          .rename %file " $+ $nofile(%file) $+ Copy of $nopath(%file) $+ "
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
      }
      if ($file(%file).size > $hget(ftpc,filesize)) {
        ;---LARGER---
        var %action = $hget(ftpc,downlarger)
        if (%action == 1) {
          ;---SKIP---
          ftpctrllog Skipping $nopath(%file)
          hadd ftpc action Idle
          dotransfer
          halt
        }
        if (%action == 2) {
          ;---OVERWRITE---
          ftpctrllog Overwriting $nopath(%file)
          .remove %file
          hadd ftpc filegot 0
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
        if (%action == 3) {
          ;---RENAME---
          ftpctrllog Renaming Existing $nopath(%file)
          .rename %file " $+ $nofile(%file) $+ Copy of $nopath(%file) $+ "
          hadd ftpc action Downloading
          var %response = PASV
          ftpctrllog < %response
          sockwrite -n $sockname %response
          return
        }
      }
    }
    if ($hget(ftpc,dataconn) == 0) {
      var %port = $rand($hget(ftpc,portstart),$hget(ftpc,portend))
      var %response = PORT $replace($hget(ftpc,portip),$chr(46),$chr(44)) $+ , $+ $replace($fromport(%port),$chr(46),$chr(44))
      sockclose ftp.data
      socklisten ftp.data %port
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
    else if ($hget(ftpc,dataconn) == 1) {
      var %response = PASV
      ftpctrllog < %response    
      sockwrite -n $sockname %response
    }
  }
}

on *:sockopen:ftp.data: {
  window -lhs @ftpdir
}

on *:sockread:ftp.data: {
  if ($sockerr > 0) return
  if ($hget(ftpc,action) == Listing) {
    :loop0
    sockread %data
    if ($sockbr == 0) goto end1
    if (%data == $null) %data = -
    aline @ftpdir %data
    unset %data
    goto loop0
  }
  if ($hget(ftpc,action) == Downloading) {
    :loop1
    sockread &data
    if ($sockbr == 0) goto end1
    if (%data == $null) %data = -
    bwrite $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),") -1 16384 &data
    unset &data
    goto loop1
  }
  if ($hget(ftpc,action) == Resuming D/L) {
    :loop2
    sockread &data
    if ($sockbr == 0) goto end1
    if (%data == $null) %data = -
    bwrite $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),") -1 16384 &data
    unset &data
    goto loop2
  }
  :end1
}

on *:sockclose:ftp.ctrl: {
  xdid -r ftpclient 20
  dialog -t ftpclient FTP Client
  hadd ftpc connected 0
  updatetoolbar
}

on *:sockclose:ftp.data: {
  if ($hget(ftpc,action) == Downloading) {
    sockwrite -n ftp.ctrl TYPE A
    xdid -r ftpclient 20
    showdir
    window -c @ftpdir
    hadd ftpc action Idle
    dotransfer
    amountdl $hget(ftpc,filesize)
    listfiles $hget(ftpc,currentdir)
  }
  else if ($hget(ftpc,action) == Resuming D/L) {
    sockwrite -n ftp.ctrl TYPE A
    xdid -r ftpclient 20
    showdir
    window -c @ftpdir
    hadd ftpc action Idle
    dotransfer
    listfiles $hget(ftpc,currentdir)
  }
  else if ($hget(ftpc,action) == Listing) {
    xdid -r ftpclient 20
    showdir
    if ($window(@filesizes)) {
      window -c @filesizes
    }
    window -lh @filesizes
    var %f = 1
    while (%f <= $line(@ftpdir,0)) {
      tokenize 32 $line(@ftpdir,%f)
      if ($left($1,1) == -) && ($5) {
        aline @filesizes $5 $9-
      }
      inc %f
    }
    window -c @ftpdir
    hadd ftpc action Idle
    dotransfer
    listfiles $hget(ftpc,currentdir)
  }
  hadd ftpc sentbytes 0
}

on *:socklisten:ftp.data: {
  hadd ftpc dataport ftpdata
  sockaccept $hget(ftpc,dataport)
  window -lhs @ftpdir
}

on *:sockread:ftpdata:{
  if ($sockerr > 0) return
  if ($hget(ftpc,action) == Listing) {
    :loop4
    sockread %data
    if ($sockbr == 0) goto end2
    if (%data == $null) %data = -
    aline @ftpdir %data
    unset %data
    goto loop4
  }
  if ($hget(ftpc,action) == Downloading) {
    :loop3
    sockread &data
    if ($sockbr == 0) goto end2
    if (%data == $null) %data = -
    bwrite $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),") -1 16384 &data
    unset &data
    goto loop3
  }
  if ($hget(ftpc,action) == Resuming D/L) {
    :loop5
    sockread &data
    if ($sockbr == 0) goto end2
    if (%data == $null) %data = -
    bwrite $+(",$replace($xdid(ftpclient,16,0).text $+ / $+ $hget(ftpc,currentfile),//,/),") -1 16384 &data
    unset &data
    goto loop5
  }
  :end2
}

on *:sockclose:ftpdata: {
  if ($hget(ftpc,action) == Downloading) {
    sockwrite -n ftp.ctrl TYPE A
    var %response = LIST -al
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
    hadd ftpc action Listing
    dotransfer
    amountdl $hget(ftpc,filesize)
    listfiles $hget(ftpc,currentdir)
  }
  else if ($hget(ftpc,action) == Resuming D/L) {
    sockwrite -n ftp.ctrl TYPE A
    var %response = LIST -al
    ftpctrllog < %response    
    sockwrite -n ftp.ctrl %response
    hadd ftpc action Listing
    dotransfer
    listfiles $hget(ftpc,currentdir)
  }
  else if ($hget(ftpc,action) == Listing) {
    xdid -r ftpclient 20
    showdir
    if ($window(@filesizes)) {
      window -c @filesizes
    }
    window -lh @filesizes
    var %f = 1
    while (%f <= $line(@ftpdir,0)) {
      tokenize 32 $line(@ftpdir,%f)
      if ($left($1,1) == -) && ($5) {
        aline @filesizes $5 $9-
      }
      inc %f
    }
    window -c @ftpdir
    hadd ftpc action Idle
    dotransfer
    listfiles $hget(ftpc,currentdir)
  }
  hadd ftpc sentbytes 0
}

on *:sockwrite:ftpdata:{
  if ($hget(ftpc,action) == Uploading) || ($hget(ftpc,action) == Resuming U/L) {
    .timer 1 0 ftpupload $hget(ftpc,currentfile)
  }
}

on *:sockwrite:ftp.data:{
  if ($hget(ftpc,action) == Uploading) || ($hget(ftpc,action) == Resuming U/L) {
    .timer 1 0 ftpupload $hget(ftpc,currentfile)
  }
}

alias onsockclose {
  sockwrite -n ftp.ctrl TYPE A
  xdid -r ftpclient 20
  showdir
  window -c @ftpdir
  hadd ftpc action Idle
  .timer 1 1 dotransfer
}

alias ftpupload {
  if ($sock(ftpdata)) {
    var %datasock = ftpdata
  }
  else {
    var %datasock = ftp.data
  }
  if ($hget(ftpc,sentbytes) == $hget(ftpc,filesize) && (!$sock(%datasock).mark)) {
    if ($hget(ftpc,upsame) == 2) {
      sockmark %datasock 0
    }
  }    
  else if ($hget(ftpc,sentbytes) > 0) && (!$sock(%datasock).mark) {
    sockmark %datasock $hget(ftpc,sentbytes)
  }
  var %cf = $file($1-).size
  hadd ftpc size %cf
  if ($sock(%datasock).mark >= %cf) {
    sockclose %datasock
    onsockclose
    amountul %cf
    goto endftp
  }
  bread " $+ $1- $+ " 0 $+ $sock(%datasock).mark 16384 &data
  sockwrite -b %datasock 16384 &data
  sockmark %datasock $calc($sock(%datasock).mark + 16384)
  :endftp
}

alias showdir {
  var %l = 1
  window -lhs @ftp.dirs
  window -lhs @ftp.files
  while (%l <= $line(@ftpdir,0)) {
    tokenize 32 $line(@ftpdir,%l)
    if ($left($1,1) == d) {
      if ($9- != .) && ($9- != ..) {
        aline @ftp.dirs $9- $+ : $+ $5 $+ : $+ $1
      }
    }
    else {
      aline @ftp.files $9- $+ : $+ $5 $+ : $+ $1
    }
    inc %l
  }
  var %l = 1
  while (%l <= $line(@ftp.dirs,0)) {
    xdid -a ftpclient 20 0 0 + 2 0 0 0 0 0 $nopath($gettok($line(@ftp.dirs,%l),1,58)) $chr(9) + 0 -1 0 0 $null $chr(9) + 0 -1 0 0 $gettok($line(@ftp.dirs,%l),3,58)
    inc %l
  }
  var %l = 1
  while (%l <= $line(@ftp.files,0)) {
    var %entry = $gettok($line(@ftp.files,%l),1,58)
    if ($right(%entry,4) == .zip) {
      var %icon = 3
    }
    else if ($right(%entry,4) == .rar) {
      var %icon = 4
    }
    else if (.r* iswm $right(%entry,4)) && ($right(%entry,2) isnum) {
      var %icon = 4
    }
    else if ($right(%entry,4) == .tar) {
      var %icon = 4
    }
    else if ($right(%entry,4) == .txt) {
      var %icon = 5
    }
    else if ($right(%entry,4) == .bat) {
      var %icon = 6
    }
    else if ($right(%entry,4) == .exe) {
      var %icon = 7
    }
    else if ($right(%entry,4) == .gif) {
      var %icon = 8
    }
    else if ($right(%entry,4) == .htm) {
      var %icon = 10
    }
    else if ($right(%entry,4) == .jpg) {
      var %icon = 9
    }
    else if ($right(%entry,4) == .bmp) {
      var %icon = 11
    }
    else if ($right(%entry,4) == .pdf) {
      var %icon = 12
    }
    else if ($right(%entry,4) == .wav) {
      var %icon = 13
    }
    else if ($right(%entry,4) == .m3u) {
      var %icon = 13
    }
    else if ($right(%entry,4) == .mp3) {
      var %icon = 14
    }
    else if ($right(%entry,4) == .wmv) {
      var %icon = 15
    }
    else if ($right(%entry,4) == .avi) {
      var %icon = 15
    }
    else if ($right(%entry,4) == .mpg) {
      var %icon = 15
    }
    else if ($right(%entry,4) == .flv) {
      var %icon = 15
    }
    else if ($right(%entry,4) == .mov) {
      var %icon = 15
    }
    else if ($right(%entry,4) == .doc) {
      var %icon = 16
    }
    else if ($right(%entry,5) == .docx) {
      var %icon = 16
    }
    else if ($right(%entry,4) == .xls) {
      var %icon = 17
    }
    else if ($right(%entry,5) == .xlsx) {
      var %icon = 17
    }
    else if ($right(%entry,4) == .ppt) {
      var %icon = 18
    }
    else if ($right(%entry,5) == .pptx) {
      var %icon = 18
    }
    else if ($right(%entry,4) == .pps) {
      var %icon = 18
    }
    else if ($right(%entry,5) == .ppsx) {
      var %icon = 18
    }
    else {
      var %icon = 1
    }
    xdid -a ftpclient 20 0 0 + %icon 0 0 0 0 0 $nopath(%entry) $chr(9) + 0 -1 0 0 $bytes($gettok($line(@ftp.files,%l),2,58)).suf $chr(9) + 0 -1 0 0 $gettok($line(@ftp.files,%l),3,58)
    inc %l
  }
  window -c @ftp.dirs
  window -c @ftp.files
}  

alias toport {
  return $longip($+(0.0.,$gettok($1,-2-,46)))
}

alias fromport {
  return $remove($longip($1),0.0.)
}

on *:signal:dcx:{
  if ($1 == trayicon) {
    if ($2 == sclick) {
      if ($3 == 1) {
        hadd ftpc tray 0
        xdialog -s ftpclient
        xtray -d 1
      }
    }
  }     
}

alias ftpcpop {
  popups New ftpcpop 16 16
  popups SetMetrics ftpcpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftpcpop end + Reconnect to $gettok($gettok($hget(ftpc,recent),2,64),1,58) $cr ftpcconnect $hget(ftpc,recent)
  popups AddItem ftpcpop end + 
  popups AddItem ftpcpop end + Quick Connect $cr newftpcconn
  popups AddItem ftpcpop end + 
  var %axx = $sorttok($hget(ftpc,axx),96)
  var %a = $numtok(%axx,96), %l = 1
  while (%l <= %a) {
    var %acc = $gettok(%axx,%l,96)
    popups AddItem ftpcpop end + %acc $cr ftpcconnect $hget(ftpc,%acc) %acc
    inc %l
  }
  popup ftpcpop $mouse.dx $mouse.dy
}

alias newftpcconn {
  noop $dialog(newftpcconn,newftpcconn,-4)
}

dialog newftpcconn {
  title "New FTP Connection"
  size -1 -1 269 294
  option pixels
  tab "Connection", 1, 4 72 260 190
  box "Site Details", 3, 13 98 242 149, tab 1
  text "Address:", 8, 28 124 54 16, tab 1 right
  text "Password:", 14, 28 210 54 16, tab 1 right
  edit "", 9, 84 120 152 23, tab 1
  edit "", 13, 84 149 152 23, tab 1
  edit "", 12, 84 177 152 23, tab 1
  edit "", 15, 84 206 152 23, tab 1
  text "Username:", 10, 28 181 54 16, tab 1 right
  text "Port:", 11, 28 153 54 16, tab 1 right
  button "Connect", 2, 195 267 70 22, disable ok
  button "Cancel", 4, 117 267 75 22, cancel
  check "Anonymous", 5, 5 267 100 20
  icon 6, -2 0 272 64, $scriptdir $+ libraries\icons\ftpconnheader.png, noborder
}

on *:dialog:newftpcconn:init:0: {
  did -f $dname 9
}

on *:dialog:newftpcconn:sclick:5: {
  if ($did($dname,5).state == 0) {
    did -r $dname 12,15
  }
  else {
    did -ar $dname 12 anonymous
    did -ar $dname 15 $hget(ftpc,email)
  }
  if ($did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }    
}

on *:dialog:newftpcconn:edit:9: {
  if ($did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:newftpcconn:edit:13: {
  if ($did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:newftpcconn:edit:12: {
  if ($did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:newftpcconn:edit:15: {
  if ($did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:newftpcconn:sclick:2: {
  var %site = $+($did($dname,12),:,$replace($did($dname,15),@,;),@,$did($dname,9),:,$did($dname,13))
  hadd ftpc recent %site
  ftpcconnect %site
}

;---STATS RECORDING---

alias ftpcstatsfile {
  return $+(",$scriptdir,settings\ftpcstats.ini,")
}

alias amountdl {
  var %w = $readini($ftpcstatsfile,Stats,AmountDL)
  writeini $ftpcstatsfile Stats AmountDL $calc(%w + $1-)
  var %n = $readini($ftpcstatsfile,Stats,NumDL)
  writeini $ftpcstatsfile Stats NumDL $calc(%n + 1)
}

alias amountul {
  var %w = $readini($ftpcstatsfile,Stats,AmountUL)
  writeini $ftpcstatsfile Stats AmountUL $calc(%w + $1-)
  var %n = $readini($ftpcstatsfile,Stats,NumUL)
  writeini $ftpcstatsfile Stats NumUL $calc(%n + 1)
}

;---SETTINGS DIALOG---

alias ftpcsetup {
  noop $dialog(ftpcsetup,ftpcsetup,-4)
}

dialog ftpcsetup {
  title "FTP Client Settings"
  size -1 -1 381 365
  option pixels
  tab "General", 1, 4 73 370 257
  box "General", 3, 13 99 352 91, tab 1
  text "Email Address:", 4, 29 125 76 16, tab 1
  text "Default D/L Dir:", 5, 29 154 79 16, tab 1
  edit "", 6, 108 121 243 23, tab 1
  button "...", 8, 320 151 30 21, tab 1
  box "Retry", 9, 13 194 352 60, tab 1
  text "Retry Delay:", 10, 25 219 62 16, tab 1
  edit "", 11, 88 215 64 23, tab 1
  edit "", 7, 108 150 210 23, tab 1
  text "Seconds", 32, 156 219 44 16, tab 1
  text "Retry Count:", 12, 221 219 64 16, tab 1
  edit "", 13, 286 215 64 23, tab 1
  box "Port Settings", 20, 13 258 352 56, tab 1
  text "Min:", 21, 24 281 21 16, tab 1
  edit "", 22, 47 277 61 23, tab 1
  edit "", 26, 222 277 106 23, tab 1
  text "IP:", 27, 203 281 16 16, tab 1
  button "?", 28, 333 279 17 20, tab 1
  text "Max:", 24, 112 281 29 16, tab 1
  edit "", 23, 141 277 58 23, tab 1
  tab "Exist Rules", 19
  box "Download", 25, 12 98 171 217, tab 19
  text "Smaller:", 34, 21 184 42 16, tab 19
  text "Same:", 35, 21 222 42 16, tab 19
  text "Larger:", 36, 21 259 42 16, tab 19
  combo 37, 66 180 107 99, tab 19 size drop
  box "Upload", 33, 191 98 173 217, tab 19
  combo 39, 66 256 107 99, tab 19 size drop
  combo 38, 66 218 107 99, tab 19 size drop
  text "Smaller:", 40, 202 184 42 16, tab 19
  combo 41, 247 180 107 99, tab 19 size drop
  text "Larger:", 42, 202 259 42 16, tab 19
  combo 43, 247 256 107 99, tab 19 size drop
  text "Same:", 44, 202 222 42 16, tab 19
  combo 45, 247 218 107 99, tab 19 size drop
  text "Take the following action when the file you are downloading already exists", 14, 24 121 148 43, tab 19
  text "Take the following action when the file you are uploading already exists", 15, 202 121 151 43, tab 19
  tab "Statistics", 16
  box "Upload Stats", 18, 12 212 352 103, tab 16
  box "Download Stats", 17, 12 98 352 109, tab 16
  text "Amount Downloaded:", 46, 31 162 104 16, tab 16 right
  text "Files Downloaded:", 30, 42 136 92 16, tab 16 right
  text "Files Uploaded:", 51, 39 245 92 16, tab 16 right
  text "Amount Uploaded:", 50, 28 271 104 16, tab 16 right
  edit "", 31, 141 131 86 23, tab 16 read
  edit "", 47, 141 157 86 23, tab 16 read
  button "Reset", 29, 251 144 75 25, tab 16
  edit "", 49, 138 240 86 23, tab 16 read
  edit "", 48, 138 266 86 23, tab 16 read
  button "Reset", 52, 248 253 75 25, tab 16
  button "OK", 2, 300 335 75 22, ok
  icon 53, -2 0 384 64, $scriptdir $+ libraries\icons\ftpcsettingsheader.png, noborder
}

on *:dialog:ftpcsetup:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 22 Updown nothousands edit alignright > $ctl
  did -i $dname 22 1 0 1 65535 10 0:1,2:5,5:20
  did -i $dname 22 1 $hget(ftpc,portstart)
  mdx SetControlMDX $dname 23 Updown nothousands edit alignright > $ctl
  did -i $dname 23 1 0 1 65535 10 0:1,2:5,5:20
  did -i $dname 23 1 $hget(ftpc,portend)
  mdx SetControlMDX $dname 11 Updown nothousands edit alignright > $ctl
  did -i $dname 11 1 0 1 900 10 0:1,2:5,5:20
  did -i $dname 11 1 $hget(ftpc,retry)
  mdx SetControlMDX $dname 13 Updown nothousands edit alignright > $ctl
  did -i $dname 13 1 0 1 100 10 0:1,2:5,5:20
  did -i $dname 13 1 $hget(ftpc,retrycount)
  did -ar $dname 6 $hget(ftpc,email)
  did -ar $dname 7 $hget(ftpc,defdldir)
  did -ar $dname 26 $hget(ftpc,portip)
  if ($hget(ftpc,xfermode) == 0) {
    did -c $dname 30
  }
  else if ($hget(ftpc,xfermode) == 1) {
    did -c $dname 31
  }
  else if ($hget(ftpc,xfermode) == 2) {
    did -c $dname 14
  }
  didtok $dname 37 44 Auto Skip,Auto Resume,Auto Overwrite,Auto Rename
  didtok $dname 38 44 Auto Skip,Auto Overwrite,Auto Rename
  didtok $dname 39 44 Auto Skip,Auto Overwrite,Auto Rename
  didtok $dname 41 44 Auto Skip,Auto Resume,Auto Overwrite
  didtok $dname 45 44 Auto Skip,Auto Overwrite
  didtok $dname 43 44 Auto Skip,Auto Overwrite
  did -c $dname 37 $hget(ftpc,downsmaller)
  did -c $dname 38 $hget(ftpc,downsame)
  did -c $dname 39 $hget(ftpc,downlarger)
  did -c $dname 41 $hget(ftpc,upsmaller)
  did -c $dname 45 $hget(ftpc,upsame)
  did -c $dname 43 $hget(ftpc,uplarger)
  did -ar $dname 31 $iif($readini($ftpcstatsfile,Stats,NumDL),$ifmatch,0)
  did -ar $dname 47 $bytes($iif($readini($ftpcstatsfile,Stats,AmountDL),$ifmatch,0)).suf
  did -ar $dname 49 $iif($readini($ftpcstatsfile,Stats,NumUL),$ifmatch,0)
  did -ar $dname 48 $bytes($iif($readini($ftpcstatsfile,Stats,AmountUL),$ifmatch,0)).suf
}

on *:dialog:ftpcsetup:sclick:2: {
  hadd ftpc downsmaller $did($dname,37).sel
  hadd ftpc downsame $did($dname,38).sel
  hadd ftpc downlarger $did($dname,39).sel
  hadd ftpc upsmaller $did($dname,41).sel
  hadd ftpc upsame $did($dname,45).sel
  hadd ftpc uplarger $did($dname,43).sel
}

on *:dialog:ftpcsetup:edit:6: {
  hadd ftpc email $did($dname,6)
}

on *:dialog:ftpcsetup:edit:7: {
  hadd ftpc defdldir $did($dname,7)
}

on *:dialog:ftpcsetup:sclick:8: {
  var %dir = $replace($sdir(C:,Select Download Dir...),\,/)
  if (%dir) {
    hadd ftpc defdldir %dir
    did -ar $dname 7 %dir
  }
}

on *:dialog:ftpcsetup:edit:11: {
  hadd ftpc retry $did($dname,11)
}

on *:dialog:ftpcsetup:edit:13: {
  hadd ftpc retrycount $did($dname,13)
}

on *:dialog:ftpcsetup:edit:22: {
  tokenize 32 $did($dname,22)
  hadd ftpc portstart $1
}

on *:dialog:ftpcsetup:edit:23: {
  tokenize 32 $did($dname,23)
  hadd ftpc portend $1
}

on *:dialog:ftpcsetup:edit:26: {
  hadd ftpc portip $did($dname,26)
}

on *:dialog:ftpcsetup:sclick:28: {
  hadd ftpc portip $ip
  did -ar $dname 26 $ip
}

on *:dialog:ftpcsetup:sclick:30: {
  hadd ftpc xfermode 0
}

on *:dialog:ftpcsetup:sclick:31: {
  hadd ftpc xfermode 1
}

on *:dialog:ftpcsetup:sclick:14: {
  hadd ftpc xfermode 2
}

on *:dialog:ftpcsetup:sclick:29: {
  writeini $ftpcstatsfile Stats AmountDL 0
  writeini $ftpcstatsfile Stats NumDL 0
  did -ar $dname 31 $iif($readini($ftpcstatsfile,Stats,NumDL),$ifmatch,0)
  did -ar $dname 47 $bytes($iif($readini($ftpcstatsfile,Stats,AmountDL),$ifmatch,0)).suf
}

on *:dialog:ftpcsetup:sclick:52: {
  writeini $ftpcstatsfile Stats AmountUL 0
  writeini $ftpcstatsfile Stats NumUL 0
  did -ar $dname 49 $iif($readini($ftpcstatsfile,Stats,NumUL),$ifmatch,0)
  did -ar $dname 48 $bytes($iif($readini($ftpcstatsfile,Stats,AmountUL),$ifmatch,0)).suf
}  

;---SITE MANAGER DIALOG---

alias ftpcsitemgr {
  noop $dialog(ftpcsitemgr,ftpcsitemgr,-4)
}

dialog ftpcsitemgr {
  title "FTP Site Manager"
  size -1 -1 376 328
  option pixels
  tab "Site", 1, 110 73 260 221
  box "Site Details", 3, 119 99 242 180, tab 1
  text "Address:", 8, 134 155 54 16, tab 1 right
  text "Site Name:", 7, 134 127 54 16, tab 1 right
  edit "", 6, 190 123 152 23, tab 1 read
  edit "", 9, 190 151 152 23, tab 1
  list 4, 3 92 103 200, size
  text "Site List", 5, 5 75 71 16
  text "Username:", 10, 134 211 54 16, right
  text "Port:", 11, 134 183 54 16, right
  edit "", 13, 190 179 152 23
  edit "", 12, 190 207 152 23
  edit "", 15, 190 236 152 23
  button "OK", 2, 317 299 54 22, ok
  text "Password:", 14, 134 240 54 16, right
  button "Apply", 16, 259 299 54 22
  button "Connect", 17, 201 299 54 22, disable
  check "Anonymous", 18, 4 298 100 20
  icon 19, -2 0 379 64, $scriptdir $+ libraries\icons\ftpcsiteheader.png, noborder
}

on *:dialog:ftpcsitemgr:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 4 listview single sortascending rowselect showsel noheader noscroll report > $views
  did -i $dname 4 1 headerdims 130:1
  did -i $dname 4 1 headertext 0 Accounts
  did -i $dname 4 1 iconsize normal small
  did -i $dname 4 1 seticon list $shortfn($scriptdirlibraries\icons\site.ico)
  did -b $dname 16
  fillaxx
}

on *:dialog:ftpcsitemgr:sclick:4: {
  if ($gettok($did($dname,4,1),1,32) == rclick) {
    newsitepop $did(4).sel $gettok($gettok($did(4).seltext,6,32),1,9)
  }
  else if ($gettok($did($dname,4,1),1,32) == sclick) {
    displayacc $gettok($gettok($did(4).seltext,6,32),1,9)
    did -e $dname 17
  }
}

on *:dialog:ftpcsitemgr:edit:9: {
  if ($gettok($gettok($did(4).seltext,6,32),1,9)) {
    hadd ftpc $ifmatch $did($dname,12) $+ : $+ $did($dname,15) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
    did -e $dname 16
  }
}

on *:dialog:ftpcsitemgr:edit:13: {
  if ($gettok($gettok($did(4).seltext,6,32),1,9)) {
    hadd ftpc $ifmatch $did($dname,12) $+ : $+ $did($dname,15) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
    did -e $dname 16
  }
}

on *:dialog:ftpcsitemgr:edit:12: {
  if ($gettok($gettok($did(4).seltext,6,32),1,9)) {
    hadd ftpc $ifmatch $did($dname,12) $+ : $+ $did($dname,15) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
    did -e $dname 16
  }
}

on *:dialog:ftpcsitemgr:edit:15: {
  if ($gettok($gettok($did(4).seltext,6,32),1,9)) {
    hadd ftpc $ifmatch $did($dname,12) $+ : $+ $did($dname,15) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
    did -e $dname 16
  }
}

on *:dialog:ftpcsitemgr:sclick:16: {
  if ($gettok($gettok($did(4).seltext,6,32),1,9)) {
    did -b $dname 16
  }
}

on *:dialog:ftpcsitemgr:sclick:17: {
  ftpcconnect $did($dname,12) $+ : $+ $replace($did($dname,15),@,;) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
  dialog -x $dname
}

on *:dialog:ftpcsitemgr:sclick:18: {
  if ($did($dname,18).state == 0) {
    did -r $dname 12,15
    did -b $dname 16
  }
  else {
    did -ar $dname 12 anonymous
    did -ar $dname 15 $hget(ftpc,email)
    did -e $dname 16
  }
}

alias displayacc {
  var %user = $gettok($gettok($hget(ftpc,$1),1,64),1,58)
  var %pass = $replace($gettok($gettok($hget(ftpc,$1),1,64),2,58),;,@)
  var %addr = $gettok($gettok($hget(ftpc,$1),2,64),1,58)
  var %port = $gettok($gettok($hget(ftpc,$1),2,64),2,58)
  did -ar ftpcsitemgr 6 $1
  did -ar ftpcsitemgr 9 %addr
  did -ar ftpcsitemgr 13 %port
  did -ar ftpcsitemgr 12 %user
  did -ar ftpcsitemgr 15 %pass
}

alias newsitepop {
  popups New newsitepop 16 16
  popups SetMetrics newsitepop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem newsitepop end + Add $cr newftpcsite
  popups AddItem newsitepop end + Delete $cr delftpcsite $1 $2
  popup newsitepop $mouse.dx $mouse.dy
}

alias delftpcsite {
  if ($1) && ($2) {
    hadd ftpc axx $remtok($hget(ftpc,axx),$2,96)
    hdel ftpc $2
    fillaxx
    did -r ftpcsitemgr 6,9,12,13,15
  }
}

alias newftpcsite {
  noop $dialog(ftpnewsite,ftpnewsite,-4)
}

dialog ftpnewsite {
  title "FTP Site"
  size -1 -1 271 328
  option pixels
  tab "New Site", 1, 4 72 260 221
  box "Site Details", 3, 13 98 242 180, tab 1
  text "Address:", 8, 28 154 54 16, tab 1 right
  text "Site Name:", 7, 28 126 54 16, tab 1 right
  text "Password:", 14, 28 239 54 16, tab 1 right
  text "Username:", 10, 28 210 54 16, tab 1 right
  text "Port:", 11, 28 182 54 16, tab 1 right
  edit "", 6, 84 122 152 23, tab 1
  edit "", 9, 84 150 152 23, tab 1
  edit "", 13, 84 178 152 23, tab 1
  edit "", 12, 84 206 152 23, tab 1
  edit "", 15, 84 235 152 23, tab 1
  button "OK", 2, 195 299 70 22, disable ok
  check "Anonymous", 4, 6 298 100 20
  icon 5, -2 0 274 64, $scriptdir $+ libraries\icons\ftpnewsiteheader.png, noborder
}

on *:dialog:ftpnewsite:init:0: {
  did -f $dname 6
}

on *:dialog:ftpnewsite:sclick:4: {
  if ($did($dname,4).state == 0) {
    did -r $dname 12,15
  }
  else {
    did -ar $dname 12 anonymous
    did -ar $dname 15 $hget(ftpc,email)
  }
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:edit:6: {
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:edit:9: {
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:edit:13: {
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:edit:12: {
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:edit:15: {
  if ($did($dname,6) && $did($dname,9) && $did($dname,13) && $did($dname,12) && $did($dname,15)) {
    did -e $dname 2
  }
}

on *:dialog:ftpnewsite:sclick:2: {
  var %acc = $did($dname,6)
  if ($istok($hget(ftpc,axx),%acc,96)) {
    noop $input(A site with the name %acc already exists.,iu,Info...)
    did -f $dname 6
    halt
  }
  else if ($chr(32) isin %acc) {
    noop $input(A site name must not contain spaces.,iu,Info...)
    did -f $dname 6
    halt
  }
  else {
    hadd ftpc axx $addtok($hget(ftpc,axx),%acc,96)
    hadd ftpc %acc $did($dname,12) $+ : $+ $replace($did($dname,15),@,;) $+ @ $+ $did($dname,9) $+ : $+ $did($dname,13)
    fillaxx
  }
}  

;---ALIASES---

alias -l fillaxx {
  did -r ftpcsitemgr 4
  var %a = $numtok($hget(ftpc,axx),96), %l = 1
  while (%l <= %a) {
    did -a ftpcsitemgr 4 0 1 $gettok($hget(ftpc,axx),%l,96)
    inc %l
  }
}

;---ACTIVITY AND STATS---

alias ftpcactivity {
  if ($hget(ftpc,action) != Idle) {
    var %activity = $hget(ftpc,action), %progress = $null, %dspeed = $null, %complete = $null
    if ($sock(ftpdata)) {
      var %datasock = ftpdata
    }
    else {
      var %datasock = ftp.data
    }
    if ($hget(ftpc,action) == Downloading) {
      var %complete = $round($calc($calc($sock(%datasock).rcvd / $hget(ftpc,filesize)) * 100),0) $+ %
      var %dspeed = $bytes($calc($sock(%datasock).rcvd / $sock(%datasock).to)).suf $+ /Sec
      var %progress = $bytes($sock(%datasock).rcvd).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
    }
    else if ($hget(ftpc,action) == Resuming D/L) {
      var %recieved = $hget(ftpc,filegot)
      var %complete = $round($calc($calc($calc($sock(%datasock).rcvd + %recieved) / $hget(ftpc,filesize)) * 100),0) $+ %
      var %dspeed = $bytes($calc($sock(%datasock).rcvd / $sock(%datasock).to)).suf $+ /Sec
      var %progress = $bytes($calc($sock(%datasock).rcvd + %recieved)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
    }
    else if ($hget(ftpc,action) == Uploading) {
      var %recieved = $hget(ftpc,filegot)
      var %complete = $round($calc($calc($calc($sock(%datasock).sent) / $hget(ftpc,filesize)) * 100),0) $+ %
      var %dspeed = $bytes($calc($sock(%datasock).sent / $sock(%datasock).to)).suf $+ /Sec
      var %progress = $bytes($calc($sock(%datasock).sent)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
    }
    else if ($hget(ftpc,action) == Resuming U/L) {
      var %sent = $hget(ftpc,sentbytes)
      var %complete = $round($calc($calc($calc($sock(%datasock).sent + %sent) / $hget(ftpc,filesize)) * 100),0) $+ %
      var %dspeed = $bytes($calc($sock(%datasock).sent / $sock(%datasock).to)).suf $+ /Sec
      var %progress = $bytes($calc($sock(%datasock).sent + %sent)).suf ( $+ $bytes($hget(ftpc,filesize)).suf $+ )
    }
    say $s.head(FTP: $hget(ftpc,action) File) $s.encleft $+ $s.value($nopath($hget(ftpc,currentfile))) $+ $s.encright $s.sep $s.head(Completed) $s.encleft $+ $s.value(%progress) $+ $s.encright $s.sep $s.head(Speed) $s.encleft $+ $s.value(%dspeed) $+ $s.encright $s.sep $s.head(Progress) $s.encleft $+ $s.value(%complete) $+ $s.encright
  }
  else {
    say $s.head(No FTP) $s.encleft $+ $s.value(Uploads) $+ $s.encright $s.head(or) $s.encleft $+ $s.value(Downloads) $+ $s.encright $s.head(in progress)
  }
}

alias ftpcstats {
  var %numdl = $iif($readini($ftpcstatsfile,Stats,NumDL),$ifmatch,0)
  var %amountdl = $bytes($iif($readini($ftpcstatsfile,Stats,AmountDL),$ifmatch,0)).suf
  var %numul = $iif($readini($ftpcstatsfile,Stats,NumUL),$ifmatch,0)
  var %amountul = $bytes($iif($readini($ftpcstatsfile,Stats,AmountUL),$ifmatch,0)).suf
  say $s.head(FTP Statistics - Downloaded) $s.encleft $+ $s.value(%amountdl) $+ $s.encright $s.head(in) $s.encleft $+ $s.value(%numdl) $+ $s.encright $s.head(files) $s.sep $s.head(Uploaded) $s.encleft $+ $s.value(%amountul) $+ $s.encright $s.head(in) $s.encleft $+ $s.value(%numul) $+ $s.encright $s.head(files)
}

;---MENUS---

menu @ftpmessages {
  Clear...:clear
}

on ^*:hotlink:*:*:{
  var %site $1
  if (*ftp://* iswm $1-) {
    if ($left($1,1) == $chr(40)) || ($left($1,1) == [) {
      %site = $right($1,-1))
    }
    if ($right(%site,1) == $chr(41)) || ($right(%site,1) == ]) {
      %site = $left(%site,-1)
    }
    if ($mouse.key & 16) {
      hotlinkpop %site
    }
  }
  halt
}

alias hotlinkpop {
  popups New hotlinkpop 16 16
  popups SetMetrics hotlinkpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem hotlinkpop end + Open... $cr connecttosite $1
  popups AddItem hotlinkpop end + Save Info $cr saveftpsite $1
  popup hotlinkpop $mouse.dx $mouse.dy
}

alias connecttosite {
  ftpc
  ftpcconnect $remove($1,ftp://)
}

alias saveftpsite {
  :start
  var %name = $input(Enter Site Name...,eoqu,Input Request,$null)
  if (%name) {
    if ($chr(32) isin %name) {
      noop $input(A site name must not contain spaces.,iou,Info...)
      goto start
    }
    else if (!$istok($hget(ftpc,axx),%name,96)) {
      hadd ftpc axx $addtok($hget(ftpc,axx),%name,96)
      hadd ftpc %name $remove($1,ftp://)
    }
    else {
      noop $input(A Site with the name %acc already exists.,iou,Info...)
      goto start
    }
  }
}

;---FAVOURITES---
