;---MODE MANAGER by mr.man (C) 2008 - Part of NeXtGenIRC---

;---EVENTS STUFF---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

;---ALIASES---

alias -l userfile {
  return $+(",$scriptdir,settings\users.ini,")
}

alias -l bansfile {
  return $+(",$scriptdir,settings\bans.ini,")
}

alias -l inifile {
  return $+(",$scriptdir,settings\modemgr.ini,")
}

alias loaduser {
  return $readini($userfile,users,$1)
}

alias saveuser {
  writeini $userfile users $1 $2-
}

alias loadban {
  return $readini($bansfile,bans,$1)
}

alias saveban {
  writeini $bansfile bans $1 $2-
}

alias -l savesettings {
  if (!%restart) {
    var %t = modemgr
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = modemgr
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
}

alias modemgr {
  dialog -m modemgr modemgr
}

alias fillusers {
  did -r modemgr 3
  var %l = 1
  while (%l <= $readini($userfile,settings,users)) {
    var %user = $readini($userfile,users,%l)
    tokenize 32 %user
    did -a modemgr 3 0 1 $1 $+ $chr(9) $+ + 0 0 0 $2 $+ $chr(9) $+ + 0 0 0 $3 $+ $chr(9) $+ + 0 0 0 $4 $+ $chr(9) $+ + 0 0 0 $5 $+ $chr(9) $+ + 0 0 0 $6
    inc %l
  }
}

alias saveusers {
  remini $userfile users
  var %c = 2
  while (%c <= $did(modemgr,3,1).lines) {
    var %user = $gettok($gettok($did(modemgr,3,%c),1,9),6,32)
    var %pass = $gettok($gettok($did(modemgr,3,%c),2,9),5,32)
    var %mask = $gettok($gettok($did(modemgr,3,%c),3,9),5,32)
    var %mode = $gettok($gettok($did(modemgr,3,%c),4,9),5,32)
    var %chan = $gettok($gettok($did(modemgr,3,%c),5,9),5,32)
    var %net = $gettok($gettok($did(modemgr,3,%c),6,9),5,32)
    saveuser $calc(%c - 1) %user %pass %mask %mode %chan %net
    inc %c
  }
  writeini $userfile settings users $calc(%c - 2)
}

alias savebans {
  remini $bansfile bans
  var %c = 2, %m = $null
  while (%c <= $did(modemgr,7,1).lines) {
    var %mask = $gettok($gettok($did(modemgr,7,%c),1,9),6,32)
    var %chan = $gettok($gettok($did(modemgr,7,%c),2,9),5,32)
    var %net = $gettok($gettok($did(modemgr,7,%c),3,9),5,32)
    var %kick = $gettok($gettok($did(modemgr,7,%c),4,9),5-,32)
    %m = %m %mask
    saveban $calc(%c - 1) %mask %chan %net %kick
    inc %c
  }
  hadd modemgr bans %m
  writeini $bansfile settings bans $calc(%c - 2)
}

alias fillbans {
  did -r modemgr 7
  var %l = 1
  while (%l <= $readini($bansfile,settings,bans)) {
    var %ban = $readini($bansfile,bans,%l)
    tokenize 32 %ban
    did -a modemgr 7 0 1 $1 $+ $chr(9) $+ + 0 0 0 $2 $+ $chr(9) $+ + 0 0 0 $3 $+ $chr(9) $+ + 0 0 0 $4-
    inc %l
  }
}

;---DIALOG STUFF---

dialog modemgr {
  title "Mode Manager"
  size -1 -1 542 390
  option pixels
  tab "User Modes", 1, 6 76 529 279
  box "User List", 2, 15 101 512 241, tab 1
  list 3, 25 118 491 212, tab 1 size
  tab "Ban List", 5
  box "Ban and Kick List", 6, 15 101 512 241, tab 5
  list 7, 25 118 491 213, tab 5 size
  button "OK", 4, 461 360 75 22, ok
  icon 8, -2 0 545 64, $scriptdir $+ libraries\icons\modemgrheader.png, noborder
}

on *:dialog:modemgr:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 3 listview single sortascending rowselect showsel report > $views
  did -i $dname 3 1 headerdims 100:1 70:2 80:3 40:4 65:5 115:6
  did -i $dname 3 1 headertext 0 Username $+ $chr(9) $+ 0 Password $+ $chr(9) $+ 0 Mask $+ $chr(9) $+ 0 Mode $+ $chr(9) $+ 0 Network $+ $chr(9) $+ 0 Channels
  did -i $dname 3 1 iconsize normal small
  did -i $dname 3 1 seticon list $shortfn($scriptdirlibraries\icons\client.ico)
  fillusers
  mdx SetControlMDX 7 listview single sortascending rowselect showsel report > $views
  did -i $dname 7 1 headerdims 125:1 80:2 80:3 180:4
  did -i $dname 7 1 headertext 0 Mask $+ $chr(9) $+ 0 Channel $+ $chr(9) $+ 0 Network $+ $chr(9) $+ 0 Kick Message
  fillbans
}

on *:dialog:modemgr:sclick:3:{
  if ($gettok($did($dname,3,1),1,32) == rclick) {
    modespopup $did(3).sel $gettok($gettok($did(3).seltext,6,32),1,9)
  }
}

on *:dialog:modemgr:sclick:4:{
  noop
}  

on *:dialog:modemgr:sclick:7:{
  if ($gettok($did($dname,7,1),1,32) == rclick) {
    banspopup $did(7).sel $gettok($gettok($did(7).seltext,6,32),1,9)
  }
}

;---ADD MODE DIALOG---

dialog addmode {
  title "Add New User"
  size -1 -1 260 363
  option pixels
  tab "User...", 1, 5 73 248 255
  box "New User Details", 2, 14 98 230 215, tab 1
  text "Username:", 3, 24 186 59 16, tab 1 right
  text "Password:", 5, 24 216 59 16, tab 1 right
  text "Hostmask:", 6, 24 246 59 16, tab 1 right
  text "Mode", 7, 24 276 59 16, tab 1 right
  edit "", 15, 89 121 139 23, tab 1 autohs
  edit "", 13, 89 151 139 23, tab 1 autohs
  edit "", 8, 89 181 139 23, tab 1 autohs
  edit "", 9, 89 211 139 23, tab 1 autohs
  edit "", 10, 89 241 139 23, tab 1 autohs
  combo 11, 90 272 137 100, tab 1 size drop
  text "Channel:", 12, 24 156 59 16, right
  text "Network:", 14, 24 126 59 16, right
  button "OK", 4, 179 334 75 22, disable ok
  icon 16, -2 0 263 64, $scriptdir $+ libraries\icons\newmodeheader.png, noborder
}

on *:dialog:addmode:init:0: {
  did -ar $dname 15 $network
  did -f $dname 15
  didtok $dname 11 44 Owner (+q),Admin (+a),Operator (+o),Half Op (+h),Voice (+v)
  did -c $dname 11 1
}

on *:dialog:addmode:sclick:4: {
  if (Owner * iswm $did($dname,11)) {
    var %mode = +q
  }
  if (Admin * iswm $did($dname,11)) {
    var %mode = +a
  }
  if (Operator * iswm $did($dname,11)) {
    var %mode = +o
  }
  if (Half * iswm $did($dname,11)) {
    var %mode = +h
  }
  if (Voice * iswm $did($dname,11)) {
    var %mode = +v
  }
  did -a modemgr 3 0 1 $did($dname,8) $+ $chr(9) $+ + 0 0 0 $did($dname,9) $+ $chr(9) $+ + 0 0 0 $did($dname,10) $+ $chr(9) $+ + 0 0 0 %mode $+ $chr(9) $+ + 0 0 0 $did($dname,15) $+ $chr(9) $+ + 0 0 0 $did($dname,13)
  saveusers
} 

on *:dialog:addmode:edit:8: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:addmode:edit:9: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:addmode:edit:10: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:addmode:edit:13: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:addmode:edit:15: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

;---EDIT MODE DIALOG---

dialog editmode {
  title "Edit User"
  size -1 -1 259 363
  option pixels
  tab "User...", 1, 5 74 248 255
  box "Edit User Details", 2, 14 99 230 215, tab 1
  text "Username:", 3, 24 187 59 16, tab 1 right
  text "Password:", 5, 24 217 59 16, tab 1 right
  text "Hostmask:", 6, 24 247 59 16, tab 1 right
  text "Mode", 7, 24 277 59 16, tab 1 right
  edit "", 15, 89 122 139 23, tab 1 autohs
  edit "", 13, 89 152 139 23, tab 1 autohs
  edit "", 8, 89 182 139 23, tab 1 read
  edit "", 9, 89 212 139 23, tab 1 autohs
  edit "", 10, 89 242 139 23, tab 1 autohs
  combo 11, 90 273 137 100, tab 1 size drop
  button "OK", 4, 179 335 75 22, ok
  text "Channel:", 12, 24 157 59 16, right
  text "Network:", 14, 24 127 59 16, right
  icon 16, -2 0 262 64, $scriptdir $+ libraries\icons\editmodeheader.png, noborder
}

on *:dialog:editmode:init:0: {
  var %n = $hget(modemgr,editname)
  var %user = $gettok($gettok($did(modemgr,3,%n),1,9),6,32)
  var %pass = $gettok($gettok($did(modemgr,3,%n),2,9),5,32)
  var %mask = $gettok($gettok($did(modemgr,3,%n),3,9),5,32)
  var %mode = $gettok($gettok($did(modemgr,3,%n),4,9),5,32)
  var %chan = $gettok($gettok($did(modemgr,3,%n),5,9),5,32)
  var %net = $gettok($gettok($did(modemgr,3,%n),6,9),5,32)
  did -ar $dname 13 %net
  did -ar $dname 15 %chan
  did -ar $dname 8 %user
  did -ar $dname 9 %pass
  did -ar $dname 10 %mask
  did -f $dname 15
  didtok $dname 11 44 Owner (+q),Admin (+a),Operator (+o),Half Op (+h),Voice (+v)
  if (%mode == +q) {
    did -c $dname 11 1
  }
  else if (%mode == +a) {
    did -c $dname 11 2
  }
  else if (%mode == +o) {
    did -c $dname 11 3
  }
  else if (%mode == +h) {
    did -c $dname 11 4
  }
  else if (%mode == +v) {
    did -c $dname 11 5
  }
}

on *:dialog:editmode:sclick:4: {
  if (Owner * iswm $did($dname,11)) {
    var %mode = +q
  }
  if (Admin * iswm $did($dname,11)) {
    var %mode = +a
  }
  if (Operator * iswm $did($dname,11)) {
    var %mode = +o
  }
  if (Half * iswm $did($dname,11)) {
    var %mode = +h
  }
  if (Voice * iswm $did($dname,11)) {
    var %mode = +v
  }
  did -d modemgr 3 $hget(modemgr,editname)
  did -a modemgr 3 0 1 $did($dname,8) $+ $chr(9) $+ + 0 0 0 $did($dname,9) $+ $chr(9) $+ + 0 0 0 $did($dname,10) $+ $chr(9) $+ + 0 0 0 %mode $+ $chr(9) $+ + 0 0 0 $did($dname,15) $+ $chr(9) $+ + 0 0 0 $did($dname,13)
  saveusers
} 

on *:dialog:editmode:edit:8: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:editmode:edit:9: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:editmode:edit:10: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:editmode:edit:13: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

on *:dialog:editmode:edit:15: {
  if ($did($dname,8)) && ($did($dname,9)) && ($did($dname,10)) && ($did($dname,13)) && ($did($dname,15)) {
    did -e $dname 4
  }
}

dialog addban {
  title "Add New Ban"
  size -1 -1 311 304
  option pixels
  tab "Ban...", 1, 4 73 300 194
  box "New Ban Details", 2, 13 98 282 154, tab 1
  text "Hostmask:", 6, 23 186 59 16, tab 1 right
  edit "", 10, 88 181 191 23, tab 1 autohs
  text "Channel:", 12, 23 156 59 16, right
  text "Network:", 14, 23 126 59 16, right
  text "Kick Msg:", 3, 23 216 59 16, right
  edit "", 15, 88 121 191 23, autohs
  edit "", 13, 88 151 191 23, autohs
  edit "", 5, 88 211 191 23, autohs
  button "OK", 4, 230 273 75 24, disable ok
  icon 7, -2 0 314 64, $scriptdir $+ libraries\icons\addbanheader.png, noborder
}

on *:dialog:addban:init:0: {
  did -ar $dname 15 $network
  did -f $dname 15
}

on *:dialog:addban:sclick:4: {
  did -a modemgr 7 0 1 $did($dname,10) $+ $chr(9) $+ + 0 0 0 $did($dname,13) $+ $chr(9) $+ + 0 0 0 $did($dname,15) $+ $chr(9) $+ + 0 0 0 $did($dname,5)
  savebans
}

on *:dialog:addban:edit:5: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:addban:edit:10: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:addban:edit:13: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:addban:edit:15: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

dialog editban {
  title "Edit Ban"
  size -1 -1 311 300
  option pixels
  tab "Ban...", 1, 5 73 300 194
  box "Edit Ban Details", 2, 14 98 282 154, tab 1
  text "Hostmask:", 6, 24 186 59 16, tab 1 right
  edit "", 10, 89 181 191 23, tab 1 autohs
  text "Channel:", 12, 24 156 59 16, right
  text "Network:", 14, 24 126 59 16, right
  text "Kick Msg:", 3, 24 216 59 16, right
  edit "", 15, 89 121 191 23, autohs
  edit "", 13, 89 151 191 23, autohs
  edit "", 5, 89 211 191 23, autohs
  button "OK", 4, 231 272 75 22, ok
  icon 7, -2 0 314 64, $scriptdir $+ libraries\icons\editbanheader.png, noborder
}

on *:dialog:editban:init:0: {
  var %n = $hget(modemgr,editban)
  var %mask = $gettok($gettok($did(modemgr,7,%n),1,9),6,32)
  var %chan = $gettok($gettok($did(modemgr,7,%n),2,9),5,32)
  var %net = $gettok($gettok($did(modemgr,7,%n),3,9),5,32)
  var %kick = $gettok($gettok($did(modemgr,7,%n),4,9),5-,32)
  did -ar $dname 15 %net
  did -ar $dname 13 %chan
  did -ar $dname 10 %mask
  did -ar $dname 5 %kick
}

on *:dialog:editban:sclick:4: {
  did -d modemgr 7 $hget(modemgr,editban)
  did -a modemgr 7 0 1 $did($dname,10) $+ $chr(9) $+ + 0 0 0 $did($dname,13) $+ $chr(9) $+ + 0 0 0 $did($dname,15) $+ $chr(9) $+ + 0 0 0 $did($dname,5)
  savebans
}

on *:dialog:editban:edit:5: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:editban:edit:10: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:editban:edit:13: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

on *:dialog:editban:edit:15: {
  if ($did($dname,15)) && ($did($dname,13)) && ($did($dname,10)) && ($did($dname,5)) {
    did -e $dname 4
  }
}

;---POPUPS STUFF---

alias modespopup {
  popups New modespop 16 16
  popups SetMetrics modespop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem modespop end + Add $cr addnewmode
  popups AddItem modespop end + Delete $cr delmode $1
  if ($did(modemgr,3).seltext) {
    popups AddItem modespop end
    popups AddItem modespop end + Edit $cr editmode $1
  }
  popup modespop $mouse.dx $mouse.dy
}

alias addnewmode {
  dialog -m addmode addmode
}

alias delmode {
  if ($1) {
    did -d modemgr 3 $1
    saveusers
  }
}

alias editmode {
  hadd modemgr editname $1
  dialog -m editmode editmode
}

alias banspopup {
  popups New banspop 16 16
  popups SetMetrics banspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem banspop end + Add $cr addnewban
  popups AddItem banspop end + Delete $cr delban $1
  if ($did(modemgr,7).seltext) {
    popups AddItem banspop end
    popups AddItem banspop end + Edit $cr editban $1
  }
  popup banspop $mouse.dx $mouse.dy
}

alias addnewban {
  dialog -m addban addban
}

alias delban {
  if ($1) {
    did -d modemgr 7 $1
    savebans
  }
}

alias editban {
  hadd modemgr editban $1
  dialog -m editban editban
}

;---CTCP IDENTIFY---

ctcp ^*:*:*: {
  if ($1 == ID) {
    idmode $2 $3 $nick $address($nick,1)
    halt
  }
}

;---ACTUAL ID ROUTINE---

alias idmode {
  var %l = 1, %username = $1, %password = $2, %nick = $3, %address = $4
  theme.text $s.head(User) $s.encleft $+ $s.value(%nick) $+ $s.encright $s.head(is trying to identify with username) $s.encleft $+ $s.value(%username) $+ $s.encright $s.head(and password) $s.encleft $+ $s.value(%password) $+ $s.encright
  while (%l <= $readini($userfile,settings,users)) {
    var %user = $readini($userfile,users,%l)
    tokenize 32 %user
    if (%username == $1) && (%password == $2) {
      if ($3 iswm %address) {
        var %n = 1
        while (%n <= $scon(0)) {
          if ($5 == $scon(%n).network) {
            var %c = 1
            while (%c <= $numtok($6,44)) {
              var %chan = $gettok($6,%c,44)
              if (%chan ischan) {
                scon %n mode %chan $4 %nick
              }
              inc %c
            }
          }
          inc %n
        }
      }
    }
    inc %l
  }
}

;---ON JOIN STUFF---

on *:join:#:{
  var %l = 1
  while (%l <= $numtok($hget(modemgr,bans),32)) {
    if ($gettok($hget(modemgr,bans),%l,32) iswm $address($nick,5)) {
      var %n = 1
      while (%n <= $scon(0)) {
        var %b = 1
        while (%b <= $readini($bansfile,settings,bans)) {
          var %ban = $readini($bansfile,bans,%b)
          tokenize 32 %ban
          if ($1 iswm $address($nick,5)) {
            if ($3 == $scon(%n).network) {
              if ($2 == $chan) {
                scon %n mode $2 +b $1
                scon %n kick $2 $nick $4-
              }
            }
          }
          inc %b
        }
        inc %n
      }
    }
    inc %l
  }
}
