;---MTS Engine by mr.man (c) 2008 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias mts {
  dialog -m mts mts
}

alias -l inifile {
  return $+(",$scriptdir,settings\mts.ini,")
}

alias -l loadsettings {
  if ($exists($inifile)) {
    var %h = mts_settings
    if ($hget(%h)) { hfree %h }
    hmake %h 10
    hload -i %h $inifile Settings
  }
}

alias -l savesettings {
  if (!%restart) {
    var %h = mts_settings
    hsave -i %h $inifile Settings
  }
}

alias mts_preload {
  var %wt = @mts.theme, %i = 1
  window -lh %wt 
  loadbuf -tmts %wt $+(",$1-,")
  filter -cxww %wt %wt ;*
  filter -cww %wt %wt ?* ?*
  if ($hget(mts_preload)) { hfree mts_preload }
  hmake mts_preload 100
  if ($dialog(mts)) {
    did -ra mts 9 Default Scheme
  }
  while (%i <= $line(%wt,0)) {
    tokenize 32 $line(%wt,%i)
    if (Scheme* iswm $1) {
      if ($dialog(mts)) {
        did -a mts 9 $2-
      }
    }
    else {
      hadd mts_preload $1 $2-
    }
    inc %i
  }
  window -c %wt
}

alias mts_loadscheme {
  if ($1 != 0) {
    var %wt = @mts.scheme, %i = 1
    window -lh %wt
    loadbuf -tscheme $+ $1 %wt $+(",$2-,")
    filter -cxww %wt %wt ;*
    filter -cww %wt %wt ?* ?*
    while (%i <= $line(%wt,0)) {
      tokenize 32 $line(%wt,%i)
      hadd mts_preload $1 $2-
      inc %i
    }
    window -c %wt  
  }
}

alias mts_compile {
  if ($script($hget(mts_preload,script)) != $null) {
    .unload -rs $+(",$ifmatch,")
  }
  .remove $+(",$scriptdir,theme.mrc,")
  var %wd = @mts.dynfile, %wc = @mts.compiled, %i = 1
  window -lh %wd | window -lh %wc
  loadbuf %wd $+(",$scriptdir,mts.dat,")
  while (%i <= $line(%wd,0)) {
    tokenize 32 $line(%wd,%i)
    if ($1 == <basecolours>) {
      var %t1 = set -nu1 % $+ ::c1 $gettok($hget(mts_preload,basecolors),1,44) $chr(124) 
      var %t2 = set -nu1 % $+ ::c2 $gettok($hget(mts_preload,basecolors),2,44) $chr(124)
      var %t3 = set -nu1 % $+ ::c3 $gettok($hget(mts_preload,basecolors),3,44) $chr(124)
      var %t4 = set -nu1 % $+ ::c4 $gettok($hget(mts_preload,basecolors),4,44)
      aline %wc %t1 %t2 %t3 %t4
    }
    else if ($1 == <common>) {
      aline %wc set -nu1 % $+ ::me $ $+ me
      aline %wc set -nu1 % $+ ::server $ $+ server
      aline %wc set -nu1 % $+ ::port $ $+ port
      aline %wc set -nu1 % $+ ::nick $ $+ nick
      aline %wc set -nu1 % $+ ::address $ $+ address
      aline %wc set -nu1 % $+ ::chan $ $+ chan
      aline %wc set -nu1 % $+ ::pre $mts_parse(-c,$hget(mts_preload,PREFIX))
    }
    else if ($1 == <parentext>) {
      aline %wc if (* iswm % $+ ::text) $chr(123) set -nu1 % $+ ::parentext $mts_parse(-c,$hget(mts_preload,PARENTEXT)) $chr(125)
    }
    else if ($1 == <error>) {
      aline %wc % $+ :echo $mts_parse(-c,$hget(mts_preload,error))
    }
    else if ($1 == <echo>) {
      aline %wc % $+ :echo $mts_parse(-c,$hget(mts_preload,echo))
    }
    else if ($1 == <timestamp>) {
      if ($hget(mts_preload,TIMESTAMPFORMAT)) {
        aline %wc .timestamp -f $mts_parse(-c,$hget(mts_preload,TIMESTAMPFORMAT))
      }
      else if ($hget(mts_preload,TIMESTAMP) != OFF) && ($hget(mts_preload,TIMESTAMP) != ON) && ($hget(mts_preload,TIMESTAMP) != $null) {
        aline %wc .timestamp -f $mts_parse(-c,$hget(mts_preload,TIMESTAMP))
      }
    }
    else if ($1 == <font>) {
      aline %wc set -nu1 % $+ ::font [ [ $hget(mts_preload,FONTCHAN) ] ]
    }
    else if (<*> iswm $1) {
      var %evt = $remove($1,<,>)
      tokenize 32 $hget(mts_preload,%evt)
      if ($1 == !Script) {
        aline %wc $2-
      }
      else {
        var %t = $mts_parse(-c,$hget(mts_preload,%evt))
        aline %wc % $+ :echo %t % $+ :comments
      }
    }
    else {
      if ($1- != $null) {
        aline %wc $1-
      }
    }
    inc %i
  }
  var %l = 1
  while (%l < 621) {
    var %r = raw. $+ $base(%l,10,10,3)
    if ($hget(mts_preload,%r) != $null) {
      tokenize 32 $ifmatch
      if ($1 == !Script) && (%l != 421) {
        aline %wc alias mts_ $+ [ [ %r ] ] $chr(123) $2- $chr(125)
      }
      elseif ($1 != $null) && (%l != 421) {
        aline %wc alias mts_ $+ [ [ %r ] ] $chr(123) % $+ :echo $mts_parse(-c,$1-) $chr(125)
      }
    }
    inc %l
  }
  if ($hget(mts_preload,WHOIS)) {
    tokenize 32 $ifmatch
    if ($1 == !Script) {
      aline %wc alias mts_raw.318 $chr(123) $2- $chr(125)
    }
    else {
      aline %wc alias mts_raw.318 $chr(123) % $+ :echo $mts_parse(-c,$1-) $chr(125)
    }
  }
  savebuf %wc $+(",$scriptdir,theme.mrc,")
  window -c %wd | window -c %wc
  .load -rs $+(",$scriptdir,theme.mrc,")
  var %script = $hget(mts_preload,script)
  var %null = $findfile($hget(mts_settings,theme_dir),%script,0,.load -rs $+(",$1-,"))
}

alias mts_parse {
  var %f = $1, %t = $2-
  tokenize 32 %t
  if ($1 != !script) {
    var %c = $regex(mts,$1-,/(<[-_.a-zA-Z0-9]+>|[%{|}\[\]$])/g), %n
    while (%c >= 1) {
      var %o = $regml(mts,%c)
      var %l = $left(%t,$calc($regml(mts,%c).pos - 1)) $+ 
      var %r = $mid(%t,$calc($regml(mts,%c).pos + $len($regml(mts,%c))))
      if ($len(%o) == 1) {
        %n = $+($,chr,$chr(40),$asc(%o),$chr(41),)
      }
      elseif (%o == <gt>) {
        %n = >
      }
      elseif (%o == <lt>) {
        %n = <
      }
      else {
        %n = $+(%,::,$right($left(%o,-1),-1)) $+ 
      }
      if (%l != ) && ($asc($right(%l,2)) != 32) {
        %n = $+($chr(32),$!+,$chr(32),%n)
      }
      if (%r != $null) && ($asc($left(%r,1)) != 32) {
        %n = $+($left(%n,-1),$chr(32),$!+,$chr(32),)
      }
      var %t = $+($left(%l,-1),$left(%n,-1),%r)
      dec %c
    }
  }
  if (%f == -c) {
    return %t
  }
  else if (%f == -p) {
    return $(%t,2)
  }
}

alias mts_set_fonts {
  if ($1 == reset) {
    var %restoreini = $+(",$scriptdir,mts_res.ini,")
    var %fchannel = $readini(%restoreini,Restore,FChannel)
    var %fstatus = $readini(%restoreini,Restore,FStatus)
    var %fquery = $readini(%restoreini,Restore,FQuery)
  }
  else {
    var %fstatus = $hget(mts_preload,FONTDEFAULT)
    var %fchannel = $hget(mts_preload,FONTCHAN)
    var %fquery = $hget(mts_preload,FONTQUERY)
  }
  if (%fstatus) {
    font -s $gettok(%fstatus,2,44) $gettok(%fstatus,1,44)
  }
  if (%fchannel) {
    var %s = $scon(0)
    while (%s) {
      scon %s
      var %l = $chan(0)
      while (%l > 0) {
        font -d $chan(%l) $right($gettok(%fchannel,2,44),2) $gettok(%fchannel,1,44)
        dec %l
      }
      dec %s
    }
  }
  if (%fquery) {
    query $me
    var %s = $scon(0)
    while (%s) {
      scon %s
      var %l = $query(0)
      while (%l > 0) {
        font -d $query(%l) $gettok(%fquery,2,44) $gettok(%fquery,1,44)
        dec %l
      }
      dec %s
    }
    var %fquery = $hget(mts_preload,FONTQUERY)
    var %s = $scon(0)
    while (%s) {
      scon %s
      var %l = $chat(0)
      while (%l > 0) {
        font -d $chat(%l) $gettok(%fquery,2,44) $gettok(%fquery,1,44)
        dec %l
      }
      dec %s
    }
    close -m $me
  }
}

alias mts_set_timestamp {
  if ($hget(mts_preload,TIMESTAMP) != OFF) {
    .timestamp -e ON
    if ($hget(mts_preload,TIMESTAMPFORMAT)) {
      .timestamp -f $($mts_parse(-p,$hget(mts_preload,TIMESTAMPFORMAT)),2)
    }
    else {
      .timestamp -f $($mts_parse(-p,$hget(mts_preload,TIMESTAMP)),2)
    }
  }
  else {
    .timestamp -e OFF
  }
}

alias mts_set_colours {
  var %cols = back,action,ctcp,high,info,info2,invite,join,kick,mode,nick,normal,notice,notify,other,own,part,quit,topic,wallops,whois,edit,editbox t,list,listbox t,gray,inactive,title
  var %cl = $hget(mts_preload,COLORS), %i = 1, %t = $numtok(%cols,44)
  if ($numtok(%cl,44) < %t) { %t = $ifmatch }
  while (%i <= %t) {
    color $gettok(%cols,%i,44) $gettok(%cl,%i,44)
    inc %i
  }
  if ($numtok(%cl,44) <= 28) {
    color inactive $gettok(%cl,22,44)
  }
  var %cl = $hget(mts_preload,RGBCOLORS), %i = 1, %t = $numtok(%cl,44)
  if ($numtok(%cl,32) < %t) { %t = $ifmatch }
  while (%i <= %t) {
    color $calc(%i - 1) $rgb( [ [ $gettok(%cl,%i,32) ] ] )
    inc %i
  }
}

alias clear_background {
  var %l = 1
  while ($scon(%l)) {
    scon %l
    background -xs
    background -xm
    background -xl
    background -xu
    background -xh
    inc %l
  }
}

alias mts_set_background {
  clear_background
  var %l = 1
  while ($scon(%l)) {
    var %i = 1
    while ($chan(%i)) {
      background -x $chan(%i)
      inc %i
    }
    var %i = 1
    while ($query(%i)) {
      background -x $query(%i)
      inc %i
    }
    var %i = 1
    while ($chat(%i)) {
      background -x $+(=,$chat(%i))
      inc %i
    }
    inc %l
  }
  var %dir = $nofile($1-)
  var %init = c.f.n.r.t.p
  if ($hget(mts_preload,IMAGEBUTTONS)) { background -u $+(",%dir,$ifmatch,") }
  if ($hget(mts_preload,IMAGETOOLBAR)) { 
    tokenize 32 $ifmatch
    var %t = $gettok(c.f.n.r.t.p,$findtok(center.fill.normal.stretch.tile.photo,$1,1,46),46)
    background -l $+ %t $+(",%dir,$2-,")
  }
  if ($hget(mts_preload,IMAGESWITCHBAR)) {
    tokenize 32 $ifmatch
    var %t = $gettok(c.f.n.r.t.p,$findtok(center.fill.normal.stretch.tile.photo,$1,1,46),46)
    background -h $+ %t $+(",%dir,$2-,")
  }
  if ($hget(mts_preload,IMAGEMIRC)) {
    tokenize 32 $ifmatch
    var %t = $gettok(c.f.n.r.t.p,$findtok(center.fill.normal.stretch.tile.photo,$1,1,46),46)
    background -m $+ %t $+(",%dir,$2-,")
  }
  if ($hget(mts_preload,IMAGESTATUS)) {
    tokenize 32 $ifmatch
    var %t = $gettok(c.f.n.r.t.p,$findtok(center.fill.normal.stretch.tile.photo,$1,1,46),46)
    background -s $+ %t $+(",%dir,$2-,")
  }
}

alias mts_set_nickcols {
  var %l = $cnick(0)
  while (%l) {
    .cnick -r 1
    dec %l
  }
  if ($hget(mts_preload,CLINEME)) {
    .cnick -an $!me $ifmatch
  }
  if ($hget(mts_preload,CLINEOWNER)) {
    .cnick * $ifmatch ~
    .cnick * $ifmatch .
  }
  if ($hget(mts_preload,CLINESOP)) {
    .cnick * $ifmatch !
    .cnick * $ifmatch &
  }
  else {
    .cnick * $hget(mts_preload,CLINEOP) &
  }
  if ($hget(mts_preload,CLINEOP)) {
    .cnick * $ifmatch @
  }
  if ($hget(mts_preload,CLINEHOP)) {
    .cnick * $ifmatch %
  }
  if ($hget(mts_preload,CLINEVOICE)) {
    .cnick * $ifmatch +
  }
  if ($hget(mts_preload,CLINEREGULAR)) {
    .cnick -n * $ifmatch
  }
}

alias mts_create_restore {
  var %restoreini = $+(",$scriptdir,settings\mts_res.ini,"), %mircini $+(",$mircini,")
  var %c = $null, %l = 1, %i = back,action,ctcp,high,info,info2,invite,join,kick,mode,nick,normal,notice,notify,other,own,part,quit,topic,wallops,whois,edit,editbox t,list,listbox t,gray,inactive,title
  while (%l <= $numtok(%i,44)) {
    %c = %c $+ $color($gettok(%i,%l,44)) $+ ,
    inc %l
  }
  var %colindex = $left(%c,-1)
  var %c = $null, %l = 0
  while (%l < 16) {
    %c = %c $+ $color(%l) $+ ,
    inc %l
  }
  var %colrgbs = $left(%c,-1)
  if ($exists(%restoreini)) { .remove %restoreini }
  writeini %restoreini Restore ColIndex %colindex
  writeini %restoreini Restore ColRGBs %colrgbs
  if ($readini(%mircini,fonts,fchannel)) { writeini %restoreini Restore FChannel $ifmatch } 
  else { writeini %restoreini Restore FChannel writeini fixedsys,9 }
  if ($readini(%mircini,fonts,fquery)) { writeini %restoreini Restore FQuery $readini(%mircini,fonts,fquery) }
  else { writeini %restoreini Restore FQuery fixedsys,9 }
  if ($readini(%mircini,fonts,fstatus)) { writeini %restoreini Restore Fstatus $readini(%mircini,fonts,fstatus) }
  else { writeini %restoreini Restore FQuery fixedsys,9 }
  writeini %restoreini Restore TimeStamp $timestampfmt
}

alias mts_do_restore {
  var %restoreini = $+(",$scriptdir,mts_res.ini,"), %mircini $+(",$mircini,")
  var %cols = back,action,ctcp,high,info,info2,invite,join,kick,mode,nick,normal,notice,notify,other,own,part,quit,topic,wallops,whois,edit,editbox t,list,listbox t,gray,inactive,title
  var %cl = $readini(%restoreini,Restore,ColIndex)
  var %i = 1
  var  %t = $numtok(%cols,44)
  if ($numtok(%cl,44) < %t) { %t = $ifmatch }
  while (%i <= %t) {
    color $gettok(%cols,%i,44) $gettok(%cl,%i,44)
    inc %i
  }
  if ($numtok(%cl,44) < 27) {
    color inactive $gettok(%cl,22,44)
  }
  var %cl = $readini(%restoreini,Restore,ColRGBs), %i = 1, %t = $numtok(%cl,44)
  if ($numtok(%cl,44) < %t) { %t = $ifmatch }
  while (%i <= %t) {
    color $calc(%i - 1) $gettok(%cl,%i,44)
    inc %i
  }
  mts_set_fonts reset
  var %fchannel = $readini(%restoreini,Restore,FChannel)
  var %fquery = $readini(%restoreini,Restore,FQuery)
  var %fstatus = $readini(%restoreini,Restore,FStatus)
  if (%fchannel) {
    writeini %mircini fonts fchannel %fchannel
  }
  if (%fquery) {
    writeini %mircini fonts fquery %fquery
  }
  if (%fstatus) {
    writeini %mircini fonts fstatus %fstatus
  }
  .timestamp -f $readini(%restoreini,Restore,TimeStamp)
  var %l = $cnick(0)
  while (%l) {
    .cnick -r 1
    dec %l
  }
  clear_background
  .remove %restoreini
}

alias mts_do_load {
  var %script = $hget(mts_settings,Theme_Script)
  if ($script(%script)) { .unload -rs %script }
  if (%f != $null) && ($exists(%f)) {
    theme_progress
    .timer -m 1 1 mts_actual_load
  }
}

alias mts_actual_load {
  did -a theme_progress 9 5
  mts_preload %f
  if (%s > 0) {
    mts_loadscheme %s %f
    hadd mts_settings Scheme %s
  }
  did -a theme_progress 9 10
  var %restoreini = $+(",$scriptdir,mts_res.ini,")
  if (!$exists(%restoreini)) {
    mts_create_restore
  }
  did -a theme_progress 9 20
  mts_compile
  did -a theme_progress 9 30
  mts_set_colours
  did -a theme_progress 9 40
  mts_set_fonts
  did -a theme_progress 9 50
  mts_set_timestamp
  did -a theme_progress 9 60
  if ($hget(mts_settings,nicklist) == 1) {
    mts_set_nickcols
  }
  did -a theme_progress 9 70
  mts_set_background %f
  did -a theme_progress 9 80
  hadd mts_settings Scheme %s
  hadd mts_settings Theme_File %f
  hadd mts_settings Theme_Loaded YES
  hadd mts_settings Theme_Script $hget(mts_preload,SCRIPT)
  unset %f %s
  did -a theme_progress 9 85
  sbar off
  did -a theme_progress 9 90
  sbar on
  did -a theme_progress 9 95
  generate_bitmaps
  did -a theme_progress 9 100
  did -v theme_progress 3
  did -e theme_progress 4
  var %d = 1
  while (%d <= $dialog(0)) {
    if (nicklist.* iswm $dialog(%d)) {
      xdid -i $dialog(%d) 1 +b $color($color(background))
    }
    inc %d
  }
}

alias generate_bitmaps {
  var %b = @bitmaps, %l = 0
  window -hdpfkniB +d %b 0 0 24 24
  while (%l <= 15) {
    drawrect -f %b %l 24 0 0 24 24
    drawsave %b $+(",$scriptdir,libraries\icons\ $+ [ [ %l ] ] $+ .bmp,")
    inc %l
  }
  window -c %b
}

alias theme.unload {
  if ($script(theme.mrc)) {
    .unload -rs theme.mrc
  }
  if ($script($hget(mts_settings,Theme_Script))) {
    .unload -rs $hget(mts_settings,Theme_Script)
  }
  mts_do_restore
  clear_background
  if ($exists($+(",$scriptdir,theme.mrc,"))) {
    .remove $+(",$scriptdir,theme.mrc,")
  }
  hadd mts_settings Theme_Loaded NO
  var %ini = $+(",$scriptdir,mts.ini,")
  if ($exists(%ini)) {
    writeini %ini Settings Theme_Loaded NO
    writeini %ini Settings Theme_Dir $hget(mts_settings,Theme_Dir)
    writeini %ini Settings Theme_File Nil
    writeini %ini Settings Theme_Script Nil
    writeini %ini Settings Theme_Scheme Nil
  }
}

alias theme.load {
  if ($0 < 1) { mts }
  var %n = $findfile($hget(mts_settings,theme_dir),$1,0, set %f $1-)
  set %s $2
  mts_do_load
}

;---PREVIEW SECTION---

alias mts_timestamp {
  if ($hget(mts_preload,TIMESTAMP) == ON) {
    var %tempts = $timestampfmt 
    .timestamp -f $($mts_parse(-p,$hget(mts_preload,TIMESTAMPFORMAT)),2)
    var %ts = $mts_parse(-p,$timestamp)
    .timestamp -f %tempts
    return %ts
  }
  else {
    return $null
  }
}

alias mts_preview_add {
  if ($hget(mts_preload,$2)) {
    var %t = $ifmatch
    set -u %:echo aline @mtspvp $1 $mts_timestamp
    %t = $mts_parse(-p,%t)
    if ($2) {
      if ($gettok(%t,1,32) == !script) {
        if ($gettok(%t,2-,32)) {
          var %ifmatch = [ [ $ifmatch ] ]
          $(%ifmatch,2)
        }
      }
      else {
        %:echo $(%t,3)
      }
    }
  }
}

alias mts_colours {
  var %cols = background,action,ctcp,highlight,info,info2,invite,join,kick,mode,nick,normal,notice,notify,other,own,part,quit,topic,wallops,whois,editbox,editbox text,listbox,listbox text,inactive,gray,title
  return $findtok(%cols,$1,1,44)
}

alias mts_preview {
  var %ts = $nofile(%f)
  var %tf = $hget(mts_preload,SCRIPT)
  var %wpp = @mtspvp, %wpv = @mtsrpv
  .load -rs $+(",%ts,%tf,")
  var %fn = $+(",$gettok($hget(mts_preload,FONTCHAN),1,44),")
  var %fs = $gettok($hget(mts_preload,FONTCHAN),2,44)
  window -hl %wpp
  window -hpfkniB +d %wpv -1 -1 495 286
  var %back = $gettok($hget(mts_preload,COLORS),1,44)
  drawfill %wpv %back %back 1 1

  set -u %::c1  $+ $gettok($hget(mts_preload,BASECOLORS),1,44)
  set -u %::c2  $+ $gettok($hget(mts_preload,BASECOLORS),2,44)
  set -u %::c3  $+ $gettok($hget(mts_preload,BASECOLORS),3,44)
  set -u %::c4  $+ $gettok($hget(mts_preload,BASECOLORS),4,44)

  set -u %::nick $me
  set -u %::chan #NXG
  set -u %::address me@here.com
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(join),44) JOINSELF

  set -u %::cmode @
  set -u %::nick mr_man
  set -u %::text Welcome $me
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) TEXTCHAN

  set -u %::cmode $null
  set -u %::nick $me
  set -u %::me $me
  set -u %::text Hi mr_man!
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) TEXTCHANSELF

  set -u %::nick Spaceman
  set -u %::chan #NXG
  set -u %::address man@space.com
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(join),44) JOIN

  set -u %::nick Spaceman
  set -u %::address man@space.com
  set -u %::realname Some Body
  if ($hget(mts_preload,WHOIS)) {
    mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) WHOIS
  }
  else {
    mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.311
  }

  set -u %::isregd is
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.307

  set -u %::chan #NXG #scripting
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.319

  set -u %::wserver irc.evorev.com
  set -u %::serverinfo The Best IRC Network
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.312

  set -u %::idletime 17643
  set -u %::signontime 1095431869
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.317

  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(whois),44) RAW.318

  set -u %::nick Partygal
  set -u %::chan #NXG
  set -u %::text See you in the next life
  set -u %::address girl@party.org
  set -u %::parentext $mts_parse(-c,$hget(mts_preload,PARENTEXT))
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(part),44) PART

  set -u %::nick mr_man
  set -u %::text NeXtGenIRC v2.0 is now available
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(topic),44) TOPIC

  set -u %::nick Burman
  set -u %::text Op me pleeeeease
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) TEXTCHAN

  set -u %::knick Burman
  set -u %::nick mr_man
  set -u %::text Here's what u get for begging
  set -u %::parentext $mts_parse(-c,$hget(mts_preload,PARENTEXT))
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(kick),44) KICK

  set -u %::nick Spaceman
  set -u %::newnick Earthman
  set -u %::address man@space.com
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(nick),44) NICK

  set -u %::nick Quitter
  set -u %::text I've had enough
  set -u %::address end@the.last.straw.com
  set -u %::parentext $mts_parse(-c,$hget(mts_preload,PARENTEXT))
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(quit),44) QUIT

  set -u %::nick Earthman
  set -u %::text decides not to ask for Ops
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(action),44) ACTIONCHAN

  set -u %::cmode @
  set -u %::nick mr_man
  set -u %::text Very shrewd move
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) TEXTCHAN

  set -u %::nick Spammer
  set -u %::text Come to my channel
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) INVITE

  set -u %::nick mr_man
  set -u %::text Spammer this is your final warning
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(normal),44) TEXTCHAN

  set -u %::cmode $null
  set -u %::nick Spammer
  set -u %::text apologises ... it will never happen again
  mts_preview_add $gettok($hget(mts_preload,COLORS),$mts_colours(action),44) ACTIONCHAN

  var %i = 1
  while ($line(%wpp,%i)) {
    var %colour = $gettok($ifmatch,1,32)
    var %line = $gettok($ifmatch,2-,32)
    if (%line) {
      drawtext -pb %wpv %colour %back %fn %fs 3 $calc((%i - 1) * $height(%line,%fn,%fs)) %line
    }
    inc %i
  }
  var %i = 1
  var %tcols = 1,1,1 2,2,2 3,3,3 4,4,4 5,5,5 6,6,6 7,7,7 8,8,8 9,9,9 10,10,10 11,11,11 12,12,12 13,13,13 14,14,14 15,15,15 16,16,16
  while (%i <= 16) {
    var %r = $rgb( [ $gettok(%tcols,%i,32) ] )
    if ($gettok(%r,2,44)) { var %r = $rgb( [ %r ] ) }
    if (%r) {
      drawreplace -nr %wpv $color($calc(%i -1)).rgb %r
    }
    inc %i
  }
  %i = 1
  while (%i <= 16) {
    var %r = $rgb( [ $gettok($hget(mts_preload,RGBCOLORS),%i,32) ] )
    if ($gettok(%r,2,44)) { var %r = $rgb( [ %r ] ) }
    if (%r) {
      drawreplace -nr %wpv $rgb( [ $gettok(%tcols,%i,32) ] ) %r
    }
    inc %i
  }
  var %mtspreview = $+(",$scriptdir,preview.bmp,")
  drawsave %wpv %mtspreview
  did -g mts 13 %mtspreview
  .remove %mtspreview
  window -c %wpp
  window -c %wpv
  .unload -rs $hget(mts_preload,SCRIPT)
}

;---EVENTS---

on *:start:{
  loadsettings
  hadd mts_settings theme_dir $+(",$scriptdir,themes,")
  var %f = $nofile($hget(mts_settings,theme_file))
  var %n = $hget(mts_settings,theme_script)
  if ($exists($+(",%f,%n,"))) {
    .load -rs $+(",%f,%n,")
  }
  mts_set_timestamp
  generate_bitmaps
}

on *:exit:{ savesettings }

;---MAIN DIALOG---

dialog mts {
  title "MTS Engine"
  size -1 -1 537 451
  option pixels
  tab "Theme", 4, 4 74 527 344
  edit "", 14, 178 123 321 23, tab 4 read
  text "Name:", 15, 179 157 47 16, tab 4
  text "Version:", 16, 179 181 50 16, tab 4
  edit "", 19, 178 277 321 103, tab 4 read multi vsbar
  text "Author:", 17, 179 206 50 16, tab 4
  text "URL:", 18, 181 252 50 16, tab 4
  text "", 37, 272 157 200 16, tab 4
  text "", 38, 272 180 200 16, tab 4
  text "", 39, 272 204 200 16, tab 4
  link "", 40, 272 228 200 16, tab 4
  link "", 41, 272 251 200 16, tab 4
  box "Theme Info", 12, 158 100 364 302, tab 4
  button "...", 2, 120 104 28 18, tab 4
  text "Themes:", 1, 11 106 50 16, tab 4
  list 3, 11 124 138 149, tab 4 size
  text "Schemes:", 8, 11 276 50 16, tab 4
  list 9, 11 296 138 107, tab 4 size
  check "Use theme Nicklist Colours", 11, 7 425 157 20, tab 4
  button "Unload", 20, 334 423 64 22, tab 4
  button "Load", 6, 401 423 64 22, tab 4 ok
  tab "Preview", 10
  icon 13, 19 111 495 286,  $mircexe, 0, tab 10
  tab "Editor", 7
  box "Theme to Edit", 21, 14 100 342 54, tab 7
  edit "", 22, 24 118 293 23, tab 7 read autohs
  button "...", 23, 320 120 23 20, tab 7
  box "Edit Settings", 24, 14 159 508 245, tab 7
  list 26, 24 177 156 178, tab 7 size
  edit "", 27, 186 239 325 116, tab 7 multi vsbar
  button "Save", 28, 400 423 65 22, tab 7
  button "", 25, 25 363 485 30, tab 7
  combo 30, 377 120 134 100, tab 7 size drop
  box "Scheme to Edit", 29, 365 100 157 54, tab 7
  text "", 31, 186 178 324 53, tab 7 center
  button "Cancel", 5, 468 423 64 22, cancel
  icon 32, -2 0 540 64, $scriptdir $+ libraries\icons\mtsheader.png, 0, noborder
}

on *:dialog:mts:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  window -ph @tpreview
  mdx SetControlMDX $dname 25 window > $dlg
  did -a $dname 25 grab $window(@tpreview).hwnd @tpreview
  mdx SetControlMDX $dname 26 TreeView haslines hasbuttons showsel > $views
  did -i $dname 26 1 cb root
  did -a $dname 26 +eb 1 1 0 0 0 Sections
  did -i $dname 26 1 cb last
  tokenize 44 General,Colours,Fonts,Timestamp,Nickname Colours,Main Events,Text Events,CTCPs,RAWs,Echos,Miscellaneous,Images
  did -a $dname 26 + 1 1 0 0 0 $*
  tokenize 44 Name,Author,Version,Email,Website,Description
  did -i $dname 26 1 cb root 2 2
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 Colors,RGBColors,BaseColors
  did -i $dname 26 1 cb root 2 3
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 Background,Action,CTCP Text,Highlight,Info,Info2,Invite Text,Join Text,Kick Text,Mode Text,Nick Text,Normal Text,Notice Text,Notify Text,Other,Own,Part Text,Quit Text,Topic Text,Wallops,Whois Text,Editbox,Editbox Text,Listbox,Listbox Text,Inactive,Gray,Title
  did -i $dname 26 1 cb root 2 3 2
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15
  did -i $dname 26 1 cb root 2 3 3
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 FontDefault,FontChan,FontQuery
  did -i $dname 26 1 cb root 2 4
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 TimeStamp,TimeStampFormat
  did -i $dname 26 1 cb root 2 5
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 CLineOwner,CLineSOP,CLineOP,CLineHOP,CLineVoice,CLineRegular,CLineMe
  did -i $dname 26 1 cb root 2 6
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 Mode,ModeUser,Join,JoinSelf,Part,Kick,KickSelf,Quit,Topic,Nick,NickSelf,Invite,Rejoin
  did -i $dname 26 1 cb root 2 7
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 TextChan,TextChanSelf,ActionChan,ActionChanSelf,NoticeChan,Notice,NoticeSelf,NoticeSelfChan,TextQuery,TextQuerySelf,ActionQuery,ActionQuerySelf,TextMsg,TextMsgSelf
  did -i $dname 26 1 cb root 2 8
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 CTCP,CTCPChan,CTCPSelf,CTCPChanSelf,CTCPReply,CTCPReplySelf
  did -i $dname 26 1 cb root 2 9
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 001,002,003,004,005,221,250,251,252,253,254,255,265,266,301,302,307,310,311,312,313,314,315,317,318,319,324,329,331,332,333,352,353,366,369,375,376,378,379,401,402,403,421,422,433,442,471,473,474,475,482,other
  did -i $dname 26 1 cb root 2 10
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 raw. $+ [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 Echo,EchoTarget,Error
  did -i $dname 26 1 cb root 2 11
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 Whois,Whowas,Prefix,ParenText,Notify,UNotify,WallOp,NoticeServer,DNS,DNSError,DNSResolve,ServerError
  did -i $dname 26 1 cb root 2 12
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  tokenize 44 ImageMIRC,ImageStatus,ImageSwitchbar,ImageToolbar,ImageButtons
  did -i $dname 26 1 cb root 2 13
  var %c = 1
  while (%c <= $0) {
    did -a $dname 26 + 1 1 0 0 0 [ [ $ $+ [ [ %c ] ] ] ]
    inc %c
  }
  did -g $dname 13 $+(",$scriptdir,libraries\icons\pre.png,")
  var %f = $findfile($hget(mts_settings,theme_dir),*.mts,0,did -a mts 3 $nopath($1-))
  if ($hget(mts_settings,nicklist) == 0) {
    did -u mts 11
  }
  else {
    did -c mts 11
  }
  showinfo Welcome to the theme editor. Please note you can use basecolours (<c1> etc.) and prefix (<pre>) in all events. Have fun.
}

menu @tpreview {
  dclick:popupselector
}

alias -l showinfo {
  did -ar mts 31 $1-
}

alias popupselector {
  var %sel = $seltext(mts,26)
  var %cols = Background.Action.CTCP Text.Highlight.Info.Info2.Invite Text.Join Text.Kick Text.Mode Text.Nick Text.Normal Text.Notice Text.Notify Text.Other.Own.Part Text.Quit Text.Topic Text.Wallops.Whois Text.Editbox.Editbox Text.Listbox.Listbox Text.Inactive.Gray.Title
  if ($istok(%cols,%sel,46)) {
    colourpicker
    return
  }
  var %nums = 00.01.02.03.04.05.06.07.08.09.10.11.12.13.14.15
  if ($istok(%nums,%sel,46)) {
    colourmaker
    return
  }
  var %fonts = FONTDEFAULT.FONTCHAN.FONTQUERY
  if ($istok(%fonts,%sel,46)) {
    var %font = $dcx(FontDialog)
    if (%font) {
      var %fn = $gettok(%font,5-,32), %fs $gettok(%font,4,32)
      did -ar mts 27 %fn $+ , $+ %fs
      commitchanges
    }
    return
  }
  if (%sel == BaseColors) {
    showhint Double Click for BaseColours Selector
    basecolourpicker
    return
  }
  var %images = IMAGEMIRC.IMAGESTATUS.IMAGESWITCHBAR.IMAGETOOLBAR
  if ($istok(%images,%sel,46)) {
    var %image = $dcx(OpenDialog, createprompt overwriteprompt owner mts $chr(9) $null $chr(9) All Files (*.*))
    if (%image) {
      did -ar mts 27 $nopath(%image)
      bgoptions
    }
    return
  }
  if (%sel == IMAGEBUTTONS) {
    var %image = $dcx(OpenDialog, createprompt overwriteprompt owner mts $chr(9) $null $chr(9) All Files (*.*))
    if (%image) {
      did -ar mts 27 $nopath(%image)
    }
    return
  }
  var %nicks = CLINEOWNER.CLINESOP.CLINEOP.CLINEHOP.CLINEVOICE.CLINEREGULAR.CLINEME
  if ($istok(%nicks,%sel,46)) {
    nickcolourpicker
    return
  }
}

on *:dialog:mts:sclick:5:{
  closeschemes
}  

on *:dialog:mts:sclick:23:{
  var %t = $sfile($hget(mts_settings,theme_dir))
  if (%t) {
    closeschemes
    did -ar $dname 22 %t
    loadthemetoedit
  }
}

alias -l loadthemetoedit {
  var %file = $+(",$did(mts,22).text,"), %i = 1, %w = @Default, %s = mts_settings
  hadd %s schemes $!null
  if ($window(%w)) {
    window -c %w
  }
  window -hl %w
  loadbuf -tmts %w %file
  if ($dialog(mts)) {
    did -ra mts 30 Default
  }
  while (%i <= $line(%w,0)) {
    tokenize 32 $line(%w,%i)
    if (scheme* iswm $1) {
      var %scheme = $replace($2-,$chr(32),_)
      hadd %s schemes $addtok($hget(%s,schemes),%scheme,44)
      if ($window(@ $+ %scheme)) {
        window -c @ $+ %scheme
      }
      window -hl @ $+ %scheme
      loadbuf -tscheme $+ $calc($findtok($hget(%s,schemes),%scheme,1,44) -1) @ $+ %scheme %file
      if ($dialog(mts)) {
        did -a mts 30 $2-
      }
    }
    inc %i
  }
  did -c mts 30 1
  hadd %s editing Default
}

alias -l savethemefromedit {
  showinfo Saving Theme... Please Wait...
  var %file = $+(",$did(mts,22).text,"), %i = 2, %w = Default, %s = mts_settings
  write -a %file [mts]
  savebuf -a @ $+ %w %file
  while (%i <= $numtok($hget(mts_settings,schemes),44)) {
    var %w = $gettok($hget(mts_settings,schemes),%i,44)
    write -a %file [scheme $+ $calc(%i - 1) $+ ]
    savebuf -a @ $+ %w %file
    inc %i
  }
  .timer 1 2 showinfo $null
}

alias -l closeschemes {
  var %l = 1
  while (%l <= $numtok($hget(mts_settings,schemes),44)) {
    var %w = $gettok($hget(mts_settings,schemes),%l,44)
    window -c @ $+ %w
    inc %l
  }
  window -c @Default
}

alias theme_entry {
  tokenize 32 $fline(@ $+ $hget(mts_settings,editing),$1 *,1,1).text
  if ($2-) {
    return $2-
  }
  else {
    return $null
  }
}

alias gettext {
  var %l = 1
  while (%l <= $did(mts,27).lines) {
    var %t = %t $did(mts,27,%l).text
    inc %l
  }
  return %t
}

on *:dialog:mts:sclick:26:{
  did -ar mts 27 $theme_entry($seltext(mts,26))
  updatepreview
}

alias updatepreview {
  if ($window(@ $+ $hget(mts_settings,editing))) {
    showinfo $null
    clear @tpreview
    var %back = $gettok($theme_entry(COLORS),1,44)
    if (%back != $null) {
      drawfill @tpreview %back %back 1 1
    }
    var %event = $seltext(mts,26), %cols = Background.Action.CTCP Text.Highlight.Info.Info2.Invite Text.Join Text.Kick Text.Mode Text.Nick Text.Normal Text.Notice Text.Notify Text.Other.Own.Part Text.Quit Text.Topic Text.Wallops.Whois Text.Editbox.Editbox Text.Listbox.Listbox Text.Inactive.Gray.Title
    set -u %::c1  $+ $gettok($theme_entry(BASECOLORS),1,44)
    set -u %::c2  $+ $gettok($theme_entry(BASECOLORS),2,44)
    set -u %::c3  $+ $gettok($theme_entry(BASECOLORS),3,44)
    set -u %::c4  $+ $gettok($theme_entry(BASECOLORS),4,44)
    set -u %::pre $mts_parse(-p,$theme_entry(PREFIX))
    set -u %::address $me $+ @nextgenirc.net
    set -u %::nick $me
    set -u %::me $me
    set -u %::chan #NXG
    set -u %::server irc.evorev.com
    if (%event == Sections) {
      showinfo Welcome to the theme editor. Please note you can use basecolours (<c1> etc.) and prefix (<pre>) in all events. Have fun.
    }
    if ($istok(00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15,%event,32)) {
      var %col = $gettok($theme_entry(RGBCOLORS),$calc(%event + 1),32)
      edit_colour %col
      if (%col) {
        did -ar mts 27 %col
      }
      showhint Double Click for Colour Palette
      showinfo These settings are for the palette your theme will use. There are 16 seperate colours for you to edit and use.
      return
    }
    if ($istok(%cols,%event,46)) {
      var %col = $gettok($theme_entry(COLORS),$findtok(%cols,%event,1,46),44)
      if (%col != $null) {
        edit_colour $rgb($color(%col))
        if (%col) {
          did -ar mts 27 %col
        }
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of event will use.
        return
      }
    }

    if (%event == NAME) {
      showinfo The name of the theme
      return
    }
    if (%event == AUTHOR) {
      showinfo The author of the theme
      return
    }
    if (%event == VERSION) {
      showinfo The version of the theme
      return
    }
    if (%event == EMAIL) {
      showinfo The email address of the author
      return
    }
    if (%event == WEBSITE) {
      showinfo The website of the author
      return
    }
    if (%event == DESCRIPTION) {
      showinfo The description of the theme
      return
    }
    if (%event == BASECOLORS) {
      showhint Double Click for BaseColours Selector
      showinfo These are the BaseColours ... a set of 4 colours that can be easily referenced by a theme.
      return
    }
    if ($istok(FONTDEFAULT.FONTCHAN.FONTQUERY,%event,46)) {
      var %font = $gettok($theme_entry(%event),1,46)
      if (%font != $null) {
        ;did -ar mts 27 %font
        showhint Double Click for Font Selector
        showinfo Set the fonts used by your theme here, in the format of font name comma then size ... e.g. Tahoma,11
        return
      }
    }
    if (%event == MODE) {
      set -u %::modes +i
      showinfo A user changes a channel mode $crlf $crlf $+ Identifiers: <address> <chan> <cmode> <modes>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(mode),44) %event
    }
    if (%event == MODEUSER) {
      set -u %::modes +o
      showinfo Your usermode gets changed $crlf $crlf $+ Identifiers: <address> <modes>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(mode),44) %event
    }
    if (%event == JOIN) {
      showinfo A user joins a channel $crlf $crlf $+ Identifiers: <address> <chan> <nick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(join),44) %event
    }
    if (%event == JOINSELF) {
      showinfo You join a channel $crlf $crlf $+ Identifiers: <chan>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(join),44) %event
    }
    if (%event == PART) {
      showinfo You or a user parts a channel $crlf $crlf $+ Identifiers: <chan> <nick> <address> <text> <parentext>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(part),44) %event
    }
    if (%event == KICK) {
      set -u %::text See you in the next life
      set -u %::knick Loser
      showinfo A user gets kicked from a channel $crlf $crlf $+ Identifiers: <chan> <nick> <knick> <text> <parentext>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(kick),44) %event
    }
    if (%event == KICKSELF) {
      set -u %::text See how you like it
      showinfo You get kicked from a channel $crlf $crlf $+ Identifiers: <chan> <nick> <knick> <text> <parentext>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(kick),44) %event
    }
    if (%event == QUIT) {
      set -u %::text I'm quitting
      showinfo A user quits IRC $crlf $crlf $+ Identifiers: <address> <chan> <nick> <text> <parentext>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(quit),44) %event
    }
    if (%event == TOPIC) {
      set -u %::text Welcome to #NXG
      showinfo A user sets the channel topic $crlf $crlf $+ Identifiers: <nick> <text> <parentext>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(topic),44) %event
    }
    if (%event == NICK) {
      set -u %::newnick SuperGenius
      showinfo A user changes their nickname $crlf $crlf $+ Identifiers: <address> <chan> <nick> <newnick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(nick),44) %event
    }
    if (%event == NICKSELF) {
      set -u %::newnick SuperGenius
      showinfo You change your nickname $crlf $crlf $+ Identifiers: <address> <chan> <nick> <newnick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(nick),44) %event
    }
    if (%event == INVITE) {
      showinfo A user invites you to a channel $crlf $crlf $+ Identifiers: <chan> <nick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(invite),44) %event
    }
    if (%event == REJOIN) {
      showinfo You rejoin a channel $crlf $crlf $+ Identifiers: <chan> <nick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TEXTCHAN) {
      set -u %::text Hello and welcome to NeXtGenIRC
      set -u %::cmode @
      set -u %::cnick $theme_entry(CLINEOP)
      showinfo A user types in a channel $crlf $crlf $+ Identifiers: <chan> <nick> <text> <cmode> <cnick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TEXTCHANSELF) {
      set -u %::text Why thankyou very much
      set -u %::cmode +
      set -u %::cnick $theme_entry(CLINEVOICE)
      showinfo You type in a channel $crlf $crlf $+ Identifiers: <chan> <nick> <text> <cmode> <cnick> <me>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(own),44) %event
    }
    if (%event == ACTIONCHAN) {
      set -u %::text waves to everybody
      set -u %::cmode @
      set -u %::cnick $theme_entry(CLINEOP)
      showinfo A user performs an action in a channel $crlf $crlf $+ Identifiers: <chan> <nick> <text> <cmode> <cnick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(action),44) %event
    }
    if (%event == ACTIONCHANSELF) {
      set -u %::text waves back
      set -u %::cmode @
      set -u %::cnick $theme_entry(CLINEOP)       
      showinfo You perform an action in a channel $crlf $crlf $+ Identifiers: <chan> <me> <text> <cmode> <cnick>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(action),44) %event
    }
    if (%event == NOTICECHAN) {
      set -u %::text Please notice this notice
      set -u %::target #NXG
      showinfo A user sends a notice to a channel $crlf $crlf $+ Identifiers: <chan> <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notice),44) %event
    }
    if (%event == NOTICE) {
      set -u %::text I noticed the notice
      showinfo You recieve a notice $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notice),44) %event
    }
    if (%event == NOTICESELF) {
      set -u %::text I noticed it too
      set -u %::target mr_man
      showinfo You send a notice to a user $crlf $crlf $+ Identifiers: <target> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notice),44) %event
    }
    if (%event == NOTICESELFCHAN) {
      set -u %::text Enough with the notices already!
      set -u %::target #NXG      
      showinfo You send a notice to a channel $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notice),44) %event
    }
    if (%event == TEXTQUERY) {
      set -u %::text Excuse me, I have a query...
      showinfo You recieve a query $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TEXTQUERYSELF) {
      set -u %::text Why am I querying myself?
      showinfo You query yourself $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == ACTIONQUERY) {
      set -u %::text waves to you
      showinfo A user performs an action in a query $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(action),44) %event
    }
    if (%event == ACTIONQUERYSELF) {
      set -u %::text waves to him/herself
      showinfo You perform an action in a query $crlf $crlf $+ Identifiers: <me> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(action),44) %event
    }
    if (%event == TEXTMSG) {
      set -u %::text Just a little message...
      showinfo You recieve a private text message $crlf $crlf $+ Identifiers: <nick> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TEXTMSGSELF) {
      set -u %::text Just talking to myself...
      set -u %::target #NXG
      showinfo You send a private text message $crlf $crlf $+ Identifiers: <target> <text>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == CTCP) {
      set -u %::text blah
      set -u %::ctcp VERSION
      showinfo You recieve a CTCP $crlf $crlf $+ Identifiers: <ctcp> <text> <nick> <address>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == CTCPCHAN) {
      set -u %::text blah
      set -u %::ctcp VERSION
      showinfo You recieve a channel CTCP $crlf $crlf $+ Identifiers: <ctcp> <text> <nick> <address>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == CTCPSELF) {
      set -u %::text blah
      set -u %::ctcp VERSION
      set -u %::target #NXG
      showinfo You send a CTCP to a user $crlf $crlf $+ Identifiers: <ctcp> <text> <target>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == CTCPCHANSELF) {
      set -u %::text blah
      set -u %::ctcp VERSION
      set -u %::target #NXG
      showinfo You send a CTCP to a channel $crlf $crlf $+ Identifiers: <ctcp> <text> <target>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == CTCPREPLY) {
      set -u %::text blah
      set -u %::ctcp VERSION
      showinfo You receive a CTCP reply $crlf $crlf $+ Identifiers: <ctcp> <text> <nick> <address>
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == CTCPREPLYSELF) {
      set -u %::text blah
      set -u %::ctcp VERSION
      set -u %::target #NXG
      showinfo You send a CTCPReply to a user or channel $crlf $crlf $+ Identifiers: <ctcp> <text> <nick> <address>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(ctcp),44) %event
    }
    if (%event == ECHO) {
      set -u %::text Some text
      showinfo A general echo of information $crlf $crlf $+ Identifiers: <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == ECHOTARGET) {
      set -u %::text Some more text
      showinfo A general echo of information to a specific target $crlf $crlf $+ Identifiers: <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == ERROR) {
      set -u %::text An error has occured
      showinfo An error has occured $crlf $crlf $+ Identifiers: <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == PREFIX) {
      showinfo A prefix that precedes any text, to use it call it with <pre>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == PARENTEXT) {
      set -u %::text Some text
      showinfo Text enclosed in brackets of your choice, to use it call it with <parentext>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == NOTIFY) {
      showinfo A user on your notify list goes online $crlf $crlf $+ Identifiers: <nick> <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notify),44) %event
    }
    if (%event == UNOTIFY) {
      showinfo A user on your notify list goes offline $crlf $crlf $+ Identifiers: <nick> <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notify),44) %event
    }
    if (%event == WALLOP) {
      set -u %::text blah blah blah      
      showinfo You recieve a Wallop text $crlf $crlf $+ Identifiers: <nick> <text>            
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(wallops),44) %event
    }
    if (%event == NOTICESERVER) {
      set -u %::text A notice from the server
      showinfo You recieve a notice from a server $crlf $crlf $+ Identifiers: <server> <text>      
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(wallops),44) %event
    }
    if (%event == DNS) {
      showinfo You try to DNS an address or nickname $crlf $crlf $+ Identifiers: <address> <nick>    
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(info),44) %event
    }
    if (%event == DNSERROR) {
      showinfo A DNS attempt failed $crlf $crlf $+ Identifiers: <address>    
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(info),44) %event
    }
    if (%event == DNSRESOLVE) {
      set -u %::raddress 127.0.0.1
      set -u %::naddress 127.0.0.1
      set -u %::iaddress localhost
      showinfo You recieve a DNS result $crlf $crlf $+ Identifiers: <iaddress> <naddress> <raddress>    
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(info),44) %event
    }
    if (%event == SERVERERROR) {
      set -u %::text There has been an error on the server
      showinfo A server error has occured $crlf $crlf $+ Identifiers: <text>    
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(notice),44) %event
    }
    if (%event == WHOIS) {
      showinfo A special event for themes that use this rather than use the raw events
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == WHOWAS) {
      showinfo A special event for themes that use this rather than use the raw events
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.001) {
      set -u %::text to the Internet Relay Network
      showinfo A welcome to the server message
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.002) {
      set -u %::text Your host is
      set -u %::value UnrealIRCD      
      showinfo The name of the server you have connected to
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.003) {
      set -u %::value 10/08/2007
      showinfo The date and time the server was created or last restarted
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.004) {
      showinfo Information on the server you are connected to
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.005) {
      set -u %::text NOQUIT TOKEN WATCH=128 SAFELIST
      showinfo A list of protocols that the server supports
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.221) {
      set -u %::modes +o
      showinfo Your usermode
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.250) {
      set -u %::text 3241
      set -u %::value 4213
      showinfo The highest total number of connections
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.251) {
      set -u %::users 4213
      set -u %::text 1423
      set -u %::value 3241
      showinfo The number of non-invisible users currently online
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.252) {
      set -u %::value 1423
      showinfo The number of IRC operators online
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.253) {
      set -u %::value 1324
      showinfo The number of unknown connections
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.254) {
      set -u %::value 4321
      showinfo The number of channels currently formed
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.255) {
      set -u %::users 1234
      set -u %::value 4312
      showinfo The number of users connected to this server
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.265) {
      set -u %::users 1234
      set -u %::value 4312
      showinfo The number of users connected to this server and the highest number of users ever connected to this server 
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.266) {
      set -u %::users 1234
      set -u %::value 4312
      showinfo The number of users connected to the entire network and the highest number of users ever connected to the entire network
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.301) {
      set -u %::text Yes
      showinfo Shows if a user is away and the reason if specified
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.302) {
      showinfo This is returned in reply to a "userhost" request
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.307) {
      set -u %::isreged Is
      showinfo This tells you if a users nickname is registered or not
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.310) {
      set -u %::text is available for help.
      showinfo This tells you if a user is available for help
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.311) {
      set -u %::realname Mr.Man
      showinfo This is sent as part of a reply to a "whois" request. It contains the user's identd and address as well as their "real name"
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.312) {
      set -u %::wserver irc.evorev.com
      set -u %::serverinfo The Best IRC Server
      showinfo This is sent as part of a reply to a "whois" request. It contains the server a user is connected to
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.313) {
      set -u %::isoper is
      set -u %::text Blah
      showinfo This is sent as part of a reply to a "whois" request, if the user is an IRC operator
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.314) {
      set -u %::realname Mr.Man
      showinfo This is sent as part of a reply to a "whowas" request. It contains the user's identd and address as well as their "real name"
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(whois),44) %event
    }
    if (%event == raw.315) {
      set -u %::value #NXG
      showinfo This is sent at the end of a "who" request
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.317) {
      set -u %::idletime 6789 
      set -u %::signontime 12345
      showinfo This is sent as part of a reply to a "whois" request, if the user is on the same server as you. It includes the number of seconds the user is idle as well as when they signed on to IRC
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.318) {
      showinfo This is sent at the end of a "whois" request
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.319) {
      showinfo This is sent as part of a reply to a "whois" request. It contains the channels a user is on
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.324) {
      set -u %::modes +nr
      showinfo This is returned for a "mode" request
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.329) {
      set -u %::text 123456
      showinfo The time the channel was created
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.331) {
      showinfo This is returned for a "topic" request if the channel has no current topic
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.332) {
      set -u %::text Welcome to #NXG
      showinfo This is returned for a "topic" request or when you join, if the channel has a topic
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(topic),44) %event
    }
    if (%event == raw.333) {
      set -u %::text 123456
      showinfo The user who last set the channel topic
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.352) {
      set -u %::text 123456
      set -u %::realname Mr.Man
      set -u %::cmode @
      showinfo This is returned by a "who" request, one line for each user that is matched
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.353) {
      set -u %::text 123456
      showinfo This is returned for a "names" request for a channel, or when you initially join a channel. It contains a list of every user on the channel
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.366) {
      showinfo This is returned at the end of a "names" list, after all visible names are returned
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.369) {
      showinfo This is returned at the end of a "whowas" request
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.375) {
      showinfo This is sent in reply to a MOTD request or on connection
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.376) {
      showinfo This is sent in reply to a MOTD request or on connection. This should be the last raw sent in reply, after the text of the message of the day itself
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.378) {
      set -u %::text EvoREV Network
      showinfo This is sent in reply to a "motd" request or on connection
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.379) {
      set -u %::text You are now an IRC Operator
      showinfo This is sent when you become an ircop
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.421) {
      set -u %::value BLAH
      showinfo Returned when you use an IRC command that the server does not recognize
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.401) {
      showinfo Returned when a message is sent to a user, but the user disconnects from the network before they receive it
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.402) {
      showinfo Returned when trying to send a command to a server that does not exist
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.403) {
      showinfo Returned when trying to use a command on a channel that is currently empty
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.422) {
      showinfo Returned instead of the Message of the Day if the server does not have a MOTD file
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.433) {
      showinfo Returned when trying to change your nickname to a nickname that someone else is using
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.442) {
      showinfo Returned when you attempt to perform a channel command on a channel you are not on
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.471) {
      showinfo Returned when attempting to join a channel that has already reached its user limit
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.473) {
      showinfo Returned when attempting to join a channel that is invite only 
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.474) {
      showinfo Returned when attempting to join a channel that you are banned from
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.475) {
      showinfo Returned when attempting to join a channel that has a key set
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.482) {
      showinfo Returned when attempting to use a command that requires you to be a channel operator
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == raw.other) {
      set -u %::text Information
      showinfo This is for any raw not set in the theme
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TIMESTAMP) {
      showinfo Turn your global timestamp on/off $crlf $crlf Use ON or OFF
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == TIMESTAMPFORMAT) {
      showinfo Set your global timestamp here $crlf $crlf $+ Formatting Codes: yy = Year, mm = Month, dd = Day, hh = Hours, nn = Minutes, ss = Seconds, tt = am/pm
      edit_preview $gettok($theme_entry(COLORS),$mts_colours(normal),44) %event
    }
    if (%event == IMAGEMIRC) {
      showhint Double Click for Background Options
      showinfo This is to set the background of the mIRC window
    }
    if (%event == IMAGESTATUS) {
      showhint Double Click for Background Options
      showinfo This is to set the background of the Staus window
    }
    if (%event == IMAGESWITCHBAR) {
      showhint Double Click for Background Options
      showinfo This is to set the background of the Switchbar
    }
    if (%event == IMAGETOOLBAR) {
      showhint Double Click for Background Options
      showinfo This is to set the background of the Toolbar
    }
    if (%event == IMAGEBUTTONS) {
      showhint Double Click for Buttons Graphic File
      showinfo This is to set the buttons of the Toolbar
    }
    if (%event == CLINEOWNER) {
      var %col = $theme_entry(CLINEOWNER)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINESOP) {
      var %col = $theme_entry(CLINESOP)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINEOP) {
      var %col = $theme_entry(CLINEOP)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINEHOP) {
      var %col = $theme_entry(CLINEHOP)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINEVOICE) {
      var %col = $theme_entry(CLINEVOICE)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINEREGULAR) {
      var %col = $theme_entry(CLINEREGULAR)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
    if (%event == CLINEME) {
      var %col = $theme_entry(CLINEME)
      if (%col != $null) {
        edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%col + 1),32)
        ;did -ar mts 27 %col
        showhint Double Click for Colour Selector
        showinfo These settings are for the colours each type of user will use.
        return
      }
    }
  }
  var %i = 1
  var %tcols = 1,1,1 2,2,2 3,3,3 4,4,4 5,5,5 6,6,6 7,7,7 8,8,8 9,9,9 10,10,10 11,11,11 12,12,12 13,13,13 14,14,14 15,15,15 16,16,16
  while (%i <= 16) {
    var %r = $rgb( [ $gettok(%tcols,%i,32) ] )
    if ($gettok(%r,2,44)) { var %r = $rgb( [ %r ] ) }
    if (%r) {
      drawreplace -nr @tpreview $color($calc(%i -1)).rgb %r
    }
    inc %i
  }
  var %i = 1
  while (%i <= 16) {
    var %r = $rgb( [ $gettok($theme_entry(RGBCOLORS),%i,32) ] )
    if ($gettok(%r,2,44)) { var %r = $rgb( [ %r ] ) }
    if (%r) {
      drawreplace -nr @tpreview $rgb( [ $gettok(%tcols,%i,32) ] ) %r
    }
    inc %i
  }
  drawcopy @tpreview 0 0 485 30 @tpreview 0 0
}

on *:dialog:mts:edit:27:{
  .timer 1 0 updatepreview
  commitchanges
}

alias commitchanges {
  ;---WRITE CHANGES---
  if ($did(mts,22).text) {
    var %setting = $seltext(mts,26), %value = $gettext, %scheme = $replace($did(mts,30).text,$chr(32),_), %events = Background.Action.CTCP Text.Highlight.Info.Info2.Invite Text.Join Text.Kick Text.Mode Text.Nick Text.Normal Text.Notice Text.Notify Text.Other.Own.Part Text.Quit Text.Topic Text.Wallops.Whois.Editbox.Editbox Text.Listbox.Listbox Text.Inactive.Gray.Title
    if ($istok(00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15,%setting,32)) {
      var %cols = $puttok($theme_entry(RGBCOLORS),%value,$calc(%setting + 1),32)
      var %line = $fline(@ $+ %scheme,RGBCOLORS *,1,1)
      if (%line) {
        rline @ $+ %scheme %line RGBCOLORS %cols
        return
      }
      else {
        aline @ $+ %scheme RGBCOLORS %cols
        return
      }
    }
    else if ($istok(%events,%setting,46)) {
      if (%value != $null) {
        var %pos = $findtok(%events,%setting,1,46)
        var %cols = $puttok($theme_entry(COLORS),%value,%pos,44)
        var %line = $fline(@ $+ %scheme,COLORS *,1,1)
        if (%line) {
          rline @ $+ %scheme %line COLORS %cols
          return
        }
        else {
          aline @ $+ %scheme COLORS %cols
          return
        }
      }
    }
    else {
      var %line = $fline(@ $+ %scheme,%setting *,1,1)
      if (%line) {
        rline @ $+ %scheme %line %setting %value
        return
      }
      else {
        aline @ $+ %scheme %setting %value
        return
      }
    }
  }
}

alias edit_colour {
  if ($numtok($1,44) == 3) {
    drawfill -r @tpreview $rgb( [ [ $1 ] ] ) $rgb( [ [ $1 ] ] ) 0 0
  }
}

alias showhint {
  if ($1-) {
    var %w = $width($1-,Tahoma,11), %h = $height($1-,Tahoma,11), %x = $calc($calc(485 - %w) / 2), %y = $calc($calc(30 - %h) / 2), %b = $getdot(@tpreview,0,0)
    if (%b == 0) {
      var %c = 0
    }
    else {
      var %c = 1)
    }
    drawtext -p @tpreview %c Tahoma 11 %x %y $1-
  }
}

alias edit_timestamp {
  if ($theme_entry(TIMESTAMP) == ON) {
    var %tempts = $timestampfmt 
    .timestamp -f $theme_entry(TIMESTAMPFORMAT)
    var %ts = $mts_parse(-p,$timestamp)
    .timestamp -f %tempts
    return %ts
  }
  else {
    return $null
  }
}

alias edit_preview {
  if ($theme_entry($2)) {
    var %t = $ifmatch, %font = $theme_entry(FONTDEFAULT)
    set -u %:echo drawtext -p @tpreview $1 $gettok(%font,1,44) $gettok(%font,2,44) 2 1 $edit_timestamp
    %t = $mts_parse(-p,%t)
    if ($2) {
      if ($gettok(%t,1,32) == !script) {
        if ($gettok(%t,3-,32)) {
          tokenize 32 %t
          $2-
        }
      }
      else {
        %:echo $(%t,3)
      }
    }
  }
}

alias seltext {
  var %d = $1, %i = $2, %b = $gettok($did(%d,%i,1),4-,32), %n = $calc($numtok(%b,32) -1)
  if (%n = 0) { 
    did -i %d %i 1 cb root
  }
  else {
    did -i %d %i 1 cb root $gettok(%b,1- $+ %n,32)
  }
  return $gettok($gettok($did(%d,%i,$gettok(%b,-1,32)),7-,32),1,9)
}

on *:dialog:mts:sclick:2:{
  var %dir = $sdir(C:,Select Themes Dir...)
  hadd mts_settings Theme_Dir %dir
  did -r mts 3
  var %f = $findfile($hget(mts_settings,theme_dir),*.mts,0,did -a mts 3 $nopath($1-))
}

on *:dialog:mts:sclick:28:{
  var %file = $+(",$did(mts,22).text,")
  if (%file) {
    .timer 1 0 dosavetheme %file
  }
}

alias dosavetheme {
  .remove $replace($1-,.mts,.bak)
  .rename $1- $replace($1-,.mts,.bak)
  savethemefromedit
  set %f $did(mts,22).text
  mts_preload %f
  mts_loadscheme $calc($did(mts,30).sel - 1) %f   
  mts_preview
}

on *:dialog:mts:sclick:30:{
  hadd mts_settings editing $replace($did($dname,30).seltext,$chr(32),_)
  var %sel = $seltext($dname,26)
  var %cols = Background.Action.CTCP Text.Highlight.Info.Info2.Invite Text.Join Text.Kick Text.Mode Text.Nick Text.Normal Text.Notice Text.Notify Text.Other.Own.Part Text.Quit Text.Topic Text.Wallops.Whois Text.Editbox.Editbox Text.Listbox.Listbox Text.Inactive.Gray.Title
  var %i = $findtok(%cols,%sel,1,46)
  edit_colour $rgb($color($gettok($theme_entry(COLORS),%i,44)))
  showhint Double Click for Colour Selector
}

on *:dialog:mts:sclick:3:{
  var %n = $findfile($hget(mts_settings,theme_dir),$did(mts,3).seltext,0, set %f $1-)
  mts_preload %f
  did -ra mts 14 %f
  did -ra mts 19 $hget(mts_preload,DESCRIPTION)
  did -ra mts 37 $hget(mts_preload,NAME)
  did -ra mts 38 $hget(mts_preload,VERSION) (Standard $hget(mts_preload,MTSVERSION) $+ )
  did -ra mts 39 $hget(mts_preload,AUTHOR)
  did -ra mts 40 $hget(mts_preload,EMAIL)
  did -ra mts 41 $hget(mts_preload,WEBSITE)
  mts_preview
}

on *:dialog:mts:sclick:5:{
  var %f = $nofile($hget(mts_settings,theme_file))
  var %n = $hget(mts_settings,theme_script)
  if ($exists($+(",%f,%n,"))) {
    .load -rs $+(",%f,%n,")
  }
  if ($hget(theme_edit)) {
    hfree theme_edit
  }
  if ($dialog(cpanel)) {
    dialog -v cpanel
  }
}

on *:dialog:mts:sclick:6:{
  %s = $calc($did(mts,9).sel - 1)
  if (%s < 0) { %s = 0 }
  dialog -x mts mts
  mts_do_load
  if (%s > 0) || (%f) { mts_loadscheme %s %f }
  if ($dialog(cpanel)) {
    dialog -v cpanel
  }
}

on *:dialog:mts:sclick:9:{
  %s = $calc($did(mts,9).sel - 1)
  if (%s == 0) { mts_preload %f }
  else if (%s > 0) || (%f) { mts_loadscheme %s %f }
  mts_preview
}

on *:dialog:mts:sclick:11:{
  hadd mts_settings nicklist $did(mts,11).state
}

on *:dialog:mts:sclick:20:{
  if ($hget(mts_settings,Theme_Loaded) == YES) {
    theme.unload
  }
}

;---COLOUR PICKER DIALOG---

alias colourpicker {
  dialog -m colourpicker colourpicker
}

dialog colourpicker {
  title "Pick a Colour"
  size -1 -1 170 45
  option pixels
}

on *:dialog:colourpicker:init:0:{
  dcx Mark $dname colourpicker_cb
  xdialog -c $dname 1 colorcombo 10 10 150 30
  var %cols = $theme_entry(RGBCOLORS), %l = 1
  if (%cols) {
    while (%l <= 16) {
      xdid -a $dname 1 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
      inc %l
    }
  }
  else {
    xdid -m $dname 1
  }
}

alias colourpicker_cb {
  if ($2 == sclick) {
    var %c = $calc($4 - 1)
    did -ar mts 27 $base(%c,10,10,2)
    dialog -x colourpicker
    edit_colour $rgb($color(%c))
    commitchanges
    showhint Double Click for Colour Selector
  }
}

;---NICK COLOUR PICKER DIALOG---

alias nickcolourpicker {
  dialog -m nickcolourpicker nickcolourpicker
}

dialog nickcolourpicker {
  title "Pick a Colour"
  size -1 -1 170 45
  option pixels
}

on *:dialog:nickcolourpicker:init:0:{
  dcx Mark $dname nickcolourpicker_cb
  xdialog -c $dname 1 colorcombo 10 10 150 30
  var %cols = $theme_entry(RGBCOLORS), %l = 1
  if (%cols) {
    while (%l <= 16) {
      xdid -a $dname 1 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
      inc %l
    }
  }
  else {
    xdid -m $dname 1
  }
}

alias nickcolourpicker_cb {
  if ($2 == sclick) {
    var %c = $calc($4 - 1)
    did -ar mts 27 $base(%c,10,10,2)
    dialog -x nickcolourpicker
    edit_colour $gettok($theme_entry(RGBCOLORS),$calc(%c + 1),32)
    commitchanges
    showhint Double Click for Colour Selector
  }
}

;---BASECOLOURS PICKER DIALOG---

alias basecolourpicker {
  dialog -m basecolourpicker basecolourpicker
}

dialog basecolourpicker {
  title "Select BaseColours"
  size -1 -1 211 169
  option pixels
  text "<c1>:", 1, 10 18 35 16
  text "<c2>:", 2, 10 49 35 16
  text "<c3>:", 3, 10 80 35 16
  text "<c4>:", 4, 10 111 35 16
  button "OK", 9, 135 142 75 25
}

on *:dialog:basecolourpicker:init:0:{
  dcx Mark $dname basecolourpicker_cb
  xdialog -c $dname 5 colorcombo 50 14 150 25
  var %cols = $theme_entry(RGBCOLORS), %l = 1
  while (%l <= 16) {
    xdid -a $dname 5 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
    inc %l
  }
  xdialog -c $dname 6 colorcombo 50 45 150 25
  var %l = 1
  while (%l <= 16) {
    xdid -a $dname 6 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
    inc %l
  }
  xdialog -c $dname 7 colorcombo 50 76 150 25
  var %l = 1
  while (%l <= 16) {
    xdid -a $dname 7 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
    inc %l
  }
  xdialog -c $dname 8 colorcombo 50 107 150 25
  var %l = 1
  while (%l <= 16) {
    xdid -a $dname 8 0 $rgb( [ [ $gettok(%cols,%l,32) ] ] )
    inc %l
  }
  tokenize 44 $gettext
  xdid -c $dname 5 $calc($1 + 1)
  xdid -c $dname 6 $calc($2 + 1)
  xdid -c $dname 7 $calc($3 + 1)
  xdid -c $dname 8 $calc($4 + 1)
}

on *:dialog:basecolourpicker:sclick:9:{
  var %c1 = $calc($xdid($dname,5).sel - 1)
  var %c2 = $calc($xdid($dname,6).sel - 1)
  var %c3 = $calc($xdid($dname,7).sel - 1)
  var %c4 = $calc($xdid($dname,8).sel - 1)
  did -ar mts 27 $base(%c1,10,10,2) $+ , $+ $base(%c2,10,10,2) $+ , $+ $base(%c3,10,10,2) $+ , $+ $base(%c4,10,10,2)
  commitchanges
  dialog -x $dname
  showhint Double Click for BaseColours Selector
}

alias basecolourpicker_cb {
  noop
}

;---COLOUR MAKER DIALOG---

alias colourmaker {
  hadd various coltoedit $gettext
  dialog -m selector selector
}

dialog selector {
  title "Colour Selector"
  size -1 -1 349 252
  option pixels
  tab "Colour", 11, 4 73 338 144
  text "R:", 1, 21 121 20 16, tab 11 right
  text "G:", 2, 21 144 20 16, tab 11 right
  text "B:", 3, 21 168 20 16, tab 11 right
  list 5, 43 141 161 23, tab 11 size
  list 6, 43 165 161 23, tab 11 size
  edit "0", 7, 207 118 41 21, tab 11
  edit "0", 8, 207 142 41 21, tab 11
  edit "0", 9, 207 166 41 21, tab 11
  list 4, 43 117 161 23, tab 11 size
  button "", 10, 252 119 67 67, tab 11
  box "Selection", 12, 15 99 316 101, tab 11
  button "OK", 13, 283 223 60 22, ok
  button "Cancel", 14, 220 223 60 22, cancel
  icon 15, -2 0 352 64, $scriptdir $+ libraries\icons\colselheader.png, noborder
}

on *:dialog:selector:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 4 TrackBar > $bars
  mdx SetBorderStyle $dname 4 windowedge
  did -i $dname 4 1 params 0 0 255 1 5 * * *
  did -i $dname 4 1 ticfreq 5
  did -i $dname 4 1 params 0 * * * * * *
  mdx SetControlMDX $dname 5 TrackBar > $bars
  mdx SetBorderStyle $dname 5 windowedge
  did -i $dname 5 1 params 0 0 255 1 5 * * *
  did -i $dname 5 1 ticfreq 5
  did -i $dname 5 1 params 0 * * * * * *
  mdx SetControlMDX $dname 6 TrackBar > $bars
  mdx SetBorderStyle $dname 6 windowedge
  did -i $dname 6 1 params 0 0 255 1 5 * * *
  did -i $dname 6 1 ticfreq 5
  did -i $dname 6 1 params 0 * * * * * *
  window -hpfkniB @selector
  mdx SetControlMDX $dname 10 window > $dlg
  did -a $dname 10 grab $window(@selector).hwnd @selector
  if ($hget(various,coltoedit)) {
    did -i $dname 4 1 params $gettok($ifmatch,1,44) * * * * * *
    did -i $dname 5 1 params $gettok($ifmatch,2,44) * * * * * *
    did -i $dname 6 1 params $gettok($ifmatch,3,44) * * * * * *
    did -ar $dname 7 $gettok($did(4,1),1,32)
    did -ar $dname 8 $gettok($did(5,1),1,32)
    did -ar $dname 9 $gettok($did(6,1),1,32)
    setselected 0 $+ $did($dname,7).text $+ , $+ 0 $+ $did($dname,8) $+ , $+ 0 $+ $did($dname,9)
  }
}

on *:dialog:selector:sclick:4:{
  did -ar $dname 7 $gettok($did(4,1),1,32)
  setselected $did($dname,7).text $+ , $+ $did($dname,8) $+ , $+ $did($dname,9)
}

on *:dialog:selector:sclick:5:{
  did -ar $dname 8 $gettok($did(5,1),1,32)
  setselected $did($dname,7).text $+ , $+ $did($dname,8) $+ , $+ $did($dname,9)
}

on *:dialog:selector:sclick:6:{
  did -ar $dname 9 $gettok($did(6,1),1,32)
  setselected $did($dname,7).text $+ , $+ $did($dname,8) $+ , $+ $did($dname,9)
}

on *:dialog:selector:edit:7:{
  did -i $dname 4 1 params $did($dname,7) * * * * * *
  setselected 0 $+ $did($dname,7).text $+ , $+ 0 $+ $did($dname,8) $+ , $+ 0 $+ $did($dname,9)
}

on *:dialog:selector:edit:8:{
  did -i $dname 5 1 params $did($dname,8) * * * * * *
  setselected 0 $+ $did($dname,7).text $+ , $+ 0 $+ $did($dname,8) $+ , $+ 0 $+ $did($dname,9)
}

on *:dialog:selector:edit:9:{
  did -i $dname 6 1 params $did($dname,9) * * * * * *
  setselected 0 $+ $did($dname,7).text $+ , $+ 0 $+ $did($dname,8) $+ , $+ 0 $+ $did($dname,9)
}

alias setselected {
  drawfill -r @selector $rgb( [ [ $1 ] ] ) $rgb( [ [ $1 ] ] ) 0 0
}

on *:dialog:selector:sclick:13:{
  var %col = $did($dname,7).text $+ , $+ $did($dname,8) $+ , $+ $did($dname,9)
  did -ar mts 27 %col
  edit_colour %col
  commitchanges
}

;---THEME APPLICATION PROGRESS---

alias theme_progress {
  if ($dialog(cpanel)) {
    dialog -x cpanel
  }
  dialog -m theme_progress theme_progress
}

dialog theme_progress {
  title "Applying Theme..."
  size -1 -1 374 303
  option pixels
  icon 1, 0 0 373 62,  $shortfn($scriptdir $+ libraries\icons\logo.png), 0
  text "Please wait while your theme is applied...", 10, 36 100 261 16
  button "OK", 4, 308 269 60 25, ok
  text "______________________________________________________________________", 2, 1 247 375 16, disable
  text "", 9, 36 124 300 16
  text "You have successfully loaded your theme. If the Treeview colours need changing, open the Control Panel, select Various, Treeview Tab, and change the colours to your taste. If the nicklist is not the correct colour, open the Control Panel, select Nicklist, and make the neccessary changes, then click Apply.", 3, 36 150 300 80, hide
}

on *:dialog:theme_progress:init:0: {
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 9 Progressbar > $ctl
  did -b $dname 4
}

on *:dialog:theme_progress:sclick:4: {
}

alias bgoptions {
  dialog -m bgoptions bgoptions
}

dialog bgoptions {
  title "Select Option..."
  size -1 -1 128 178
  option pixels
  radio "Center", 1, 10 10 64 20
  radio "Fill", 2, 10 33 64 20
  radio "Normal", 3, 10 56 64 20
  radio "Stretch", 4, 10 79 64 20
  radio "Tile", 5, 10 102 64 20
  radio "Photo", 6, 10 125 64 20
  radio "None", 7, 10 148 64 20
}

on *:dialog:bgoptions:sclick:*: {
  if ($did == 1) {
    %i = $did(mts,27).text
    did -ar mts 27 center %i
    dialog -x $dname
  }
  if ($did == 2) {
    %i = $did(mts,27).text
    did -ar mts 27 fill %i
    dialog -x $dname
  }
  if ($did == 3) {
    %i = $did(mts,27).text
    did -ar mts 27 normal %i
    dialog -x $dname
  }
  if ($did == 4) {
    %i = $did(mts,27).text
    did -ar mts 27 stretch %i
    dialog -x $dname
  }
  if ($did == 5) {
    %i = $did(mts,27).text
    did -ar mts 27 tile %i
    dialog -x $dname
  }
  if ($did == 6) {
    %i = $did(mts,27).text
    did -ar mts 27 photo %i
    dialog -x $dname
  }
  if ($did == 7) {
    dialog -x $dname
  }
  commitchanges
}
