;---Nick Completer by mr.man (c) 2004 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias nickcompleter {
  dialog -m nc nc
}

alias -l inifile {
  return $+(",$scriptdir,settings\ncomp.ini,")
}

alias -l savesettings {
  if (!%restart) {
    var %t = ncomp
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = ncomp
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hload -i %t $inifile Settings
}

alias setncstyles {
  var %t = ncomp
  hadd %t dec_left $read($scriptdir $+ settings\ncdec.dat,$calc($1 * 2))
  hadd %t dec_right $read($scriptdir $+ settings\ncdec.dat,$calc(($1 * 2) + 1))
  hadd %t name_left $read($scriptdir $+ settings\ncname.dat,$calc($2 * 2))
  hadd %t name_right $read($scriptdir $+ settings\ncname.dat,$calc(($2 * 2) + 1))
}

alias -l genpreview {
  window -hpfkniB +d @ncpreview -1 -1 355 32 Tahoma 20
  drawtext -p @ncpreview $color(normal text) 10 5 $decorate($me)
  var %ncpreview = " $+ $scriptdir $+ preview.bmp $+ "
  drawsave @ncpreview %ncpreview
  did -g nc 3 %ncpreview
  .remove %ncpreview
  window -c @ncpreview
}

alias -l savencstyles {
  var %t = ncomp
  write -l $+ $calc($1 * 2) $+(",$scriptdir,settings\ncdec.dat,") $hget(%t,dec_left)
  write -l $+ $calc(($1 * 2) + 1) $+(",$scriptdir,settings\ncdec.dat,") $hget(%t,dec_right)
  write -l $+ $calc($2 * 2) $+(",$scriptdir,settings\ncname.dat,") $hget(%t,name_left)
  write -l $+ $calc(($2 * 2) + 1) $+(",$scriptdir,settings\ncname.dat,") $hget(%t,name_right)
}

;---VARIOUS EVENTS---

on *:start:{
  var %t = ncomp
  loadsettings
  setncstyles $hget(%t,NameDecor) $hget(%t,SideDecor)
}

on 1:exit:{
  savesettings
}

on *:input:*: {
  var %t = ncomp
  if (($me ison $active) && ($left($1,1) != /) && ($right($1,1) == $hget(%t,Trigger)) && ($1 != $hget(%t,Trigger))) {
    if ($istok($hget(%t,words),$left($1,-1),44)) { msg $active $trans($1-) | halt }
    var %nc.loop = 0
    set %nc.matches 0
    while (%nc.loop <= $nick($active,0)) {
      inc %nc.loop 1
      if ($left($1,-1) isin $nick($chan,%nc.loop)) {
        inc %nc.matches
        set %nc.match. $+ %nc.matches $nick($active,%nc.loop)
      }
    }
    if (%nc.matches == 0) { msg $active $trans($1-) | unset %nc.* | halt }
    elseif (%nc.matches == 1) {
      if ($istok($hget(blowfish,keys),$active,44)) {
        .!msg $active $encrypt($hget(blowfish,$active),$decorate(%nc.match.1) $+  $trans($2-))
        say $decorate(%nc.match.1) $+  $trans($2-)
      }
      else {
        msg $active $decorate(%nc.match.1) $+  $trans($2-)
      }
      unset %nc.match.* %nc.matches
      halt
    }
    else { set %nc.saytext $trans($2-) | dialog -m nchoice nchoice | halt }
  }
}

dialog nchoice {
  title "Select Nick..."
  size -1 -1 200 154
  option pixels
  list 1, 10 10 180 110
  button  "Cancel", 2, 65 117 60 26, cancel
  button  "Okay", 3, 130 117 60 26, ok
}

on 1:dialog:nchoice:init:0: {
  var %loop = 1
  inc %nc.matches
  while (%loop < %nc.matches) {
    var %temp = $chr(37) $+ nc.match. $+ %loop
    did -a nchoice 1 [ [ %temp ] ] 
    inc %loop
  }
  did -c nchoice 1 1
}

on 1:dialog:nchoice:sclick:2: {
  unset %nc.match.* %nc.matches %nc.saytext
  halt
}

on 1:dialog:nchoice:sclick:3: {
  var %temp = $did(nchoice,1).seltext
  if ($istok($hget(blowfish,keys),$active,44)) {
    say $encrypt($hget(blowfish,$active),$decorate(%temp) $+  $trans(%nc.saytext))
  }
  else {
    say $decorate(%temp) $+  $trans(%nc.saytext))
  }
  unset %nc.match.* %nc.matches %nc.saytext
}

;---MAIN DECORATION ALIAS---

alias decorate {
  var %t = ncomp
  setncstyles $hget(%t,SideDecor) $hget(%t,NameDecor)
  %nc.t.left = $left($1,$calc($len($1) / 2))
  if ($right($len($1),1) isin 13579) {
    %nc.t.mid = $mid($1,$calc(($len($1) / 2) + 1),1)
    %nc.t.odd = $true
  }
  else {
    %nc.t.mid = $null
    %nc.t.odd = $false
  }
  %nc.t.right = $right($1,$calc($len($1) / 2))
  %nc.t.nickname = $1
  if (%nc.t.nickname !isnum) {
    ;BOLD MODE 1 = FIRST CHARACTER BOLD
    if ($hget(%t,Bold) == 1) && ($hget(%t,Underline) == 0) {
      %nc.t.nickname = $+(,$hget(%t,Colour),,$left(%nc.t.nickname,1),,$hget(%t,Colour),$right(%nc.t.nickname,-1))
    }
    ;BOLD MODE 2 = RANDOM CHARACTER BOLD
    if ($hget(%t,Bold) == 2) && ($hget(%t,Underline) == 0) {
      %nc.t.char = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.nickname = $+(,$hget(%t,Colour),$replace(%nc.t.nickname,%nc.t.char, $+ %nc.t.char $+  $+  $+ $hget(%t,Colour)))
    }      
    ;UNDERLINE MODE 1 = FIRST CHARACTER UNDERLINED
    if ($hget(%t,Underline) == 1) && ($hget(%t,Bold) == 0) {
      %nc.t.nickname = $+(,$hget(%t,Colour),,$left(%nc.t.nickname,1),,$hget(%t,Colour),$right(%nc.t.nickname,-1))
    }
    ;UNDERLINE MODE 2 = RANDOM CHARACTER UNDERLINED
    if ($hget(%t,Underline) == 2) && ($hget(%t,Bold) == 0) {
      %nc.t.char = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.nickname = $+(,$hget(%t,Colour),$replace(%nc.t.nickname,%nc.t.char, $+ %nc.t.char $+  $+  $+ $hget(%t,Colour)))
    }
    ;BOLD AND UNDERLINE MODE 1 = FIRST CHAR BOLD & UNDERLINE
    if ($hget(%t,Bold) == 1) && ($hget(%t,Underline) == 1) {
      %nc.t.nickname = $+(,$hget(%t,Colour),,$left(%nc.t.nickname,1),,$hget(%t,Colour),$right(%nc.t.nickname,-1))
    }
    ;BOLD AND UNDERLINE MODE 2 - FIRST CHAR BOLD & RANDOM UNDERLINE
    if ($hget(%t,Underline) == 2) && ($hget(%t,Bold) == 1) {
      %nc.t.char = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.nickname = $+(,$hget(%t,Colour),,$left(%nc.t.nickname,1),,$hget(%t,Colour),$replace($right(%nc.t.nickname,-1),%nc.t.char, $+ %nc.t.char $+  $+  $+ $hget(%t,Colour)))
    }
    ;BOLD AND UNDERLINE MODE 3 - RANDOM CHAR BOLD & FIRST UNDERLINE
    if ($hget(%t,Underline) == 1) && ($hget(%t,Bold) == 2) {
      %nc.t.char = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.nickname = $+(,$hget(%t,Colour),,$left(%nc.t.nickname,1),,$hget(%t,Colour),$replace($right(%nc.t.nickname,-1),%nc.t.char, $+ %nc.t.char $+  $+  $+ $hget(%t,Colour)))
    }
    ;BOLD AND UNDERLINE MODE 4 - RANDOM BOLD RANDOM & RANDOM UNDERLINE
    if ($hget(%t,Underline) == 2) && ($hget(%t,Bold) == 2) {
      %nc.t.bchar = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.uchar = $mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1)
      %nc.t.nickname = $+(,$hget(%t,Colour),$replace(%nc.t.nickname,%nc.t.bchar, $+ %nc.t.bchar $+  $+  $+ $hget(%t,Colour)))
      %nc.t.nickname = $+(,$hget(%t,Colour),$replace(%nc.t.nickname,%nc.t.uchar, $+ %nc.t.uchar $+  $+ $hget(%t,Colour)))
    }
    ;ASCII MODE 1 = ASCIIFY ALL CHARACTERS
    if ($hget(%t,Ascii) == 1) {
      var %loop = 65
      while (%loop <= 90) {
        %nc.t.nickname = $replace($upper(%nc.t.nickname),$upper($chr(%loop)),$mid($hget(%t,Chars),$calc(%loop - 64),1))
        inc %loop
      }        
      ;COLOURS MODE 1 = RANDOM NICK COLOUR
      if ($hget(%t,Colours) == 1) { %nc.t.nickname =  $+ ?9 $+ %nc.t.nickname }
      ;COLOURS MODE 2 = RANDOM CHAR COLOUR
      ;---N/A---
      ;COLOURS MODE 3 = RANDOM NICK & CHAR COLOUR
      ;---N/A---
    }
    ;ASCII MODE 2 = ASCIIFY FIRST CHARACTER
    if ($hget(%t,Ascii) == 2) {
      ;COLOURS MODE 1 = RANDOM NICK COLOUR
      if ($hget(%t,Colours) == 1) {
        %nc.t.nickname =  $+ $mid($hget(%t,Chars),$calc($asc($upper($left(%nc.t.nickname,1))) - 64),1) $+  $+ ?9 $+ $right(%nc.t.nickname,-1)
      }
      ;COLOURS MODE 2 = RANDOM CHAR COLOUR
      if ($hget(%t,Colours) == 2) {
        %nc.t.nickname =  $+ ?8 $+ $mid($hget(%t,Chars),$calc($asc($upper($left(%nc.t.nickname,1))) - 64),1) $+  $+ $right(%nc.t.nickname,-1)
      }
      ;COLOURS MODE 3 = RANDOM NICK & CHAR COLOUR
      if ($hget(%t,Colours) == 3) {
        %nc.t.nickname =  $+ ?8 $+ $mid($hget(%t,Chars),$calc($asc($upper($left(%nc.t.nickname,1))) - 64),1) $+  $+ ?9 $+ $right(%nc.t.nickname,-1)
      }
    }
    ;ASCII MODE 3 = ASCIIFY RANDOM CHARACTER
    if ($hget(%t,Ascii) == 3) {
      :choose
      %nc.t.char = $upper($mid(%nc.t.nickname,$rand(1,$len(%nc.t.nickname)),1))
      if (%nc.t.char !isletter) { goto choose }
      ;COLOURS MODE OFF
      if ($hget(%t,Colours) == 0) {
        %nc.t.nickname = $+($replace(%nc.t.nickname,%nc.t.char,$mid($hget(%t,Chars),$calc($asc(%nc.t.char) - 64),1)))
      }
      ;COLOURS MODE 1 = RANDOM NICK COLOUR
      if ($hget(%t,Colours) == 1) {
        %nc.t.nickname =  $+ ?9 $+ $replace(%nc.t.nickname,%nc.t.char, $+ $mid($hget(%t,Chars),$calc($asc(%nc.t.char) - 64),1) $+  $+ ?9)
      }
      ;COLOURS MODE 2 = RANDOM CHAR COLOUR
      if ($hget(%t,Colours) == 2) {
        %nc.t.nickname =  $+ $replace(%nc.t.nickname,%nc.t.char, $+ ?8 $+ $mid($hget(%t,Chars),$calc($asc(%nc.t.char) - 64),1) $+ )
      }
      ;COLOURS MODE 3 = RANDOM NICK & CHAR COLOUR
      if ($hget(%t,Colours) == 3) {
        %nc.t.nickname =  $+ ?9 $+ $replace(%nc.t.nickname,%nc.t.char, $+ ?8 $+ $mid($hget(%t,Chars),$calc($asc(%nc.t.char) - 64),1) $+  $+ ?9)
      }
    }
    ;NORMAL NAME DECORATION MODE
    if ($hget(%t,Colours) == 0) && ($hget(%t,Underline) == 0) && ($hget(%t,Bold) == 0) && ($hget(%t,Ascii) == 0) {
      %nc.t.n.left = $hget(%t,name_left)
      var %loop = 1
      var %count = 0
      var %len = $len(%nc.t.left)
      %nc.t.lchars = %nc.t.left
      while (%loop <= %len) {
        var %rep = @ $+ %loop
        if (%rep isin %nc.t.n.left) {
          %count = $calc(%count + $count(%nc.t.n.left,%rep))
          %nc.t.lchars = $right(%nc.t.lchars,-1)
        }
        %nc.t.n.left = $replace(%nc.t.n.left,%rep,$mid(%nc.t.left,%loop,1))
        inc %loop
      }
      while (@ isin %nc.t.n.left) {
        %nc.t.n.left = $left(%nc.t.n.left,-1)
      }
      %nc.t.n.right = $hget(%t,name_right)
      var %loop = $len(%nc.t.right)
      var %count = 0
      var %num = 1
      %nc.t.rchars = %nc.t.right
      while (%loop > 0) {
        var %rep = @ $+ %loop
        if (%rep isin %nc.t.n.right) {
          %count = $calc(%count + $count(%nc.t.n.right,%rep))
          %nc.t.rchars = $left(%nc.t.rchars,-1)
        }
        %nc.t.n.right = $replace(%nc.t.n.right,%rep,$mid(%nc.t.right,%num,1))
        dec %loop
        inc %num
      }
      var %loop = 1
      while (%loop < 10) {
        var %rem = @ $+ %loop
        %nc.t.n.right = $remove(%nc.t.n.right,%rem)
        inc %loop
      }
      %nc.t.nickname = $+(%nc.t.n.left,%nc.t.lchars,%nc.t.mid,%nc.t.rchars,%nc.t.n.right)
    }
  }
  :done
  var %all = $+($hget(%t,dec_left),%nc.t.nickname,$hget(%t,dec_right))
  var %loop = 1
  while (%loop < 10) {
    %nc.t.rep = ? $+ %loop
    %nc.t.rnd = $rand($gettok($hget(%t,Range),1,44),$gettok($hget(%t,Range),2,44))
    var %pad = $null
    if (%nc.t.rnd < 10) { %pad = 0 }
    var %nc.t.new = %pad $+ %nc.t.rnd
    %all = $replace(%all,%nc.t.rep,%nc.t.new)
    inc %loop
  }
  unset %nc.t.*
  if ($istok($hget(%t,Mono),$active,44) || (c isin $chan($active).mode)) {
    %all = $strip(%all)
  }
  return %all
}

;---MAIN CONFIGURATION DIALOG---

dialog nc {
  title "Nick Completer"
  size -1 -1 360 407
  option pixels
  tab "L&&R", 4, 4 74 350 256
  edit "", 27, 68 122 259 23, tab 4 autohs
  text "Left:", 28, 33 126 31 16, tab 4
  text "Right:", 29, 33 157 31 16, tab 4
  edit "", 30, 68 153 259 23, tab 4 autohs
  edit "", 31, 27 280 48 23, disable tab 4
  button "<", 32, 77 280 30 23, tab 4
  button ">", 33, 111 280 30 23, tab 4
  button "New", 34, 233 280 46 23, tab 4
  button "Delete", 35, 283 280 46 23, tab 4
  text "These settings are for the decoration either side of the nickname. Use Ctrl+k for colours and make sure you use 2 digits for colour code (02, 03 etc.) Use Ctrl+b for bold, Ctrl+u for underline and Ctrl+o for normal text. You can also use ?1-?9 for random colours (Single digits for this)", 1, 39 194 289 67, tab 4
  box "Left + Right Decoration", 9, 13 98 333 219, tab 4
  tab "Name", 5
  edit "", 36, 27 280 48 23, disable tab 5
  button "<", 37, 77 280 30 23, tab 5
  button ">", 38, 111 280 30 23, tab 5
  button "New", 39, 233 280 46 23, tab 5
  button "Delete", 40, 283 280 46 23, tab 5
  text "Left:", 41, 33 126 31 16, tab 5
  text "Right:", 42, 33 157 31 16, tab 5
  edit "", 43, 68 122 259 23, tab 5 autohs
  edit "", 44, 68 153 259 23, tab 5 autohs
  text "This is for decoration of the name. Use @1, @2 etc. to represent each character. Ctrl+k = colour. Use 2 digits. ?1-?9 = random cols. Ctrl+b = bold, Ctrl+u = underline and Ctrl+o = normal.", 53, 39 194 289 67, tab 5
  box "Name Decoration", 67, 13 98 333 219, tab 5
  tab "Settings", 6
  box "Ignore Words", 45, 13 163 149 153, tab 6
  list 46, 24 183 125 119, tab 6 size
  text "Trigger:", 50, 21 124 40 16, tab 6
  edit "", 51, 63 120 31 23, tab 6
  box "Trigger", 68, 13 100 92 59, tab 6
  edit "", 61, 167 120 37 23, tab 6
  text "Name:", 62, 126 124 36 16, tab 6
  text "Range:", 63, 214 124 36 16, tab 6
  edit "", 64, 251 120 34 23, tab 6
  text "->", 66, 286 124 14 16, tab 6
  edit "", 65, 302 120 33 23, tab 6
  box "No Colours for these Channels", 56, 171 163 174 153, tab 6
  list 57, 182 183 149 119, tab 6 size
  box "Colours", 71, 113 100 232 59, tab 6
  tab "Options", 2
  text "Ascii Mode:", 8, 46 128 56 16, tab 2
  radio "Off", 7, 109 126 51 20, group tab 2
  radio "All", 10, 160 126 39 20, tab 2
  radio "First", 11, 206 126 51 20, tab 2
  radio "Random", 12, 258 126 65 20, tab 2
  text "Random Colour:", 13, 26 159 78 16, tab 2
  radio "Off", 14, 109 157 42 20, group tab 2
  radio "Nick", 15, 160 157 45 20, tab 2
  radio "Char", 16, 206 157 48 20, tab 2
  radio "Nick+Char", 17, 258 157 75 20, tab 2
  text "Bold Effect:", 18, 57 198 61 16, tab 2
  radio "Off", 19, 129 196 42 20, group tab 2
  radio "First", 20, 189 196 52 20, tab 2
  radio "Random", 21, 254 196 75 20, tab 2
  text "Underline Effect:", 22, 35 229 89 16, tab 2
  radio "Off", 23, 129 227 42 20, group tab 2
  radio "First", 24, 189 227 52 20, tab 2
  radio "Random", 25, 254 227 75 20, tab 2
  text "Turning on any of the above effects automatically disables the name decoration settings.", 26, 33 268 296 33, tab 2
  box "Options", 69, 12 98 334 219, tab 2
  icon 3, 5 367 348 32,  $mircexe, 0
  button "OK", 52, 280 335 75 22, ok
  button "Test", 54, 201 335 75 22
  icon 47, -2 0 363 64, $scriptdir $+ libraries\icons\ncheader.png, noborder
}

on *:dialog:nc:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 46 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 46 1 headerdims 100:1
  did -i $dname 46 1 headertext 0 Words
  mdx SetControlMDX 57 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 57 1 headerdims 120:1
  did -i $dname 57 1 headertext 0 Channels
  var %t = ncomp
  setncstyles $hget(%t,SideDecor) $hget(%t,NameDecor)
  if ($hget(%t,Ascii) == 0) { did -c nc 7 }
  if ($hget(%t,Ascii) == 1) { did -c nc 10 }
  if ($hget(%t,Ascii) == 2) { did -c nc 11 }
  if ($hget(%t,Ascii) == 3) { did -c nc 12 }
  if ($hget(%t,Colours) == 0) { did -c nc 14 }
  if ($hget(%t,Colours) == 1) { did -c nc 15 }
  if ($hget(%t,Colours) == 2) { did -c nc 16 }
  if ($hget(%t,Colours) == 3) { did -c nc 17 }
  if ($hget(%t,Bold) == 0) { did -c nc 19 }
  if ($hget(%t,Bold) == 1) { did -c nc 20 }
  if ($hget(%t,Bold) == 2) { did -c nc 21 }
  if ($hget(%t,Underline) == 0) { did -c nc 23 }
  if ($hget(%t,Underline) == 1) { did -c nc 24 }
  if ($hget(%t,Underline) == 2) { did -c nc 25 }
  did -a nc 27 $hget(%t,dec_left)
  did -a nc 30 $hget(%t,dec_right)
  did -a nc 31 $hget(%t,SideDecor)
  did -a nc 36 $hget(%t,NameDecor)
  did -a nc 43 $hget(%t,name_left)
  did -a nc 44 $hget(%t,name_right)
  did -a nc 51 $hget(%t,Trigger)
  ;didtok nc 46 44 $hget(%t,Words)
  fillncchans
  did -a nc 61 $hget(%t,Colour)
  did -a nc 64 $gettok($hget(%t,Range),1,44)
  did -a nc 65 $gettok($hget(%t,Range),2,44)
  ;didtok nc 57 44 $hget(%t,Mono)
  fillncwords
  genpreview
}

on *:dialog:nc:sclick:7:{
  if ($did(nc,7).state == 1) { hadd ncomp Ascii 0 }
}

on *:dialog:nc:sclick:10:{
  if ($did(nc,10).state == 1) { hadd ncomp Ascii 1 }
}

on *:dialog:nc:sclick:11:{
  if ($did(nc,11).state == 1) { hadd ncomp Ascii 2 }
}

on *:dialog:nc:sclick:12:{
  if ($did(nc,12).state == 1) { hadd ncomp Ascii 3 }
}

on *:dialog:nc:sclick:14:{
  if ($did(nc,14).state == 1) { hadd ncomp Colours 0 }
}

on *:dialog:nc:sclick:15:{
  if ($did(nc,15).state == 1) { hadd ncomp Colours 1 }
}

on *:dialog:nc:sclick:16:{
  if ($did(nc,16).state == 1) { hadd ncomp Colours 2 }
}

on *:dialog:nc:sclick:17:{
  if ($did(nc,17).state == 1) { hadd ncomp Colours 3 }
}

on *:dialog:nc:sclick:19:{
  if ($did(nc,19).state == 1) { hadd ncomp Bold 0 }
}

on *:dialog:nc:sclick:20:{
  if ($did(nc,20).state == 1) { hadd ncomp Bold 1 }
}

on *:dialog:nc:sclick:21:{
  if ($did(nc,21).state == 1) { hadd ncomp Bold 2 }
}

on *:dialog:nc:sclick:23:{
  if ($did(nc,23).state == 1) { hadd ncomp Underline 0 }
}

on *:dialog:nc:sclick:24:{
  if ($did(nc,24).state == 1) { hadd ncomp Underline 1 }
}

on *:dialog:nc:sclick:25:{
  if ($did(nc,25).state == 1) { hadd ncomp Underline 2 }
}

on *:dialog:nc:edit:27:{
  hadd ncomp dec_left $did(nc,27).text
  savencstyles $hget(%ncomp,SideDecor) $hget(ncomp,NameDecor)
}

on *:dialog:nc:edit:30:{
  hadd ncomp dec_right $did(nc,30).text
  savencstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
}

on *:dialog:nc:sclick:32:{
  if ($hget(ncomp,SideDecor) > 1) {
    hdec ncomp SideDecor
    did -ra nc 31 $hget(ncomp,SideDecor)
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
  did -ra nc 27 $hget(ncomp,dec_left)
  did -ra nc 30 $hget(ncomp,dec_right)
}

on *:dialog:nc:sclick:33:{
  var %max = $calc($calc($lines($scriptdirsettings\ncdec.dat) -1 ) / 2)
  if ($hget(ncomp,SideDecor) < %max) {
    hinc ncomp SideDecor
    did -ra nc 31 $hget(ncomp,SideDecor)
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
  did -ra nc 27 $hget(ncomp,dec_left)
  did -ra nc 30 $hget(ncomp,dec_right)
}

on *:dialog:nc:sclick:34:{
  ;---NEW---
  hadd ncomp SideDecor $calc($calc($lines($scriptdirsettings\ncdec.dat) -1 ) / 2 + 1)
  write -i $+(",$scriptdir,settings\ncdec.dat,")
  write -i $+(",$scriptdir,settings\ncdec.dat,")
  did -ra nc 27 $null
  hadd ncomp dec_left $null
  did -ra nc 30 $null
  hadd ncomp dec_right $null
  did -ra nc 31 $hget(ncomp,SideDecor) 
}

on *:dialog:nc:sclick:35:{
  ;---DELETE---
  var %max = $calc($calc($lines($scriptdir $+ settings\ncdec.dat) -1 ) / 2)
  write -dl $+ $calc($hget(ncomp,SideDecor) * 2) $+(",$scriptdir,settings\ncdec.dat,")
  write -dl $+ $calc($hget(ncomp,SideDecor) * 2) $+(",$scriptdir,settings\ncdec.dat,")
  if ($hget(ncomp,SideDecor) == %max) {
    hdec ncomp SideDecor    
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
  did -ra nc 27 $hget(ncomp,dec_left)
  did -ra nc 30 $hget(ncomp,dec_right)
  did -ra nc 31 $hget(ncomp,SideDecor)
}

on *:dialog:nc:sclick:37:{
  if ($hget(ncomp,NameDecor) > 1) {
    hdec ncomp NameDecor
    did -ra nc 36 $hget(ncomp,NameDecor)
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)  
  did -ra nc 43 $hget(ncomp,name_left)
  did -ra nc 44 $hget(ncomp,name_right)
}

on *:dialog:nc:sclick:38:{
  var %max = $calc($calc($lines($scriptdir $+ settings\ncname.dat) -1 ) / 2)
  if ($hget(ncomp,NameDecor) < %max) {
    hinc ncomp NameDecor
    did -ra nc 36 $hget(ncomp,NameDecor)
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
  did -ra nc 43 $hget(ncomp,name_left)
  did -ra nc 44 $hget(ncomp,name_right)
}

on *:dialog:nc:sclick:39:{
  ;---NEW---
  hadd ncomp NameDecor $calc($calc($lines($scriptdir $+ settings\ncname.dat) -1 ) / 2 + 1)
  write -i $+(",$scriptdir,settings\ncname.dat,")
  write -i $+(",$scriptdir,settings\ncname.dat,")
  did -ra nc 43 $null
  hadd ncomp name_left $null
  did -ra nc 44 $null
  hadd ncomp name_right $null
  did -ra nc 36 $hget(ncomp,NameDecor)
}

on *:dialog:nc:sclick:40:{
  ;---DELETE---
  var %max = $calc($calc($lines($scriptdir $+ settings\ncname.dat) -1 ) / 2)
  write -dl $+ $calc($hget(ncomp,NameDecor) * 2) $+(",$scriptdir,settings\ncname.dat,")
  write -dl $+ $calc($hget(ncomp,NameDecor) * 2) $+(",$scriptdir,settings\ncname.dat,")
  if ($hget(ncomp,NameDecor) == %max) {
    hdec ncomp NameDecor
  }
  setncstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
  did -ra nc 43 $hget(ncomp,name_left)
  did -ra nc 44 $hget(ncomp,name_right)
  did -ra nc 36 $hget(ncomp,NameDecor)
}

on *:dialog:nc:edit:43:{
  hadd ncomp name_left $did(nc,43).text
  savencstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
}

on *:dialog:nc:edit:44:{
  hadd ncomp name_right $did(nc,44).text
  savencstyles $hget(ncomp,SideDecor) $hget(ncomp,NameDecor)
}

on *:dialog:nc:edit:51:{
  hadd ncomp Trigger $did(nc,51).text
}

on *:dialog:nc:sclick:52:{
  ;---OK BUTTON---
  dialog -v cpanel
}

on *:dialog:nc:sclick:54:{
  ;---TEST BUTTON---
  genpreview
}

on *:dialog:nc:sclick:46:{
  if ($gettok($did($dname,46,1),1,32) == rclick) {
    ncwordspop $did(46).sel $gettok($gettok($did(46).seltext,6,32),1,9)
  }
}

on *:dialog:nc:sclick:57:{
  if ($gettok($did($dname,57,1),1,32) == rclick) {
    ncchanpop $did(57).sel $gettok($gettok($did(57).seltext,6,32),1,9)
  }
}

on *:dialog:nc:sclick:59:{
  if ($did(nc,58) != $null) {
    hadd ncomp Mono $addtok($hget(ncomp,Mono),$did(nc,58),44)	
    didtok -ar nc 57 44 $hget(ncomp,Mono)
  }
}

on *:dialog:nc:sclick:60:{
  did -d nc 57 $did(nc,57).sel
}

on *:dialog:nc:edit:61:{
  hadd ncomp Colour $did(nc,61).text
}

on *:dialog:nc:edit:64:{
  hadd ncomp Range $did(nc,64).text $+ , $+ $did(nc,65)
}

on *:dialog:nc:edit:65:{
  hadd ncomp Range $did(nc,64).text $+ , $+ $did(nc,65)
}

alias ncchanpop {
  popups New ncchanpop 16 16
  popups SetMetrics ncchanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ncchanpop end + Add $cr newncchan
  popups AddItem ncchanpop end + Delete $cr delncchan $1 $2
  popup ncchanpop $mouse.dx $mouse.dy
}

alias newncchan {
  var %chan = $input(Please enter a Channel...,equ,Query...,$null)
  hadd ncomp Mono $addtok($hget(ncomp,Mono),%chan,44)
  did -r nc 57
  fillncchans
}

alias delncchan {
  did -d nc 57 $1
  hadd ncomp Mono $remtok($hget(ncomp,Mono),$2,44)
}

alias fillncchans {
  var %l = 1, %chans = $hget(ncomp,Mono)
  while (%l <= $numtok(%chans,44)) {
    var %chan = $gettok(%chans,%l,44) 
    did -a nc 57 + 0 0 0 %chan
    inc %l
  }
}

alias ncwordspop {
  popups New ncwordspop 16 16
  popups SetMetrics ncwordspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ncwordspop end + Add $cr newncword
  popups AddItem ncwordspop end + Delete $cr delncword $1 $2
  popup ncwordspop $mouse.dx $mouse.dy
}

alias newncword {
  var %word = $input(Please enter a word to ignore...,equ,Query...,$null)
  hadd ncomp Words $addtok($hget(ncomp,Words),%word,44)
  did -r nc 46
  fillncwords
}

alias delncword {
  did -d nc 46 $1
  hadd ncomp Words $remtok($hget(ncomp,Words),$2,44)
}

alias fillncwords {
  var %l = 1, %words = $hget(ncomp,Words)
  while (%l <= $numtok(%words,44)) {
    var %word = $gettok(%words,%l,44) 
    did -a nc 46 + 0 0 0 %word
    inc %l
  }
}
