;---Profile System by mr.man (c) 2005 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias id {
  var %n = $network
  if ($hget(%n,Services) == 1) {
    if ($hget(%n,NickServCommand)) {
      $replace($hget(%n,NickServCommand),<pass>,$hget(%n,NickServPass))
    }
    else {
      theme.error You have not set up a profile for this network.
    }
  }
}

alias a {
  var %n = $network
  if ($hget(%n,AwayNick)) {
    if (!$1) {
      nick $hget(%n,AwayNick)
      away $hget(various,awaymessage)
    }
    else {
      nick $replace($hget(%n,BusyNick),<a>,$1)
      away $hget(various,awaymessage)
    }
  }
  else {
    theme.error You have not set up a profile for this network.
  }
}

alias h {
  var %n = $network
  if ($hget(%n,Nick)) {
    nick $hget(%n,Nick)
    id
    if ($away) {
      away
      ;theme.text You are no longer marked Away
    }
  }
  else {
    theme.error You have not set up a profile for this network.
  }
}

alias back {
  h
}

alias d {
  var %n = $network
  if ($hget(%n,DownNick)) {
    nick $hget(%n,DownNick)
  }
  else {
    theme.error You have not set up a profile for this network.
  }
}

alias ad {
  var %n = $network
  if ($hget(%n,AwayDownNick)) {
    nick $hget(%n,AwayDownNick)
  }
  else {
    theme.error You have not set up a profile for this network.
  }
}

alias profile {
  dialog -m profile profile
}

alias -l inifile {
  return $+(",$scriptdir,settings\profile.ini,")
}

alias fillservers {
  did -r profile 19
  var %l = 1, %servers = $hget($1,ServerList)
  while (%l <= $numtok(%servers,32)) {
    var %server = $gettok(%servers,%l,32)
    var %port = $iif($gettok($gettok(%server,2,44),1,58) == DEFAULT,$null,$ifmatch)
    var %pass = $gettok($gettok(%server,2,44),2,58)
    did -a profile 19 + 0 0 0 $gettok(%server,1,44) %port $+ $chr(9) $+ + 0 0 0 %pass
    inc %l
  }
}

alias fillscmds {
  did -r profile 49
  var %l = 1, %cmds = $hget($1,Commands)
  while (%l <= $numtok(%cmds,96)) {
    var %cmd = $gettok(%cmds,%l,96)
    did -a profile 49 + 0 0 0 %cmd
    inc %l
  }
}

alias fillpchans {
  did -r profile 33
  var %l = 1, %chans = $hget($1,JoinChannels)
  while (%l <= $numtok(%chans,32)) {
    var %chan = $gettok($gettok(%chans,%l,32),1,44)
    var %key = $gettok($gettok(%chans,%l,32),2,44)
    did -a profile 33 + 0 0 0 %chan $+ $chr(9) $+ + 0 0 0 %key
    inc %l
  }
}

alias fillpchancmds {
  did -r profile 40
  var %l = 1, %cmds = $1-
  while (%l <= $numtok(%cmds,96)) {
    var %cmd = $gettok(%cmds,%l,96)
    did -a profile 40 + 0 0 0 %cmd
    inc %l
  }
}

alias -l display_profile {
  var %t = $1, %f = $+(",$scriptdir,profiles\,$1,.ini,"))
  if ($exists(%f)) {
    if (!$hget(%t)) { hmake %t 10 }
    hload -i %t %f Profile
    did -ra profile 8 $hget(%t,Nick)
    did -ra profile 11 $hget(%t,AwayNick)
    did -ra profile 13 $hget(%t,DownNick)
    did -ra profile 14 $hget(%t,AwayDownNick)
    did -ra profile 17 $hget(%t,BusyNick)
    did -ra profile 28 $hget(%t,NickServCommand)
    did -ra profile 30 $hget(%t,NickServPass)
    fillservers %t
    did -ra profile 22 $replace($hget(%t,PreferredServer),$chr(44),$chr(32))
    fillscmds %t
    fillpchans %t
    if ($hget(%t,AutoConnect) == 1) { did -c profile 26 }
    else { did -u profile 26 }
    if ($hget(%t,UsePreferred) == 1) { did -c profile 32 }
    else { did -u profile 32 }
    if ($hget(%t,Services) == 1) { did -c profile 55 }
    else { did -u profile 55 }
  }
}

alias -l error_msg {
  noop $input(Sorry... you cannot modify this part of the Default profile.,owu,Warning!,$null)
}

;---DIALOG STUFF---

dialog profile {
  title "Profile System"
  size -1 -1 437 458
  option pixels
  list 1, 4 105 105 316, size
  tab "Nicknames", 6, 116 75 315 350
  text "Main Nick:", 9, 142 129 55 16, tab 6
  edit "", 8, 236 124 162 23, tab 6 autohs
  text "Away Nick:", 10, 142 169 55 16, tab 6
  edit "", 11, 236 164 162 23, tab 6 autohs
  text "Down Nick:", 29, 142 211 55 16, tab 6
  edit "", 13, 236 206 162 23, tab 6 autohs
  text "Away/Down Nick:", 27, 142 252 89 16, tab 6
  edit "", 14, 236 247 162 23, tab 6 autohs
  text "Busy Nick Format:", 12, 142 293 91 16, tab 6
  edit "", 17, 236 288 162 23, tab 6 autohs
  text "Identify Command:", 15, 142 334 95 16, tab 6
  edit "", 28, 236 329 162 23, tab 6 autohs
  text "Identify Password:", 16, 142 372 93 16, tab 6
  edit "", 30, 236 367 162 23, tab 6 pass autohs
  box "Nicknames and ID", 5, 126 102 295 308, tab 6
  tab "Servers", 18
  text "Server List:", 20, 145 122 60 16, tab 18
  list 19, 142 140 261 89, tab 18 size
  text "Preferred Server:", 21, 142 238 88 16, tab 18
  edit "", 22, 234 234 169 23, tab 18
  check "Auto Connect", 26, 142 262 95 20, tab 18
  check "Use Preferred Server", 32, 278 262 125 20, tab 18
  text "Perform Commands:", 48, 142 307 100 16, tab 18
  list 49, 142 325 261 69, tab 18 size
  check "Network Uses Services (NickServ/ChanServ etc.)", 55, 142 282 257 20, tab 18
  box "Server Settings", 56, 126 102 295 308, tab 18
  tab "Channels", 31
  list 33, 142 143 260 135, tab 31 size
  text "Autojoin Channels:", 34, 144 125 103 16, tab 31
  text "Perform Commands:", 39, 143 287 107 16, tab 31
  list 40, 142 303 260 89, tab 31 size
  box "Channel Settings", 57, 126 102 295 308, tab 31
  button "OK", 7, 371 430 61 22, ok
  button "Connect", 54, 301 430 67 22
  text "Profile List:", 2, 8 85 96 16
  icon 3, -2 0 440 64, $scriptdir $+ libraries\icons\profileheader.png, noborder
}

on *:dialog:profile:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 1 listview single sortascending rowselect showsel noheader noscroll smallicon > $views
  did -i $dname 1 1 headerdims 130:1
  did -i $dname 1 1 headertext 0 Profiles
  mdx SetControlMDX 19 listview single rowselect showsel alignleft report > $views
  did -i $dname 19 1 headerdims 170:1 65:2
  did -i $dname 19 1 headertext 0 Server $+ $chr(9) $+ 0 Password
  mdx SetControlMDX 49 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 49 1 headerdims 235:1
  did -i $dname 49 1 headertext 0 Commands
  mdx SetControlMDX 33 listview single rowselect showsel alignleft report > $views
  did -i $dname 33 1 headerdims 155:1 80:2
  did -i $dname 33 1 headertext 0 Channel $+ $chr(9) $+ 0 Key
  mdx SetControlMDX 40 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 40 1 headerdims 240:1
  did -i $dname 40 1 headertext 0 Commands
  didtok profile 1 44 $readini($inifile,Settings,Profiles)
}

on *:dialog:profile:sclick:1: {
  if ($gettok($did($dname,1,1),1,32) == sclick) {
    did -r profile 40
    display_profile $gettok($gettok($did(1).seltext,6,32),1,9)
  }
  else if ($gettok($did($dname,1,1),1,32) == rclick) {
    profilepop $did(1).sel $gettok($gettok($did(1).seltext,6,32),1,9)
  }
}

on *:dialog:profile:sclick:7:{
  ;---OK BUTTON---
  var %n = $gettok($gettok($did(1).seltext,6,32),1,9)
  if (%n) && (%n != Default) {
    hadd %n Nick $did(profile,8)
    hadd %n AwayNick $did(profile,11)
    hadd %n DownNick $did(profile,13)
    hadd %n AwayDownNick $did(profile,14)
    hadd %n BusyNick $did(profile,17)
    hadd %n NickServCommand $did(profile,28)
    hadd %n NickServPass $did(profile,30)
    hadd %n PreferredServer $did(profile,22)
    hadd %n AutoConnect $did(profile,26).state
    hadd %n UsePreferred $did(profile,32).state
    hadd %n Services $did(profile,55).state
    var %f = $+(",$scriptdir,profiles\,%n,.ini,"))
    hsave -i %n %f Profile
    if ($dialog(cpanel)) {
      dialog -v cpanel
    }
  }
}

on *:dialog:profile:edit:8: {
  var %n = $network
  var %t = $did(profile,8).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s Nick %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:11: {
  var %n = $network
  var %t = $did(profile,11).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s AwayNick %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:13: {
  var %n = $network
  var %t = $did(profile,13).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s DownNick %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:14: {
  var %n = $network
  var %t = $did(profile,14).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s AwayDownNick %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:17: {
  var %n = $network
  var %t = $did(profile,17).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s BusyNick %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:28: {
  var %n = $network
  var %t = $did(profile,28).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s NickservCommand %t
  hsave -i %s %f Profile
}

on *:dialog:profile:edit:30: {
  var %n = $network
  var %t = $did(profile,30).text
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s NickservPass %t
  hsave -i %s %f Profile
}

on *:dialog:profile:sclick:19: {
  ;SERVERLIST
  if ($gettok($did($dname,19,1),1,32) == rclick) {
    pserverpop $did(19).sel $gettok($gettok($did(19).seltext,6,32),1,9)
  }
}

on *:dialog:profile:sclick:26: {
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s AutoConnect $did(profile,26).state
  hsave -i %s %f Profile  
}

on *:dialog:profile:sclick:32: {
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s UsePreferred $did(profile,32).state
  hsave -i %s %f Profile  
}

on *:dialog:profile:sclick:33: {
  ;CHANNEL LIST
  if ($gettok($did($dname,1,1),1,32) == sclick) {
    var %n = $network
    var %c = $right($gettok($gettok($did(33).seltext,6,32),1,9),-1)
    var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
    fillpchancmds $hget(%s,$+(%c,Commands))
  }
  if ($gettok($did($dname,33,1),1,32) == rclick) {
    pchanpop $did(33).sel $gettok($gettok($did(33).seltext,6,32),1,9)
  }
}

on *:dialog:profile:sclick:55: {
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  hadd %s Services $did(profile,55).state
  hsave -i %s %f Profile  
}

on *:dialog:profile:sclick:40: {
  ;CHAN COMMANDS LIST
  if ($gettok($did($dname,40,1),1,32) == rclick) {
    pchancmdspop $did(40).sel $gettok($gettok($did(40).seltext,6,32),1,9)
  }
}

on *:dialog:profile:sclick:49: {
  ;SERVER COMMANDS CLICK
  if ($gettok($did($dname,49,1),1,32) == rclick) {
    pservercmdspop $did(49).sel $gettok($gettok($did(49).seltext,6,32),1,9)
  }
}  

on *:dialog:profile:sclick:54: {
  ;CONNECT NOW
  var %s = 1, %c = $false, %server
  var %p = $gettok($gettok($did(1).seltext,6,32),1,9)
  while (%s <= $scon(0)) {
    if (%p == $scon(%s).network) {
      %c = $true
    }
    inc %s
  }
  if ($hget(%p,UsePreferred)) {
    %server = $replace($hget(%p,PreferredServer),$chr(44),$chr(32))
  }
  else {
    %server = $replace($gettok($hget(%p,ServerList),1,32),$chr(44),$chr(32))
  }
  if (%c) {
    server %server
  }
  else if (!%c) {
    if ($scid(1).status == disconnected) {
      server %server
    }
    else {
      server -m %server
    }
  }
}

;---POPUPS---

alias pchancmdspop {
  popups New pchancmdspop 16 16
  popups SetMetrics pchancmdspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem pchancmdspop end + Add $cr newpchancmd
  popups AddItem pchancmdspop end + Delete $cr delpchancmd $1 $2
  popup pchancmdspop $mouse.dx $mouse.dy
}

alias newpchancmd {
  ;ADD CHAN COMMANDS
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  if (%s == Default) { error_msg }
  else {
    var %t = $right($gettok($gettok($did(33).seltext,6,32),1,9),-1)
    if (%t) {
      var %p = $input(Please enter command. Do not use the "/" character.,equ,Query...,$null)
      var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
      if (%p) {
        %p = $remove(%p,/)
        did -a profile 40 + 0 0 0 %p $+ $chr(9)
      }
      hadd %s $+(%t,Commands) $addtok($hget(%s,$+(%t,Commands)),%p,96)
      hsave -i %s %f Profile
    }
    else {
      noop $input(Please select a channel.,owu,Warning!,$null)
    }
  }
}

alias delpchancmd {
  ;DELETE CHAN COMMANDS
  var %n = $network
  var %t = $did(profile,40).sel
  var %r = $right($did(profile,33).seltext,-1)
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  if (%t) {
    did -d profile 40 %t
    getpchancmds $right($gettok($gettok($did(33).seltext,6,32),1,9),-1)
    hsave -i %s %f Profile
  }
}

alias getpchancmds {
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9), %lines = $did(profile,40).lines, %l = 2, %cmds, %details
  while (%l <= %lines) {
    %cmds = $gettok($gettok($did(profile,40,%l),1,9),6-,32)
    if (%cmds) {
      %details = $addtok(%details,$(%cmds,1),96)
    }
    inc %l
  }
  hadd %s $+($1,Commands) %details
}

alias pservercmdspop {
  popups New pservercmdspop 16 16
  popups SetMetrics pservercmdspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem pservercmdspop end + Add $cr newpservercmd
  popups AddItem pservercmdspop end + Delete $cr delpservercmd $1 $2
  popup pservercmdspop $mouse.dx $mouse.dy
}

alias newpservercmd {
  ;ADD SERVER COMMANDS
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  if (%s == Default) { error_msg }
  else {
    var %p = $input(Please enter command. Do not use the "/" character.,equ,Query...,$null)
    var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
    if (%p) {
      %p = $remove(%p,/)
      did -a profile 49 %p
    }
    hadd %s $+(%t,Commands) $addtok($hget(%s,$+(%t,Commands)),%p,96)
    hsave -i %s %f Profile
  }
}

alias delpservercmd {
  ;DELETE SERVER COMMANDS
  var %n = $network
  var %t = $did(profile,49).sel
  var %r = $right($did(profile,33).seltext,-1)
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  if (%t) {
    did -d profile 49 %t
    getpservercmds
    hsave -i %s %f Profile
  }
}

alias getpservercmds {
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9), %lines = $did(profile,49).lines, %l = 2, %cmds, %details
  while (%l <= %lines) {
    %cmds = $gettok($gettok($did(profile,49,%l),1,9),6-,32)
    if (%cmds) {
      %details = %details $(%cmds,1)
    }
    inc %l
  }
  hadd %s Commands %details
}

alias profilepop {
  popups New profilepop 16 16
  popups SetMetrics profilepop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem profilepop end + Add $cr newprofile
  popups AddItem profilepop end + Delete $cr delprofile $1 $2
  popup profilepop $mouse.dx $mouse.dy
}

alias newprofile {
  var %p = $input(Please enter a new Profile name. This should match the networks name you wish to use the profile on.,equ,Query...,$network)
  if (%p) && (!$hget(%p)) {
    var %d = $+(",$scriptdir,profiles\,Default,.ini,"))
    var %f = $+(",$scriptdir,profiles\,%p,.ini,"))
    if (!$exists(%f)) {
      .copy %d %f
    }
    did -a profile 1 %p
    var %a = $readini($inifile,Settings,Profiles)
    writeini $inifile Settings Profiles $addtok(%a,%p,44)
    if ($hget(%p)) { hfree %p }
    hmake %p 10
  }
}

alias delprofile {
  var %t = $gettok($gettok($did(1).seltext,6,32),1,9)
  if (%t == Default) {
    var %q = $input(You cannot delete the Default Profile,owu,Warning!,$null)
  }
  else {
    var %q = $input(Are you sure you want to delete this profile?,qu,Query...,$null)
    if (%q) {
      var %t = $gettok($gettok($did(1).seltext,6,32),1,9)
      var %f = $+(",$scriptdir,profiles\,%t,.ini,"))
      if ($exists(%f)) {
        .remove %f
      }
      hfree %t
      did -d profile 1 $1
      var %p = $readini($inifile,Settings,Profiles)
      writeini $inifile Settings Profiles $remtok(%p,%t,44)
      did -r profile 8,11,30,28,13,14,17
    }
  } 
}

alias pserverpop {
  popups New pserverpop 16 16
  popups SetMetrics pserverpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem pserverpop end + Add $cr newpserver
  popups AddItem pserverpop end + Delete $cr delpserver $1 $2-
  popups AddItem pserverpop end + Edit $cr editpserver $1 $2
  popups AddItem pserverpop end + 
  popups AddItem pserverpop end + Make Preferred $cr prefpserver $1 $2
  popup pserverpop $mouse.dx $mouse.dy
}

alias delpserver {
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  var %t = $gettok($gettok($did(19).seltext,6,32),1,9)
  if (%t) {
    did -d profile 19 $1
    getpservers
  }
}

alias getpservers {
  var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  var %lines = $did(profile,19).lines, %l = 2, %server, %port, %pass, %details
  while (%l <= %lines) {
    %server = $gettok($gettok($did(profile,19,%l),1,9),6,32)
    %port = $gettok($gettok($did(profile,19,%l),1,9),7,32)
    %pass = $gettok($gettok($did(profile,19,%l),2,9),5,32)
    if (!%port) {
      %port = DEFAULT
    }
    if (%pass) {
      %details = %details %server $+ , $+ %port $+ : $+ %pass
    }
    else {
      %details = %details %server $+ , $+ %port
    }
    inc %l
  }
  hadd %s Serverlist %details
  hsave -i %s %f Profile
}

alias prefpserver {
  var %n = $network
  var %t = $gettok($gettok($did(19).seltext,6,32),1,9)
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  if (%t) {
    did -ar profile 22 %t
    hadd %s PreferredServer $did(profile,22)
    hsave -i %s %f Profile
  }
}

alias pchanpop {
  popups New pchanpop 16 16
  popups SetMetrics pchanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem pchanpop end + Add $cr newpchan
  popups AddItem pchanpop end + Delete $cr delpchan $1 $2
  popups AddItem pchanpop end + 
  popups AddItem pchanpop end + Edit $cr editpchan $1 $2
  popup pchanpop $mouse.dx $mouse.dy
}

alias delpchan {
  var %n = $network
  var %s = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
  var %t = $gettok($gettok($did(33).seltext,6,32),1,9)
  if (%t) {
    did -d profile 33 $1
    getpchans
    hsave -i %s %f Profile
  }
}

alias getpchans {
  var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9), %lines = $did(profile,33).lines, %l = 2, %chan, %key, %details
  while (%l <= %lines) {
    %chan = $gettok($gettok($did(profile,33,%l),1,9),6,32)
    %key = $gettok($gettok($did(profile,33,%l),2,9),5,32)
    if (%key) {
      %details = %details %chan $+ , $+ %key
    }
    else {
      %details = %details %chan
    }
    inc %l
  }
  hadd %s JoinChannels %details
}

;---EVENTS STUFF---

alias load_hashes {
  var %l = 1
  var %s = $readini($inifile,Settings,Profiles)
  var %n = $numtok(%s,44)
  while (%l <= %n) {
    var %p = $gettok(%s,%l,44)
    if ($hget(%p)) { hfree %p }
    hmake %p 10
    var %f = $+(",$scriptdir,profiles\,%p,.ini,"))
    hload -i %p %f Profile
    inc %l
  }
}

alias -l makegeneralsettingshash {
  var %t = general
  if ($hget(%t)) { hfree %t }
  hmake %t 10
}

alias connect_profiles {
  makegeneralsettingshash
  load_hashes
  var %l = 1
  var %s = $readini($inifile,Settings,Profiles)
  var %n = $numtok(%s,44)
  while (%l <= %n) {
    var %p = $gettok(%s,%l,44)
    if (%p != Default) {
      if ($hget(%p,AutoConnect) == 1) {
        if ($hget(%p,UsePreferred) == 1) {
          if (%l == 2) { server $hget(%p,PreferredServer) }
          else { server -m $hget(%p,PreferredServer) }
        }
        else {
          var %r = $rand(1,$numtok($hget(%p,Serverlist),32))
          var %m = $gettok($hget(%p,Serverlist),%r,32)
          var %server = $gettok(%m,1,44)
          var %port = $iif($gettok($gettok(%m,2,44),1,58) == DEFAULT,$null,$ifmatch)
          var %pass = $gettok($gettok(%m,2,44),2,58)
          if (%l == 2) { server %server %port %pass }
          else { server -m %server %port %pass }
        }
      }
    }   
    inc %l
  }
}

on *:connect:{
  var %n = $network
  ;.timerconnect 1 2 update.switchbar
  if ($hget(%n,Nick)) {
    nick $hget(%n,Nick)
    if ($hget(%n,NickServCommand)) && ($hget(%n,Services)) {
      $replace($hget(%n,NickServCommand),<pass>,$hget(%n,NickServPass))
    }
    if ($hget(%n,Commands)) {
      var %c = $ifmatch
      var %j = $numtok(%c,96)
      var %l = 1
      while (%l <= %j) {
        $($gettok(%c,%l,96),2)
        inc %l
      }
    }
    if ($hget(%n,JoinChannels)) {
      var %c = $ifmatch
      var %j = $numtok(%c,32)
      var %l = 1
      while (%l <= %j) {
        var %v = $gettok(%c,%l,32)
        var %k = $right($gettok(%c,%l,32),-1)
        join %v $hget(%n,$+(%k,Key))
        inc %l
      }
    }
  }
}

on *:join:#:{
  if ($nick == $me) {
    var %n = $network
    var %c = $chan
    var %k = $right(%c,-1)
    var %l = $hget(%n,$+(%k,Commands))
    var %i = $numtok(%l,96)
    var %d = 1
    while (%d <= %i) {
      $($gettok(%l,%d,96),2)
      inc %d
    }
  }
}

on *:notice:*:*:{
  if ($nick == NickServ) {
    if (This nickname is registered * iswm $1-) {
      id
    }
  }
}

raw 433:*:{
  var %l = 1, %s = $null
  while (%l <= $scon(0)) {
    if ($scon(%l).network == $network) {
      %s = %l
    }
    inc %l
  }
  if ($hget($network,Services)) {
    if ($hget($network,Nick)) {
      scon %s
      nickserv ghost $2 $hget($network,NickServPass)
      nick $hget($network,Nick)
      id
    }
  }
}

;---MORE DIALOGS---

alias newpserver {
  dialog -m newpserver newpserver
}

dialog newpserver {
  title "Server"
  size -1 -1 250 266
  option pixels
  tab "Add...", 1, 4 72 240 161
  box "Server Details", 2, 13 97 223 123, tab 1
  edit "", 3, 91 124 131 23, tab 1 autohs
  text "Server Name:", 4, 23 129 66 16, tab 1 right
  text "Server Port:", 5, 23 156 66 16, tab 1 right
  edit "", 6, 91 151 131 23, tab 1 autohs
  text "Password:", 7, 23 183 66 16, tab 1 right
  edit "", 8, 91 178 131 23, tab 1 autohs
  button "OK", 9, 182 238 63 22, ok
  button "Cancel", 10, 116 238 63 22, cancel
  icon 11, -2 0 253 64, $scriptdir $+ libraries\icons\newpserverheader.png, noborder
}

on *:dialog:newpserver:init:0: {
  did -f $dname 3
}

on *:dialog:newpserver:sclick:9: {
  var %server = $did($dname,3)
  var %port = $did($dname,6)
  if (!%port) {
    %port = DEFAULT
  }
  var %pass = $did($dname,8)
  if (%server) {
    var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
    if (%s == Default) {
      error_msg
      return
    }
    else if {%s) {
      var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
      did -a profile 19 + 0 0 0 %server $iif(%port == DEFAULT,$null,%port) $+ $chr(9) $+ + 0 0 0 %pass
      var %newserver = %server $+ , $+ %port $+ : $+ %pass
      hadd %s Serverlist $addtok($hget(%s,ServerList),%newserver,32)
      hsave -i %s %f Profile
    }
    else {
      noop $input(Please select a profile to edit.,owu,Warning!,$null)
    }
  }    
}    

alias editpserver {
  dialog -m editpserver editpserver
  var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
  var %port = $gettok($gettok($gettok($hget(%s,ServerList),$calc($1 - 1),32),2,44),1,58)
  var %pass = $gettok($gettok($gettok($hget(%s,ServerList),$calc($1 - 1),32),2,44),2,58)
  did -ar editpserver 3 $2
  did -ar editpserver 6 $iif(%port == DEFAULT,$null,%port)
  did -arf editpserver 8 %pass
}

dialog editpserver {
  title "Server"
  size -1 -1 252 267
  option pixels
  tab "Edit...", 1, 5 73 240 161
  box "Server Details", 2, 14 98 223 123, tab 1
  edit "", 3, 92 125 131 23, tab 1 autohs
  text "Server Name:", 4, 24 130 66 16, tab 1 right
  text "Server Port:", 5, 24 157 66 16, tab 1 right
  edit "", 6, 92 152 131 23, tab 1 autohs
  text "Password:", 7, 24 184 66 16, tab 1 right
  edit "", 8, 92 179 131 23, tab 1 autohs
  button "OK", 9, 183 239 63 22, ok
  button "Cancel", 10, 117 239 63 22, cancel
  icon 11, -2 0 255 64, $scriptdir $+ libraries\icons\editpserverheader.png, noborder
}

on *:dialog:editpserver:sclick:9: {
  var %server = $did($dname,3)
  var %port = $did($dname,6)
  if (!%port) {
    %port = DEFAULT
  }
  var %pass = $did($dname,8)
  if (%server) {
    var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
    if (%s == Default) {
      error_msg
      return
    }
    else if {%s) {
      var %l = $did(profile,19).sel
      var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
      did -d profile 19 %l
      did -a profile 19 + 0 0 0 %server $iif(%port == DEFAULT,$null,%port) $+ $chr(9) $+ + 0 0 0 %pass
      getpservers
    }
    else {
      noop $input(Please select a profile to edit.,owu,Warning!,$null)
    }
  }    
}

alias newpchan {
  dialog -m newpchan newpchan
}

dialog newpchan {
  title "Channel"
  size -1 -1 253 247
  option pixels
  tab "Add...", 1, 5 74 240 138
  box "Channel Details", 2, 14 99 223 100, tab 1
  edit "", 3, 72 126 153 23, tab 1 autohs
  text "Channel:", 4, 24 131 45 16, tab 1 right
  text "Key:", 5, 24 158 45 16, tab 1 right
  edit "", 6, 72 153 153 23, tab 1 autohs
  button "OK", 9, 183 217 63 22, ok
  button "Cancel", 10, 117 217 63 22, cancel
  icon 7, -2 0 256 64, $scriptdir $+ libraries\icons\newpchanheader.png, noborder
}

on *:dialog:newpchan:init:0: {
  did -f $dname 3
}

on *:dialog:newpchan:sclick:9: {
  var %chan = $did($dname,3)
  var %key = $did($dname,6)
  if (%chan) {
    var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
    if (%s == Default) {
      error_msg
      return
    }
    else if {%s) {
      var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
      did -a profile 33 + 0 0 0 %chan $+ $chr(9) $+ + 0 0 0 %key
      var %newchan = %chan $+ , $+ %key
      hadd %s JoinChannels $addtok($hget(%s,JoinChannels),%newchan,32)
      hsave -i %s %f Profile
    }
    else {
      noop $input(Please select a profile to edit.,owu,Warning!,$null)
    }
  }
}

alias editpchan {
  dialog -m editpchan editpchan
  var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
  did -ar editpchan 3 $2
  did -arf editpchan 6 $gettok($gettok($hget(%s,JoinChannels),$calc($1 - 1),32),2,44)
}

dialog editpchan {
  title "Channel"
  size -1 -1 251 244
  option pixels
  tab "Edit...", 1, 5 73 240 138
  box "Channel Details", 2, 14 98 223 100, tab 1
  edit "", 3, 72 125 153 23, tab 1 read autohs
  text "Channel:", 4, 24 130 45 16, tab 1 right
  text "Key:", 5, 24 157 45 16, tab 1 right
  edit "", 6, 72 152 153 23, tab 1 autohs
  button "OK", 9, 183 216 63 22, ok
  button "Cancel", 10, 117 216 63 22, cancel
  icon 7, -2 0 256 64, $scriptdir $+ libraries\icons\editpchanheader.png, noborder
}

on *:dialog:editpchan:sclick:9: {
  var %chan = $did($dname,3)
  var %key = $did($dname,6)
  if (%chan) {
    var %s = $gettok($gettok($did(profile,1).seltext,6,32),1,9)
    if (%s == Default) {
      error_msg
      return
    }
    else if {%s) {
      var %l = $did(profile,33).sel
      var %f = $+(",$scriptdir,profiles\,%s,.ini,"))
      did -d profile 33 %l
      did -a profile 33 + 0 0 0 %chan $+ $chr(9) $+ + 0 0 0 %key
      getpchans
      hsave -i %s %f Profile
    }
    else {
      noop $input(Please select a profile to edit.,owu,Warning!,$null)
    }
  }
}
