;---Seen System by mr.man (c) 2008 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias seen {
  if (!$dialog(seen)) {
    dialog -m seen seen
  }
}

alias -l inifile {
  return $+(",$scriptdir,settings\seen.ini,")
}

alias -l savesettings {
  if (!%restart) {
    var %t = seen
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = seen
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hload -i %t $inifile Settings
}

;---SOME EVENTS---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

;---DIALOGS STUFF---

dialog seen {
  title "Seen System"
  size -1 -1 361 292
  option pixels
  tab "Settings", 2, 4 71 351 187
  box "Output", 10, 215 148 132 45, tab 2
  box "Public Trigger", 5, 215 94 132 52, tab 2
  box "Networks/Channels", 3, 12 94 196 152, tab 2
  check "Seen System Active", 8, 4 264 119 20, tab 2
  button "OK", 9, 281 264 75 22, tab 2 ok
  check "", 6, 229 113 20 20, tab 2
  edit "", 7, 253 111 80 23, tab 2
  list 4, 22 112 175 123, tab 2 size
  button "Flush Data", 11, 202 264 75 22, tab 2
  radio "Chan", 12, 231 164 42 20, tab 2
  radio "Notice", 13, 278 164 52 20, tab 2
  box "Search For", 14, 215 196 132 50, tab 2
  edit "", 15, 225 212 98 23, tab 2
  button "!", 16, 325 214 13 20, tab 2
  icon 1, -2 0 363 64,  $scriptdir $+ libraries\icons\seenheader.png, 0, noborder
}

on *:dialog:seen:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 4 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 4 1 headerdims 155:1
  did -i $dname 4 1 headertext 0 Network/Channel
  if ($hget(seen,active)) {
    did -c $dname 8
  }
  if ($hget(seen,public)) {
    did -c $dname 6
  }
  fillseenchans
  if ($hget(seen,notice)) {
    did -c $dname 13
  }
  else {
    did -c $dname 12
  }
  did -ar $dname 7 $hget(seen,trigger)
}

on *:dialog:seen:sclick:4:{
  if ($gettok($did($dname,4,1),1,32) == rclick) {
    seenchanpopup $did(4).sel $gettok($gettok($did(4).seltext,6,32),1,9)
  }
}

on *:dialog:seen:sclick:6:{
  hadd seen public $did($dname,6).state
}

on *:dialog:seen:edit:7:{
  hadd seen trigger $did($dname,7)
}

on *:dialog:seen:sclick:8:{
  hadd seen active $did($dname,8).state
  if ($hget(seen,active)) {
    .enable #seensys
  }
  else {
    .disable #seensys
  }
}

on *:dialog:seen:sclick:11:{
  noop $findfile($scriptdir\seendb,*,0,.remove $+(",$1-,"))
}

on *:dialog:seen:sclick:12:{
  hadd seen notice 0
}

on *:dialog:seen:sclick:13:{
  hadd seen notice 1
}

on *:dialog:seen:sclick:16:{
  searchforuser $did($dname,15)
}

;---POPUPS---

alias seenchanpopup {
  popups New seenchanpop 16 16
  popups SetMetrics seenchanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem seenchanpop end + Add $cr addseenchan
  popups AddItem seenchanpop end + Delete $cr delseenchan $1 $2
  popup seenchanpop $mouse.dx $mouse.dy
}

alias addseenchan {
  dialog -m seenchan seenchan
}

dialog seenchan {
  title "Seen Network/Channel"
  size -1 -1 282 246
  option pixels
  icon 1, -2 0 285 64, $scriptdir $+ libraries\icons\seenchanheader.png, noborder
  tab "Monitor", 2, 4 73 273 141
  box "Net/Channel", 5, 13 98 256 103, tab 2
  edit "", 6, 83 125 163 23, tab 2 autohs
  text "Network:", 7, 29 129 50 16, tab 2 right
  text "Channel:", 8, 29 159 50 16, tab 2 right
  edit "", 9, 83 155 163 23, tab 2 autohs
  button "OK", 3, 203 218 75 22, ok
  button "Cancel", 4, 123 218 75 22, cancel
}

on *:dialog:seenchan:init:0:{
  did -ar $dname 6 $network
  did -f $dname 6
  did -b $dname 3
}

on *:dialog:seenchan:sclick:3:{
  var %nc = $did($dname,6) $+ / $+ $did($dname,9)
  hadd seen chans $addtok($hget(seen,chans),%nc,44)
  did -r seen 4
  fillseenchans
}

on *:dialog:seenchan:edit:6:{
  if ($did($dname,6) && $did($dname,9)) {
    did -e $dname 3
  }
  else {
    did -b $dname 3
  }
}

on *:dialog:seenchan:edit:9:{
  if ($did($dname,6) && $did($dname,9)) {
    did -e $dname 3
  }
  else {
    did -b $dname 3
  }
}

alias fillseenchans {
  var %l = 1, %chans = $hget(seen,chans)
  while (%l <= $numtok(%chans,44)) {
    var %chan = $gettok(%chans,%l,44) 
    did -a seen 4 + 0 0 0 %chan
    inc %l
  }
}

;---WORK DONE HERE---

alias searchforuser {
  var %chan = $gettok($gettok($did(seen,4).seltext,6,32),1,9), %file = $replace($+(",$scriptdir,seendb\,%chan,.ini,"),/,.), %action = $readini(%file,$1,Action)
  if (%file) {
    if (%action == join) {
      var %time = $readini(%file,$1,Time), %chan = $readini(%file,$1,Channel), %msg = $1 joined %chan $duration($calc($ctime - %time)) ago.
      noop $input(%msg,o,User Info)
    }
    if (%action == part) {
      var %time = $readini(%file,$1,Time), %chan = $readini(%file,$1,Channel), %msg = $1 parted %chan $duration($calc($ctime - %time)) ago.
      noop $input(%msg,o,User Info)
    }
    if (%action == quit) {
      var %time = $readini(%file,$1,Time), %quit = $readini(%file,$1,Message), %msg = $1 quit with the message %quit $duration($calc($ctime - %time)) ago.
      noop $input(%msg,o,User Info)
    }
    if (%action == kick) {
      var %time = $readini(%file,$1,Time), %chan = $readini(%file,$1,Channel), %msg = $1 was kicked from %chan $duration($calc($ctime - %time)) ago.
      noop $input(%msg,o,User Info)
    }
    if (%action == nick) {
      var %time = $readini(%file,$1,Time), %nick = $readini(%file,$1,Nick), %msg = $1 changed nick to %nick $duration($calc($ctime - %time)) ago.
      noop $input(%msg,o,User Info)
    }
  }
}

#seensys on

on *:text:*:*:{
  if ($1 == $hget(seen,trigger)) && ($2) && ($hget(seen,active)) && ($hget(seen,public)) {
    var %src = $+($network,/,$chan)
    if ($istok($hget(seen,chans),%src,44)) {
      if ($2 == $nick) {
        var %msg = Is there a reason you're looking for yourself?
        if ($hget(seen,notice)) {
          .notice $nick %msg
        }
        else {
          msg $chan %msg
        }
      }
      else if ($2 ison $chan) {
        var %msg = $2 is here now. Maybe a visit to the opticians would be beneficial.
        if ($hget(seen,notice)) {
          .notice $nick %msg
        }
        else {
          msg $chan %msg
        }
      }
      else {
        $checkseen($2,%src)
      }
    }
  }
}

alias seenlog {
  return $+(",$scriptdir,seendb\,$replace($1-,/,.),.ini,")
}

alias checkseen {
  var %net = $gettok($2,1,47), %chan = $gettok($2,2,47)
  if (($right($1,1) == ]) || ($left($1,1) == [)) {
    var %nick $replace($1,[,@,],~)
  }
  else {
    var %nick $1
  }
  var %action = $readini($seenlog($2),%nick,Action)
  if (!%action) {
    var %msg = $1 has not visited %chan lately.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }
  }
  if (%action == join) {
    var %time = $readini($seenlog($2),%nick,Time), %chan = $readini($seenlog($2),%nick,Channel), %msg = $1 joined %chan $duration($calc($ctime - %time)) ago.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }
  }
  if (%action == part) { 
    var %time = $readini($seenlog($2),%nick,Time), %chan = $readini($seenlog($2),%nick,Channel), %msg = $1 left %chan $duration($calc($ctime - %time)) ago.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }
  }
  if (%action == quit) { 
    var %time = $readini($seenlog($2),%nick,Time), %quit = $readini($seenlog($2),%nick,Message), %msg = $1 quit with the message %quit $duration($calc($ctime - %time)) ago.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }


  }
  if (%action == kick) { 
    var %time = $readini($seenlog($2),%nick,Time), %chan = $readini($seenlog($2),%nick,Channel), %msg = $1 was kicked from %chan $duration($calc($ctime - %time)) ago.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }
  }
  if (%action == nick) { 
    var %time = $readini($seenlog($2),%nick,Time), %nick = $readini($seenlog($2),%nick,Nick), %msg = $1 changed nick to %nick $duration($calc($ctime - %time)) ago.
    if ($hget(seen,notice)) {
      .notice $nick %msg
    }
    else {
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan %msg
        }
        inc %n
      }
    }
  }
}

on *:join:#:{
  var %src = $+($network,/,$chan)
  if ($istok($hget(seen,chans),%src,44)) {
    if (($right($nick,1) == ]) || ($left($nick,1) == [)) {
      var %nick $replace($nick,[,@,],~)
    }
    else {
      var %nick $nick
    }
    writeini -n $seenlog(%src) %nick Action join
    writeini -n $seenlog(%src) %nick Channel $chan
    writeini -n $seenlog(%src) %nick Time $ctime
  }
}

on *:part:#:{
  var %src = $+($network,/,$chan)
  if ($istok($hget(seen,chans),%src,44)) {
    if (($right($nick,1) == ]) || ($left($nick,1) == [)) {
      var %nick $replace($nick,[,@,],~)
    }
    else {
      var %nick $nick
    }
    writeini -n $seenlog(%src) %nick Action part
    writeini -n $seenlog(%src) %nick Channel $chan
    writeini -n $seenlog(%src) %nick Time $ctime
  }
}

on *:quit:{
  var %c = 1
  while (%c <= $comchan($nick,0)) {
    var %src = $+($network,/,$comchan($nick,%c))
    if ($istok($hget(seen,chans),%src,44)) {
      if (($right($nick,1) == ]) || ($left($nick,1) == [)) {
        var %nick $replace($nick,[,@,],~)
      }
      else {
        var %nick $nick
      }
      writeini -n $seenlog(%src) %nick Action quit
      writeini -n $seenlog(%src) %nick Time $ctime
      writeini -n $seenlog(%src) %nick Message $1-
    }
    inc %c
  }
}

on *:kick:#:{
  var %src = $+($network,/,$chan)
  if ($istok($hget(seen,chans),%src,44)) {
    if (($right($knick,1) == ]) || ($left($knick,1) == [)) {
      var %nick $replace($knick,[,@,],~)
    }
    else {
      var %nick $knick
    }
    writeini -n $seenlog(%src) %nick Action kick
    writeini -n $seenlog(%src) %nick Channel $chan
    writeini -n $seenlog(%src) %nick Time $ctime
  }
}

on *:nick:{
  var %c = 1
  while (%c <= $comchan($newnick,0)) {
    var %src = $+($network,/,$comchan($newnick,%c))
    if ($istok($hget(seen,chans),%src,44)) {
      if (($right($nick,1) == ]) || ($left($nick,1) == [)) {
        var %nick $replace($nick,[,@,],~)
      }
      else {
        var %nick $nick
      }
      writeini -n $seenlog(%src) %nick Action nick
      writeini -n $seenlog(%src) %nick Nick $newnick
      writeini -n $seenlog(%src) %nick Time $ctime
    }
    inc %c
  }
}

#seensys end
