;---Sysinfo by mr.man (c) 2005 - (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias sysinfo {
  dialog -m sysinfo sysinfo
}

alias -l inifile {
  return $+(",$scriptdir,settings\sysinfo.ini,")
}

alias -l setdefsettings {
  var %t = sysinfo
  if ($hget(%t)) { hfree %t }
  hmake %t 10
}

alias -l loadsettings {
  var %t = sysinfo
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hload -i %t $inifile Settings
}

alias -l savesettings {
  var %t = sysinfo
  hsave -i %t $inifile Settings
}

alias -l genpreview {
  loadinfo Win32_OperatingSystem
  aline -p @sysinfoprev $preview
  noop $getinfo(close)
}

alias preview {
  return $s.head(OS:) $s.encleft $+ $s.value($getinfo(Caption) $getinfo(CSDVersion) $chr(40) $+ $getinfo(Version) $+ $chr(41)) $+ $s.encright $s.sep $s.head(Installed:) $s.encleft $+ $s.value($convdate($getinfo(InstallDate))) $+ $s.encright $s.sep $s.head(Uptime:) $s.encleft $+ $s.value($uptime(system,1)) $+ $s.encright $s.sep $s.head(Last Boot:) $s.encleft $+ $s.value($convdate($getinfo(LastBootUpTime))) $+ $s.encright
}

alias setfields {
  didtok sysinfo 32 32 $hget(sysinfo,availfields)
  didtok sysinfo 33 32 $hget(sysinfo,chosenfields)
}

;---DIALOG STUFF---

dialog sysinfo {
  title "System Information"
  size -1 -1 317 385
  option pixels
  tab "Formatting", 1, 4 74 308 280
  box "Values", 2, 15 160 289 58, tab 1
  text "Colour:", 4, 55 184 36 16, tab 1
  check "Underline:", 5, 200 181 66 20, tab 1 left
  check "Bold:", 6, 145 181 40 20, tab 1 left
  box "Headings", 7, 14 100 289 58, tab 1
  text "Colour:", 8, 54 125 36 16, tab 1
  check "Bold:", 10, 144 122 40 20, tab 1 left
  check "Underline:", 11, 202 122 66 20, tab 1 left
  box "Enclosure", 12, 15 220 289 58, tab 1
  text "Colour:", 14, 100 244 36 16, tab 1
  check "Bold:", 15, 176 242 40 20, tab 1 left
  check "Underline:", 16, 223 242 67 20, tab 1 left
  edit "", 17, 28 241 31 23, tab 1
  edit "", 18, 60 241 31 23, tab 1
  box "Seperator", 19, 15 280 289 60, tab 1
  edit "", 20, 28 301 63 23, tab 1
  text "Colour:", 22, 97 305 40 16, tab 1
  check "Bold:", 24, 176 303 40 20, tab 1 left
  check "Underline:", 25, 223 303 67 20, tab 1 left
  icon 9, 101 119 24 24,  $mircexe, 0, tab 1
  icon 3, 101 180 24 24,  $mircexe, 0, tab 1
  icon 13, 144 239 24 24,  $mircexe, 0, tab 1
  icon 23, 144 300 24 24,  $mircexe, 0, tab 1
  tab "Custom", 30
  box "/sys", 31, 15 100 288 240, tab 30
  list 32, 27 143 110 184, tab 30 size
  list 33, 182 143 110 184, tab 30 size
  button "->", 34, 141 176 37 25, tab 30
  button "<-", 35, 141 208 37 25, tab 30
  button "Up", 39, 141 241 37 25, tab 30
  button "Down", 40, 141 274 37 25, tab 30
  text "Available Fields:", 28, 29 123 82 16, tab 30
  text "Chosen Fields:", 36, 186 123 85 16, tab 30
  tab "Settings", 43
  box "No Colours in these Channels", 41, 14 100 289 132, tab 43
  list 42, 26 119 265 100, tab 43 size
  button "", 27, 27 257 263 68, tab 43
  box "Preview", 26, 14 235 289 105, tab 43
  tab "SpeedFan", 37
  box "Temp Sensors", 38, 14 100 289 123, tab 37
  list 45, 25 118 268 93, tab 37 size
  box "Fan Sensors", 44, 14 226 289 114, tab 37
  list 46, 23 243 268 86, tab 37 size
  button "OK", 21, 239 358 74 22, ok
  icon 29, -2 0 320 64,  $scriptdir $+ libraries\icons\sysheader.png, 0, noborder
}

on 1:dialog:sysinfo:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 27 window > $dlg
  window -h @sysinfoprev
  did -a $dname 27 grab $window(@sysinfoprev).hwnd @sysinfoprev
  mdx SetControlMDX 42 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 42 1 headerdims 120:1
  did -i $dname 42 1 headertext 0 Channels
  mdx SetControlMDX 45 listview single rowselect showsel alignleft report > $views
  did -i $dname 45 1 headerdims 0:1 30:2 100:3 70:4
  did -i $dname 45 1 headertext 0 $null $+ $chr(9) $+ 0 $chr(35) $+ $chr(9) $+ 0 Label $+ $chr(9) $+ 0 Value
  mdx SetControlMDX 46 listview single rowselect showsel alignleft report > $views
  did -i $dname 46 1 headerdims 0:1 30:2 100:3 70:4
  did -i $dname 46 1 headertext 0 $null $+ $chr(9) $+ 0 $chr(35) $+ $chr(9) $+ 0 Label $+ $chr(9) $+ 0 Value
  var %h = sysinfo
  if ($hget(%h,head.colour) == 16) {
    var %p = nocol.bmp
  }
  else {
    var %p = $hget(%h,head.colour) $+ .bmp
  }
  did -g sysinfo 9 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(%h,value.colour) == 16) {
    var %p = nocol.bmp
  }
  else {
    var %p = $hget(%h,value.colour) $+ .bmp
  }
  did -g sysinfo 3 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(%h,enc.colour) == 16) {
    var %p = nocol.bmp
  }
  else {
    var %p = $hget(%h,enc.colour) $+ .bmp
  }
  did -g sysinfo 13 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(%h,sep.colour) == 16) {
    var %p = nocol.bmp
  }
  else {
    var %p = $hget(%h,sep.colour) $+ .bmp
  }
  did -g sysinfo 23 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(sysinfo,value.bold) == 1) {
    did -c sysinfo 6
  }
  else {
    did -u sysinfo 6
  }
  if ($hget(sysinfo,value.underline) == 1) {
    did -c sysinfo 5
  }
  else {
    did -u sysinfo 5
  }
  if ($hget(sysinfo,head.bold) == 1) {
    did -c sysinfo 10
  }
  else {
    did -u sysinfo 10
  }
  if ($hget(sysinfo,head.underline) == 1) {
    did -c sysinfo 11
  }
  else {
    did -u sysinfo 11
  }
  did -ar sysinfo 17 $hget(sysinfo,enc.left)
  did -ar sysinfo 18 $hget(sysinfo,enc.right)
  if ($hget(sysinfo,enc.bold) == 1) {
    did -c sysinfo 15
  }
  else {
    did -u sysinfo 15
  }
  if ($hget(sysinfo,enc.underline) == 1) {
    did -c sysinfo 16
  }
  else {
    did -u sysinfo 16
  }
  did -ar sysinfo 20 $hget(sysinfo,sep)
  if ($hget(sysinfo,sep.bold) == 1) {
    did -c sysinfo 24
  }
  else {
    did -u sysinfo 24
  }
  if ($hget(sysinfo,sep.underline) == 1) {
    did -c sysinfo 25
  }
  else {
    did -u sysinfo 25
  }
  didtok -ar $dname 42 44 $hget(various,mono)
  setfields
  genpreview
  setfans
  settemps
}

on *:dialog:sysinfo:sclick:9: {
  var %p = sysinfo
  hadd various ColSet %p $+ ,head.colour
  colpickadv
}

on *:dialog:sysinfo:sclick:3: {
  var %p = sysinfo
  hadd various ColSet %p $+ ,value.colour
  colpickadv
}

on *:dialog:sysinfo:sclick:13: {
  var %p = sysinfo
  hadd various ColSet %p $+ ,enc.colour
  colpickadv
}

on *:dialog:sysinfo:sclick:23: {
  var %p = sysinfo
  hadd various ColSet %p $+ ,sep.colour
  colpickadv
}

on *:dialog:sysinfo:edit:17: {
  hadd sysinfo enc.left $did($dname,17)
}

on *:dialog:sysinfo:edit:18: {
  hadd sysinfo enc.right $did($dname,18)
}

on *:dialog:sysinfo:edit:20: {
  hadd sysinfo sep $did($dname,20)
}

on 1:dialog:sysinfo:sclick:21: {
  hadd sysinfo value.bold $did(sysinfo,6).state
  hadd sysinfo value.underline $did(sysinfo,5).state
  hadd sysinfo head.bold $did(sysinfo,10).state
  hadd sysinfo head.underline $did(sysinfo,11).state
  hadd sysinfo enc.left $did(sysinfo,17).text
  hadd sysinfo enc.right $did(sysinfo,18).text
  hadd sysinfo enc.bold $did(sysinfo,15).state
  hadd sysinfo enc.underline $did(sysinfo,16).state
  hadd sysinfo sep $did(sysinfo,20).text
  hadd sysinfo sep.bold $did(sysinfo,24).state
  hadd sysinfo sep.underline $did(sysinfo,25).state
  hadd sysinfo availfields $didtok(sysinfo,32,32)
  hadd sysinfo chosenfields $didtok(sysinfo,33,32)
  savesettings
  if ($dialog(cpanel)) {
    dialog -v cpanel
  }
}

on 1:dialog:sysinfo:sclick:32: {
  did -e sysinfo 34
  did -b sysinfo 35,39,40
}

on 1:dialog:sysinfo:sclick:33: {
  did -b sysinfo 34
  did -e sysinfo 35,39,40
}

on 1:dialog:sysinfo:sclick:34: {
  did -a $dname 33 $did($dname,32,$did($dname,32).sel)
  did -d $dname 32 $did($dname,32).sel
  did -c $dname 32 1
}

on 1:dialog:sysinfo:sclick:35: {
  if ($did($dname,33).lines > 0) {
    did -a $dname 32 $did($dname,33,$did($dname,33).sel)
    did -d $dname 33 $did($dname,33).sel
    did -c $dname 33 1
  }
}

on 1:dialog:sysinfo:sclick:39: {
  var %temp = $calc($did($dname,33).sel - 1)
  did -i $dname 33 %temp $did($dname,33,$did($dname,33).sel)
  did -d $dname 33 $did($dname,33).sel
  did -c $dname 33 %temp
}

on 1:dialog:sysinfo:sclick:40: {
  if ($did($dname,33).sel < $did($dname,33).lines) {
    var %temp = $calc($did($dname,33).sel + 2)
    did -i $dname 33 %temp $did($dname,33,$did($dname,33).sel)
    did -d $dname 33 $did($dname,33).sel
    did -c $dname 33 $calc(%temp - 1)
  }
}

on *:dialog:sysinfo:sclick:42:{
  if ($gettok($did($dname,42,1),1,32) == rclick) {
    nocolspop $did(42).sel $gettok($gettok($did(42).seltext,6,32),1,9)
  }
}

on *:dialog:sysinfo:sclick:45:{
  if ($gettok($did($dname,45,1),1,32) == rclick) {
    hadd sysinfo $+(temp,.,$calc($did(45).sel - 1)) $input(Enter name for Sensor,eo,Input Request...)
    settemps
  }
}

on *:dialog:sysinfo:sclick:46:{
  if ($gettok($did($dname,46,1),1,32) == rclick) {
    hadd sysinfo $+(fan,.,$calc($did(46).sel - 1)) $input(Enter name for Fan,eo,Input Request...)
    setfans
  }
}

menu @sysinfo {
  .Generate Preview:genpreview
}

alias settemps {
  did -r sysinfo 45
  var %temps = $temps, %l = 1
  tokenize 32 %temps
  while (%l <= $0) {
    did -a sysinfo 45 0 1 %l $+ $chr(9) $+ + 0 0 0 %l $+ $chr(9) $+ + 0 0 0 $hget(sysinfo,$+(temp.,%l)) $+ $chr(9) $+ + 0 0 0 $iif($left( [ [ $ $+ [ [ %l ] ] ] ] ,-2),$v1 $+ C,Not Used)
    inc %l
  }
}

alias setfans {
  did -r sysinfo 46
  var %fans = $fans, %l = 1
  tokenize 32 %fans
  while (%l <= $0) {
    did -a sysinfo 46 0 1 %l $+ $chr(9) $+ + 0 0 0 %l $+ $chr(9) $+ + 0 0 0 $hget(sysinfo,$+(fan.,%l)) $+ $chr(9) $+ + 0 0 0 $iif( [ [ $ $+ [ [ %l ] ] ] ] ,$v1 $+ RPM,Not Used)
    inc %l
  }
}

alias fillusers {
  did -r modemgr 3
  var %l = 1
  while (%l <= $readini($userfile,settings,users)) {
    var %user = $readini($userfile,users,%l)
    tokenize 32 %user
    did -a modemgr 3 0 1 $1 $+ $chr(9) $+ + 0 0 0 $2 $+ $chr(9) $+ + 0 0 0 $3 $+ $chr(9) $+ + 0 0 0 $4 $+ $chr(9) $+ + 0 0 0 $5 $+ $chr(9) $+ + 0 0 0 $6
    inc %l
  }
}


alias disks {
  var %l = 67, %t = 0, %f = 0, %cd = 0
  while (%l <= 90) {
    if ($disk($chr(%l))) {
      var %o = $s.head(Disk) $s.encleft $+ $s.value($chr(%l) $+ :) $+ $s.encright $s.sep $s.head(Size) $s.encleft $+ $s.value($round($calc($disk($chr(%l)).size / 1024 / 1024 / 1024),2) $+ Gb) $+ $s.encright $s.sep $s.head(Free) $s.encleft $+ $s.value($round($calc($disk($chr(%l)).free / 1024 / 1024 / 1024),2) $+ Gb) $+ $s.encright $s.sep $s.head(Label) $s.encleft $+ $s.value($disk($chr(%l)).label) $+ $s.encright $s.sep $s.head(Type) $s.encleft $+ $s.value($replace($disk($chr(%l)).type,fixed,HDD,remote,Network,cdrom,CD-ROM)) $+ $s.encright $s.sep $s.head(Usage) $s.encleft $+ $s.value($abs($calc($round($calc(($disk($chr(%l)).free / $disk($chr(%l)).size) * 100),2) - 100)) $+ %)) $+ $s.encright
      say $iif($istok($hget(various,mono),$active,44),$strip(%o),%o)
    }
    %t = $calc(%t + $disk($chr(%l)).size)
    %f = $calc(%f + $disk($chr(%l)).free)
    if ($disk($chr(%l)).type == cdrom) {
      %cd = $calc(%cd + $disk($chr(%l)).size)
    }
    inc %l
  }
  var %o = $s.head(Total Disk Space) $s.encleft $+ $s.value($round($calc(%t / 1024 / 1024 / 1024),2) $+ Gb) $+ $s.encright $s.sep $s.head(Total Free Space) $s.encleft $+ $s.value($round($calc(%f / 1024 / 1024 / 1024),2) $+ Gb) $+ $s.encright $s.sep $s.head(Total CD Space) $s.encleft $+ $s.value($round($calc(%cd / 1024 / 1024 / 1024),2) $+ Gb) $+ $s.encright
  say $iif($istok($hget(various,mono),$active,44),$strip(%o),%o)
}

;---POPUPS---

alias nocolspop {
  popups New nocolspop 16 16
  popups SetMetrics nocolspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem nocolspop end + Add $cr addnocol
  popups AddItem nocolspop end + Delete $cr delnocol $1 $2
  popup nocolspop $mouse.dx $mouse.dy
}

alias addnocol {
  var %c = $input(Please enter a channel name.,equ,Query...,$null)
  if (%c) {
    hadd various mono $addtok($hget(various,mono),%c,44)
    did -a sysinfo 42 + 0 0 0 %c
    savesettings
  }
}

alias delnocol {
  did -d sysinfo 42 $1
  hadd various mono $remtok($hget(various,mono),$2,44)
  savesettings
}

;---DECORATION ALIASES---

alias s.i {
  return $hget(sysinfo,$1)
}

alias s.encleft {
  return $iif($s.i(enc.bold),,$null) $+ $iif($s.i(enc.underline),,$null) $+  $+ $s.i(enc.colour) $+ $s.i(enc.left) $+ 
}

alias s.encright {
  return $iif($s.i(enc.bold),,$null) $+ $iif($s.i(enc.underline),,$null) $+  $+ $s.i(enc.colour) $+ $s.i(enc.right) $+ 
}

alias s.sep {
  return $iif($s.i(sep.bold),,$null) $+ $iif($s.i(sep.underline),,$null) $+  $+ $s.i(sep.colour) $+ $s.i(sep) $+ 
}

alias s.head {
  return $iif($s.i(head.bold),,$null) $+ $iif($s.i(head.underline),,$null) $+  $+ $s.i(head.colour) $+ $1- $+ 
}

alias s.value {
  var %v = $s.i(value.colour)
  if ($len(%v) == 1) {
    %v = 0 $+ %v
  }
  return $iif($s.i(value.bold),,$null) $+ $iif($s.i(value.underline),,$null) $+  $+ %v $+ $1- $+ 
}

;---GET INFO---

alias temps {
  return $dll($scriptdir $+ libraries\sysinfo.dll,_temps,.)
}

alias fans {
  return $dll($scriptdir $+ libraries\sysinfo.dll,_fans,.)
}

alias loadinfo {
  if (!$window(@sysinfo)) {
    window -lh @sysinfo
  }
  wmi $1
  loadbuf @sysinfo info.txt
  .remove info.txt
}

alias getinfo {
  if ($1 == close) {
    window -c @sysinfo
    return
  }
  var %l = 1, %value = $null
  while (%l <= $line(@sysinfo,0)) {
    if ($gettok($line(@sysinfo,%l),1,42) == $1) {
      return $replace($gettok($line(@sysinfo,%l),2,42),NULL,$null)
    }
    inc %l
  }
}

alias convdate {
  var %year = $mid($1,1,4)
  var %month = $mid($1,5,2)
  var %day = $mid($1,7,2)
  var %hour = $mid($1,9,2)
  var %min = $mid($1,11,2)
  var %sec = $mid($1,13,2)
  return $+(%day,/,%month,/,%year) $+(%hour,:,%min,:,%sec)
}

alias uptimerec {
  return $calc($hget(various,uptimerec) / 1000)
}

;---SYSINFO CALLS---

alias sys.os {
  loadinfo Win32_OperatingSystem
  return $s.head(OS:) $s.encleft $+ $s.value($getinfo(Caption) $getinfo(CSDVersion) $chr(40) $+ $getinfo(Version) $+ $chr(41)) $+ $s.encright $s.sep $s.head(Installed:) $s.encleft $+ $s.value($convdate($getinfo(InstallDate))) $+ $s.encright $s.sep $s.head(Uptime:) $s.encleft $+ $s.value($uptime(system,1)) $+ $s.encright $s.sep $s.head(Last Boot:) $s.encleft $+ $s.value($convdate($getinfo(LastBootUpTime))) $+ $s.encright $getinfo(close)
}

alias sys.uptime {
  loadinfo Win32_OperatingSystem
  return $s.head(Uptime:) $s.encleft $+ $s.value($uptime(system,1)) $+ $s.encright $s.sep $s.head(Record:) $s.encleft $+ $s.value($duration($uptimerec)) $+ $s.encright $s.sep $s.head(Set On:) $s.encleft $+ $s.value($hget(various,recdate)) $+ $s.encright $s.sep $s.head(Last Boot:) $s.encleft $+ $s.value($convdate($getinfo(LastBootUpTime))) $+ $s.encright $s.sep $s.head(Using:) $s.encleft $+ $s.value(Windows $os) $+ $s.encright $getinfo(close)
}

alias sys.cpu {
  loadinfo Win32_Processor
  loadinfo Win32_OperatingSystem
  return $s.head(CPU:) $s.encleft $+ $s.value($replace($getinfo(Name),(R),,(TM),)) $+ $s.encright $s.sep $s.head(Speed:) $s.encleft $+ $s.value($round($calc($getinfo(CurrentClockSpeed) / 1000),2) $+ GHz) $+ $s.encright $s.sep $s.head(L2 Cache:) $s.encleft $+ $s.value($getinfo(L2CacheSize) $+ KB) $+ $s.encright $s.sep $s.head(CPU Load:) $s.encleft $+ $s.value($iif($getinfo(LoadPercentage),$v1,0) $+ %) $+ $s.encright $s.sep $s.head(Processes:) $s.encleft $+ $s.value($getinfo(NumberOfProcesses)) $+ $s.encright $getinfo(close)
}

alias sys.mem {
  tokenize 32 $dll($scriptdir $+ libraries\sysinfo.dll,_mem,.)
  return $s.head(Memory Usage:) $s.encleft $+ $s.value($round($calc($calc($1 - $2) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($1 / 1024 / 1024),0) $+ MB) $+ $s.encright $s.sep $s.head(Virtual Memory:) $s.encleft $+ $s.value($round($calc($calc($3 - $4) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($3 / 1024 / 1024),0) $+ MB) $+ $s.encright $s.sep $s.head(Page File:) $s.encleft $+ $s.value($round($calc($calc($5 - $6) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($5 / 1024 / 1024),0) $+ MB) $+ $s.encright
}

alias sys.hds {
  var %d = 65, %t = 0, %f = 0
  while (%d <= 91) {
    if ($disk($chr(%d)).type == fixed) || ($disk($chr(%d)).type == remote) {
      %t = $calc(%t + $disk($chr(%d)).size)
      %f = $calc(%f + $disk($chr(%d)).free)
    }
    inc %d
  }
  return $s.head(HD Space Free/Total:) $s.encleft $+ $s.value($bytes(%f,3).suf $+ / $+ $bytes(%t,3).suf) $+ $s.encright $s.sep $s.head(Usage:) $s.encleft $+ $s.value($abs($calc($round($calc((%f / %t) * 100),2) - 100)) $+ %) $+ $s.encright
}

alias sys.network {
  loadinfo Win32_PerfRawData_Tcpip_NetworkInterface
  return $s.head(Network Interface:) $s.encleft $+ $s.value($getinfo(Name)) $+ $s.encright $s.sep $s.head(Received:) $s.encleft $+ $s.value($bytes($getinfo(BytesReceivedPersec)).suf) $+ $s.encright $s.sep $s.head(Sent:) $s.encleft $+ $s.value($bytes($getinfo(BytesSentPersec)).suf) $+ $s.encright $getinfo(close)
}

alias sys.display {
  loadinfo Win32_VideoController
  return $s.head(GFX Card:) $s.encleft $+ $s.value($getinfo(Caption)) $+ $s.encright $s.sep $s.head(Video Memory:) $s.encleft $+ $s.value($bytes($getinfo(AdapterRAM),3).suf) $+ $s.encright $s.sep $s.head(DAC:) $s.encleft $+ $s.value($getinfo(AdapterDACType)) $+ $s.encright $s.sep $s.head(Driver:) $s.encleft $+ $s.value($getinfo(DriverVersion)) $+ $s.encright $s.sep $s.head(Resolution:) $s.encleft $+ $s.value($getinfo(CurrentHorizontalResolution) $+ x $+ $getinfo(CurrentVerticalResolution)) $+ $s.encright $s.sep $s.head(Colours:) $s.encleft $+ $s.value($getinfo(CurrentBitsPerPixel) $+ bits) $+ $s.encright $s.sep $s.head(Refresh:) $s.encleft $+ $s.value($getinfo(MaxRefreshRate) $+ hz) $+ $s.encright $getinfo(close)
}

alias sys.temps {
  tokenize 32 $temps
  var %l = 1, %temps = $null
  while (%l <= $0) {
    if ([ [ $ $+ [ [ %l ] ] ] ] != 0) {
      %temps = %temps $s.encleft $+ $s.value($hget(sysinfo,$+(temp,.,%l)) $iif($left( [ [ $ $+ [ [ %l ] ] ] ] ,-2),$v1 $+ C,Not Used)) $+ $s.encright $s.sep
    }
    inc %l
  }
  return $s.head(Temperatures:) $left(%temps,-3)
}

alias sys.fans {
  tokenize 32 $fans
  var %l = 1, %fans = $null
  while (%l <= $0) {
    if ([ [ $ $+ [ [ %l ] ] ] ] != 0) {
      %fans = %fans $s.encleft $+ $s.value($hget(sysinfo,$+(fan,.,%l)) $iif( [ [ $ $+ [ [ %l ] ] ] ] ,$v1 $+ RPM,Not Used)) $+ $s.encright $s.sep
    }
    inc %l
  }
  return $s.head(Fan Speeds:) $left(%fans,-3)
}

alias sys.sound {
  loadinfo Win32_SoundDevice
  return $s.head(Soundcard:) $s.encleft $+ $s.value($getinfo(Caption)) $+ $s.encright $getinfo(close)
}

alias bandwidth {
  tokenize 32 $dll($shortfn($scriptdir $+ libraries\sysinfo.dll),_bw,.)
  set %bw.down $2
  set %bw.down.ticks $ticks
  set %bw.up $1
  set %bw.up.ticks $ticks
  .timer 1 1 bw
}

alias bw {
  tokenize 32 $dll($shortfn($scriptdir $+ libraries\sysinfo.dll),_bw,.)
  set %bw.down2 $2
  set %bw.down.curr $calc( ( %bw.down2 - %bw.down ) / ( $ticks - %bw.down.ticks ) )
  set %bw.up2 $1
  set %bw.up.curr $calc( ( %bw.up2 - %bw.up ) / ( $ticks - %bw.up.ticks ) )
  set %bw.output $s.head(Bandwidth Up) $s.encleft $+ $s.value($round(%bw.up.curr,2) $+ KB/sec) $+ $s.encright $s.sep $s.head(Bandwidth Down) $s.encleft $+ $s.value($round(%bw.down.curr,2) $+ KB/sec) $+ $s.encright
  say $iif($istok($hget(various,mono),$active,44),$strip(%bw.output),%bw.output)
  unset %bw.*
}

alias sys.mobo {
  loadinfo Win32_BaseBoard
  return $s.head(Mobo Make:) $s.encleft $+ $s.value($getinfo(Manufacturer)) $+ $s.encright $s.sep $s.head(Mobo Model:) $s.encleft $+ $s.value($getinfo(Product)) $+ $s.encright $getinfo(close)
}

alias sys.bios {
  loadinfo Win32_BIOS
  return $s.head(BIOS Make:) $s.encleft $+ $s.value($getinfo(Manufacturer)) $+ $s.encright $s.sep $s.head(BIOS Version:) $s.encleft $+ $s.value($getinfo(Version)) $+ $s.encright $getinfo(close)
}

alias sys.mon {
  loadinfo Win32_DesktopMonitor
  return $s.head(Monitor:) $s.encleft $+ $s.value($getinfo(Caption)) $+ $s.encright $s.sep $s.head(PPI:) $s.encleft $+ $s.value($getinfo(PixelsPerXLogicalInch) $+ x $+ $getinfo(PixelsPerYLogicalInch)) $+ $s.encright $s.sep $s.head(Screen Size:) $s.encleft $+ $s.value($getinfo(ScreenWidth) $+ x $+ $getinfo(ScreenHeight)) $+ $s.encright $getinfo(close)
}

alias sys.td {
  return $s.head(Current Time:) $s.encleft $+ $s.value($asctime(hh:nn:sstt) $tz) $+ $s.encright $s.sep $s.head(Current Date:) $s.encleft $+ $s.value($asctime(dd/mm/yyyy)) $+ $s.encright
}

alias sys.mirc {
  return $s.head(mIRC Version:) $s.encleft $+ $s.value(mIRC $version) $+ $s.encright
}

alias sys.nxg {
  return $s.head(NXG Version:) $s.encleft $+ $s.value($remove($sversion,v)) $+ $s.encright $s.sep $s.head(Loaded) $s.encleft $+ $s.value($sf) $+ $s.encright $s.head(script files containing) $s.encleft $+ $s.value($sl) $+ $s.encright $s.head(lines...)
}

;---DCC STATS---

alias dccstats {
  if ($sock(dcc2ftp/*,0) > 0) { 
    var %x = 1, %y = $sock(dcc2ftp/*,0)
    while (%x <= %y) {
      say $s.head(DCCtoFTP $chr(35) $+ %x $+ : Address) $s.encleft $+ $s.value($sock(dcc2ftp/*,%x).ip) $+ $s.encright $s.head(Size) $s.encleft $+ $s.value($bytes($sock(dcc2ftp/*,%x).mark,3).suf) $+ $s.encright $s.head(Time Taken) $s.encleft $+ $s.value($duration($sock(dcc2ftp/*,%x).to)) $+ $s.encright
      inc %x
    }
  }
  if ($get(0) > 0) { 
    var %g = 1
    while (%g <= $get(0)) {
      say $s.head(Get $chr(35) $+ %g $+ :) $s.head(Nick) $s.encleft $+ $s.value($get(%g)) $+ $s.encright $s.sep $s.head(Network) $s.encleft $+ $s.value($scid($get(%g).cid).network)) $+ $s.encright $s.sep $s.head(File) $s.encleft $+ $s.value($get(%g).file) $+ $s.encright $s.sep $s.head(Size) $s.encleft $+ $s.value($bytes($get(%g).size,3).suf) $+ $s.encright $s.sep $s.head(CPS) $s.encleft $+ $s.value($bytes($get(%g).cps,3).suf) $+ $s.encright $s.sep $s.head(Completed) $s.encleft $+ $s.value($get(%g).pc $+ %) $+ $s.encright $s.sep $s.head(Time Left) $s.encleft $+ $s.value($duration($round($calc( [ $calc($get(%g).size - $get(%g).rcvd) ] / $get(%g).cps),0)))) $+ $s.encright
      inc %g
    }
  }
  if ($send(0) > 0) {
    var %s = 1
    while (%s <= $send(0)) {
      say $s.head(Send $chr(35) $+ %s $+ :) $s.head(Nick) $s.encleft $+ $s.value($send(%s)) $+ $s.encright $s.sep $s.head(Network) $s.encleft $+ $s.value($scid($send(%s).cid).network)) $+ $s.encright $s.sep $s.head(File) $s.encleft $+ $s.value($send(%s).file) $+ $s.encright $s.sep $s.head(Size) $s.encleft $+ $s.value($bytes($send(%s).size,3).suf) $+ $s.encright $s.sep $s.head(CPS) $s.encleft $+ $s.value($bytes($send(%s).cps,3).suf) $+ $s.encright $s.sep $s.head(Completed) $s.encleft $+ $s.value($send(%s).pc $+ %) $+ $s.encright $s.sep $s.head(Time Left) $s.encleft $+ $s.value($duration($round($calc( [ $calc($send(%s).size - $send(%s).rcvd) ] / $send(%s).cps),0)))) $+ $s.encright
      inc %s
    }
  }
  if ($send(0) == 0) && ($get(0) == 0) && ($sock(dcc2ftp/*,0) == 0) { say $s.head(No DCC) $s.encleft $+ $s.value(Sends) $+ $s.encright $s.head(or) $s.encleft $+ $s.value(Gets) $+ $s.encright $s.head(or) $s.encleft $+ $s.value(FXPs) $+ $s.encright $s.head(in progress.) }
}

;---CHANNEL STATS---

alias owned {
  var %o = 1, %owned = 0, %all = 0
  while (%o <= $scon(0)) {
    %owned = $calc(%owned + $gettok($scon(%o).nicks,1,59)) 
    %all = $calc(%all + $gettok($scon(%o).nicks,2,59)) 
    inc %o
  }
  return $s.encleft $+ $s.value(%owned) $+ $s.encright $s.head(of) $s.encleft $+ $s.value(%all) $+ $s.encright
}

alias nicks { 
  var %b = 1, %opped = 0, %total = 0
  while ($chan(%b) != $null) {
    if ($me isop $chan(%b)) || ($me ishop $chan(%b)) {
      %opped = $calc(%opped + $nick($chan(%b),0))
    } 
    %total = $calc(%total + $nick($chan(%b),0))
    inc %b
  }
  return %opped $+ ; $+ %total
}

alias chans { return $chan(0) }

alias channels {
  var %x = 1, %chans = 0
  while (%x <= $scon(0)) {
    %chans = $calc(%chans + $scon(%x).chans)
    inc %x
  }
  return %chans
}

alias chanstats {
  say $s.head(I am connected to) $s.encleft $+ $s.value($scon(0)) $+ $s.encright $s.head(IRC servers and) $s.encleft $+ $s.value($channels) $+ $s.encright $s.head(channels $+ $chr(44) owning) $owned $s.head(users.)
}

alias sys {
  if ($window(@sys)) {
    clear @sys
  }
  else {
    window -lh @sys
  }
  getsysinfo
  var %l = 1, %line = $hget(sysinfo,chosenfields)
  while (%l <= $line(@sys,0)) {
    var %tag = $gettok($line(@sys,%l),1,42)
    var %id = $gettok($line(@sys,%l),2,42)
    var %info = $gettok($line(@sys,%l),3,42)
    var %line = $replace(%line,%tag,$s.head(%id) $s.encleft $+ $s.value(%info) $+ $s.encright $s.sep)
    inc %l
  }
  say $left(%line,-3)
  window -c @sys
}

alias getsysinfo {
  loadinfo Win32_OperatingSystem
  aline @sys <os>*OS* $+ $getinfo(Caption) $getinfo(CSDVersion) $chr(40) $+ $getinfo(Version) $+ $chr(41)
  aline @sys <installed>*Install Date* $+ $convdate($getinfo(InstallDate))
  aline @sys <lastboot>*Last Boot* $+ $convdate($getinfo(LastBootUpTime))
  aline @sys <processes>*Processes* $+ $getinfo(NumberOfProcesses)
  getinfo close
  loadinfo Win32_Processor
  aline @sys <cpu>*CPU* $+ $replace($getinfo(Name),(R),,(TM),)
  aline @sys <speed>*Speed* $+ $round($calc($getinfo(CurrentClockSpeed) / 1000),2) $+ GHz
  aline @sys <l2cache>*L2 Cache* $+ $getinfo(L2CacheSize) $+ KB
  aline @sys <cpuload>*CPU Load* $+ $getinfo(LoadPercentage) $+ %
  getinfo close
  loadinfo Win32_BIOS
  aline @sys <biosmake>*BIOS Make* $+ $getinfo(Manufacturer)
  aline @sys <biosversion>*BIOS Version* $+ $getinfo(Version)
  getinfo close  
  aline @sys <uptime>*Uptime* $+ $uptime(system,1)
  aline @sys <record>*Record* $+ $duration($uptimerec)
  aline @sys <seton>*Set On* $+ $hget(various,recdate)
  loadinfo Win32_BaseBoard
  aline @sys <mobomake>*Mobo Make* $+ $getinfo(Manufacturer)
  aline @sys <mobomodel>*Mobo Model* $+ $getinfo(Product)
  getinfo close
  tokenize 32 $dll($scriptdir $+ libraries\sysinfo.dll,_mem,.)
  aline @sys <memory>*Memory* $+ $round($calc($calc($1 - $2) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($1 / 1024 / 1024),0) $+ MB)
  aline @sys <virtualmem>*Virtual Memory* $+ $round($calc($calc($3 - $4) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($3 / 1024 / 1024),0) $+ MB)
  aline @sys <pagefile>*Pagefile* $+ $round($calc($calc($5 - $6) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($5 / 1024 / 1024),0) $+ MB)
  loadinfo Win32_PerfRawData_Tcpip_NetworkInterface
  aline @sys <network>*Network Interface* $+ $getinfo(Name)
  aline @sys <received>*Received* $+ $bytes($getinfo(BytesReceivedPersec)).suf
  aline @sys <sent>*Sent* $+ $bytes($getinfo(BytesSentPersec)).suf
  getinfo close
  loadinfo Win32_VideoController
  aline @sys <gfxcard>*GFX Card* $+ $getinfo(Caption)
  aline @sys <videomem>*Video Memory* $+ $bytes($getinfo(AdapterRAM),3).suf
  aline @sys <dac>*DAC* $+ $getinfo(AdapterDACType)
  aline @sys <driver>*Driver* $+ $getinfo(DriverVersion)
  aline @sys <resolution>*Resolution* $+ $getinfo(CurrentHorizontalResolution) $+ x $+ $getinfo(CurrentVerticalResolution)
  aline @sys <colours>*Colours* $+ $getinfo(CurrentBitsPerPixel) $+ bits
  aline @sys <refresh>*Refresh* $+ $getinfo(MaxRefreshRate) $+ hz
  getinfo close
  loadinfo Win32_SoundDevice
  aline @sys <soundcard>*Soundcard* $+ $getinfo(Caption)
  getinfo close
  loadinfo Win32_DesktopMonitor
  aline @sys <monitor>*Monitor* $+ $getinfo(Caption)
  getinfo close
  aline @sys <bwup>*Bandwidth Up* $+ $bandwidth_up
  aline @sys <bwdown>*Bandwidth Down* $+ $bandwidth_down
}

;---EVENTS---

on *:start:{
  if ($exists($inifile)) {
    loadsettings
  }
  else {
    setdefsettings
  }
}

;---SYSTEM/DISKS/STATS DIALOG---

alias sds {
  dialog -m sds sds
}

dialog sds {
  title "System/Disks/Statistics"
  size -1 -1 508 385
  option pixels
  tab "System", 2, 4 72 498 283
  box "System Information", 6, 13 96 482 246, tab 2
  list 10, 22 112 463 220, tab 2 size
  tab "Disks", 3
  box "Disks Information", 7, 13 96 482 246, tab 3
  list 11, 22 112 463 220, tab 3 size
  tab "Statistics", 4
  box "Script/IRC Statistics", 8, 13 96 482 246, tab 4
  list 12, 22 112 463 220, tab 4 size
  button "OK", 5, 428 359 75 22, ok
  icon 1, -3 0 514 64,  $scriptdir $+ libraries\icons\sdsheader.png, 0, noborder
}

on *:dialog:sds:init:0:{
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 10 TreeView haslines > $views
  mdx SetControlMDX 11 listview single rowselect showsel report > $views
  did -i $dname 11 1 headerdims 100:1 120:2 110:3 100:4
  did -i $dname 11 1 headertext Drive $+ $chr(9) $+ Label $+ $chr(9) $+ Free Space $+ $chr(9) $+ Total
  mdx SetControlMDX 12 listview single rowselect showsel report > $views
  did -i $dname 12 1 headerdims 230:1 200:2
  did -i $dname 12 1 headertext +r Description $+ $chr(9) $+ +l Value
  displaysysinfo
  displaydisksinfo
  displaystats
}

alias displaysysinfo {
  if ($window(@sys)) {
    clear @sys
  }
  else {
    window -lh @sys
  }
  getsysinfo
  did -i sds 10 1 clearicons normal 
  did -i sds 10 1 iconsize normal small 
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\exe.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\calendar.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\boot.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\cpu.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\speed.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\cache.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\cpuload.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\procs.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\mobo.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\bios.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\memory.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\network.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\nwsent.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\nwrec.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\gfxcard.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\vidmem.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\soundcard.ico
  did -i sds 10 1 seticon normal 0 $scriptdir $+ libraries\icons\monitor.ico
  cb root 
  add +b 1 1 OS
  add + 1 1 Version
  add + 1 1 $infoline(<os>)
  cb up
  cb up
  add + 2 2 Installed
  add + 2 2 $infoline(<installed>)
  cb up
  cb up
  add + 3 3 Last Boot
  add + 3 3 $infoline(<lastboot>)
  cb root
  add +b 4 4 CPU
  add + 4 4 Name
  add + 4 4 $infoline(<cpu>)
  cb up
  cb up
  add + 5 5 Speed
  add + 5 5 $infoline(<speed>)
  cb up
  cb up
  add + 6 6 L2 Cache
  add + 6 6 $infoline(<l2cache>)
  cb up
  cb up
  add + 7 7 CPU Load
  add + 7 7 $infoline(<cpuload>)
  cb up
  cb up
  add + 8 8 Processes
  add + 8 8 0 0 0 $infoline(<processes>)
  cb root
  add +b 9 9 Motherboard
  add + 9 9 Make
  add + 9 9 $infoline(<mobomake>)
  cb up
  cb up
  add + 9 9 Model
  add + 9 9 $infoline(<mobomodel>)
  cb root
  add +b 10 10 BIOS
  add + 10 10 Make
  add + 10 10 $infoline(<biosmake>)
  cb up
  cb up
  add + 10 10 Version
  add + 10 10 $infoline(<biosversion>)
  tokenize 32 $dll($scriptdir $+ libraries\sysinfo.dll,_mem,.)
  cb root
  add +b 11 11 Memory
  add + 11 11 Physical
  add + 11 11 $round($calc($calc($1 - $2) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($1 / 1024 / 1024),0) $+ MB
  cb up
  cb up
  add + 11 11 Virtual
  add + 11 11 $round($calc($calc($3 - $4) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($3 / 1024 / 1024),0) $+ MB
  cb up
  cb up
  add + 11 11 Page File
  add + 11 11 $round($calc($calc($5 - $6) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($5 / 1024 / 1024),0) $+ MB
  cb root
  add +b 12 12 Network
  add + 12 12 Adapter
  add + 12 12 $infoline(<network>)
  cb up
  cb up
  add + 13 13 Sent
  add + 13 13 $infoline(<sent>)
  cb up
  cb up
  add + 14 14 Received
  add + 14 14 $infoline(<received>)
  cb root
  add +b 15 15 Graphics
  add + 15 15 $infoline(<gfxcard>)
  cb up
  add + 16 16 Video Memory
  add + 16 16 $infoline(<videomem>)
  cb root
  add +b 17 17 Sound
  add + 17 17 $infoline(<soundcard>)
  cb root
  add +b 18 18 Monitor
  add + 18 18 $infoline(<monitor>)
  window -c @sys
}

alias -l add {
  did -a sds 10 $1-
  cb last
} 

alias -l cb {
  did -i sds 10 1 cb $1-
} 

alias infoline {
  var %l = 1
  while (%l <= $line(@sys,0)) {
    var %line = $line(@sys,%l)
    if ($gettok(%line,1,42) == $1) {
      return $gettok(%line,3,42)
      break
    }
    inc %l
  }
}

alias displaydisksinfo {
  did -i sds 11 1 clearicons normal 
  did -i sds 11 1 iconsize normal small 
  did -i sds 11 1 seticon normal 0 $scriptdir $+ libraries\icons\hd.ico
  var %d = 67, %s = 0, %f = 0
  while (%d < 91) {
    if ($disk($chr(%d)).size != $null) && ($disk($chr(%d)).type == fixed) {
      %s = $calc(%s + $disk($chr(%d)).size)
    }
    if ($disk($chr(%d)).free != $null) && ($disk($chr(%d)).type == fixed) {
      %f = $calc(%f + $disk($chr(%d)).free)
    }
    if ($disk($chr(%d)).type == fixed) {
      did -a sds 11 + 1 $chr(%d) $+ : $+ $chr(9) $+ 0 $disk($chr(%d)).label $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).free,3).suf $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).size,3).suf $+ $chr(9) $+ 0 $abs($calc($round($calc(($disk($chr(%d)).free / $disk($chr(%d)).size) * 100),2) - 100)) $+ % $+ $chr(4) $+ Hard Disk Drive
    }
    if ($disk($chr(%d)).type == remote) {
      did -a sds 11 + 1 $chr(%d) $+ : $+ $chr(9) $+ 0 $disk($chr(%d)).label $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).free,3).suf $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).size,3).suf $+ $chr(9) $+ 0 $abs($calc($round($calc(($disk($chr(%d)).free / $disk($chr(%d)).size) * 100),2) - 100)) $+ % $+ $chr(4) $+ Hard Disk Drive
    }
    if ($disk($chr(%d)).type == cdrom) {
      if ($bytes($disk($chr(%d)).size,3) != 0) {
        did -a sds 11 + 1 $chr(%d) $+ : $+ $chr(9) $+ 0 $disk($chr(%d)).label $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).free,3).suf $+ $chr(9) $+ 0 $bytes($disk($chr(%d)).size,3).suf $+ $chr(9) $+ 0 100% $+ $chr(4) $+ CD-Rom
      }
    }
    inc %d
  }
}

alias displaystats {
  did -r sds 12
  did -a sds 12 + 1 0 0 Lines Spoken $+ $chr(9) $+ 1 0 0 $hget(sysinfo,lines)
  did -a sds 12 + 1 0 0 Words Spoken $+ $chr(9) $+ 1 0 0 $hget(sysinfo,words)
  did -a sds 12 + 1 0 0 Characters Spoken $+ $chr(9) $+ 1 0 0 $hget(sysinfo,chars)
  did -a sds 12 + 1 0 0 Questions Asked $+ $chr(9) $+ 1 0 0 $hget(sysinfo,questions)
  did -a sds 12 + 1 0 0 Bans Set $+ $chr(9) $+ 1 0 0 $hget(various,bans)
  did -a sds 12 + 1 0 0 Kicks $+ $chr(9) $+ 1 0 0 $hget(various,kicks)
  did -a sds 12 + 1 0 0 Files Uploaded $+ $chr(9) $+ 1 0 0 $hget(various,uploads)
  did -a sds 12 + 1 0 0 Amount Uploaded $+ $chr(9) $+ 1 0 0 $bytes($hget(various,uploaded),3).suf
  did -a sds 12 + 1 0 0 Files Downloaded $+ $chr(9) $+ 1 0 0 $hget(various,downloads)
  did -a sds 12 + 1 0 0 Amount Downloaded $+ $chr(9) $+ 1 0 0 $bytes($hget(various,downloaded),3).suf
}

;---STATS HARVESTING---

on *:input:*:{
  if ($left($1,1) != /) {
    hinc sysinfo lines 
    hinc sysinfo words $0
    hinc sysinfo chars $len($1-)
    if (? isin $1-) {
      hinc sysinfo questions
    }
  }
}

;---CLEAR STATS POPUP---

alias clearstatspopup {
  popups New clearstatspop 16 16
  popups SetMetrics clearstatspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem clearstatspop end + Clear Stats $cr clearstats
  popup clearstatspop $mouse.dx $mouse.dy
}

alias clearstats {
  hadd sysinfo lines 0
  hadd sysinfo words 0
  hadd sysinfo chars 0
  hadd sysinfo questions 0
  hadd various bans 0
  hadd various kicks 0
  hadd various uploads 0
  hadd various uploaded 0
  hadd various downloads 0
  hadd various downloaded 0
  displaystats
}  

on *:dialog:sds:sclick:12:{
  if ($gettok($did($dname,12,1),1,32) == rclick) {
    clearstatspopup $did(12).sel $gettok($gettok($did(12).seltext,6,32),1,9)
  }
}
