;---XDCC Server by mr.man (c) 2008 (Part of NeXtGenIRC)---

;---ALIASES---

alias -l inifile {
  return $+(",$scriptdir,settings\xdccserver.ini,")
}

alias -l packsfile {
  return $+(",$scriptdir,settings\xdccpacks.txt,")
}

alias -l advertfile {
  return $+(",$scriptdir,settings\xdccadvert.txt,")
}

alias -l queuefile {
  return $+(",$scriptdir,settings\xdccqueue.txt,")
}

alias -l makedefsettings {
  var %t = xdccsrv
  hadd %t totalxfers 2
  hadd %t xfersperuser 1
  hadd %t autoad 1
  hadd %t adtimer 600
  hadd %t mincps 1024
  hadd %t qperuser 2
  hadd %t maxqueue 20
  hadd %t active 0
  hadd %t filessent 0
  hadd %t amountsent 0
  savesettings
}

alias -l savesettings {
  if (!%restart) {
    var %t = xdccsrv
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = xdccsrv
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
  else {
    makedefsettings
  }
}

;---EVENTS---

on *:start:{ loadsettings }

on *:exit:{ savesettings }

;---DIALOGS STUFF---

alias xdccserver {
  dialog -m xdccserver xdccserver
}

dialog xdccserver {
  title "XDCC Server"
  size -1 -1 294 306
  option pixels
  tab "Settings", 1, 4 73 284 201
  box "Main Settings", 4, 12 96 269 166, tab 1
  check "XDCC Server Active", 6, 8 277 143 20, tab 1
  text "Max Transfers:", 7, 58 123 106 16, tab 1 right
  text "Transfers per User:", 8, 62 148 102 16, tab 1 right
  text "Minimum CPS:", 9, 58 174 106 16, tab 1 right
  text "Max in Queue:", 10, 61 200 103 16, tab 1 right
  text "Max Queues per User:", 11, 47 226 117 16, tab 1 right
  edit "", 12, 169 118 63 23, tab 1
  edit "", 13, 169 143 63 23, tab 1
  edit "", 14, 169 169 63 23, tab 1
  edit "", 15, 169 195 63 23, tab 1
  edit "", 16, 169 221 63 23, tab 1
  tab "Packs", 2
  box "XDCC Pack Listing", 17, 12 96 269 166, tab 2
  list 18, 23 114 247 136, tab 2 size extsel
  tab "Advert", 3
  box "Advert Settings", 19, 12 96 269 57, tab 3
  check "Auto Advert Active", 20, 8 277 125 20, tab 3
  box "Advert Networks/Channels", 21, 12 155 269 106, tab 3
  text "Auto Advertise every", 22, 40 120 105 16, tab 3
  edit "", 23, 147 115 51 23, tab 3
  text "seconds", 24, 203 120 50 16, tab 3
  list 25, 21 171 251 80, tab 3 size
  tab "Statistics", 26
  box "Server Statistics", 27, 12 96 269 165, tab 26
  text "Files Sent:", 28, 76 142 50 16, tab 26 right
  text "Amount Sent:", 29, 56 177 70 16, tab 26 right
  edit "", 30, 130 137 100 23, tab 26 read
  button "Reset", 32, 105 212 75 25, tab 26
  edit "", 31, 129 171 100 23, tab 26 read
  button "OK", 5, 224 279 65 22, ok
  icon 33, -2 0 297 64, $scriptdir $+ libraries\icons\xdccsrvheader.png, noborder
}

on *:dialog:xdccserver:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 18 listview single rowselect showsel alignleft report > $views
  did -i $dname 18 1 headerdims 135:1 55:2 35:3
  did -i $dname 18 1 headertext 0 Pack $+ $chr(9) $+ 0 Size $+ $chr(9) $+ 0 Sent
  did -ar $dname 12 $hget(xdccsrv,totalxfers)
  did -ar $dname 13 $hget(xdccsrv,xfersperuser)
  did -ar $dname 14 $hget(xdccsrv,mincps)
  did -ar $dname 15 $hget(xdccsrv,maxqueue)
  did -ar $dname 16 $hget(xdccsrv,qperuser)
  if ($hget(xdccsrv,active) == 1) {
    did -c $dname 6
  }
  did -ar $dname 23 $hget(xdccsrv,adtimer)
  if ($hget(xdccsrv,autoad) == 1) {
    did -c $dname 20
  }
  mdx SetControlMDX 25 listview single rowselect showsel alignleft report > $views
  did -i $dname 25 1 headerdims 110:1 110:2
  did -i $dname 25 1 headertext 0 Network $+ $chr(9) $+ 0 Channel
  loadpacklist
  loadnetschans
  did -ar $dname 30 $hget(xdccsrv,filessent)
  did -ar $dname 31 $bytes($hget(xdccsrv,amountsent)).suf
}

on *:dialog:xdccserver:sclick:5:{
  hadd xdccsrv totalxfers $did($dname,12)
  hadd xdccsrv xfersperuser $did($dname,13)
  hadd xdccsrv mincps $did($dname,14)
  hadd xdccsrv maxqueue $did($dname,15)
  hadd xdccsrv qperuser $did($dname,16)
  hadd xdccsrv active $did($dname,6).state
  hadd xdccsrv adtimer $did($dname,23)
  hadd xdccsrv autoad $did($dname,20).state
  savesettings
  savepacklist
  makeadvert
  savenetchan
  if ($hget(xdccsrv,autoad) == 1) {
    .timerxdccad 0 $hget(xdccsrv,adtimer) displayadvert
  }
  else {
    .timerxdccad off
  }
  if ($hget(xdccsrv,active) == 1) {
    .enable #xdccserver
  }
  else if ($hget(xdccsrv,active) == 0) {
    write -c $queuefile
    .disable #xdccserver
  }    
}

on *:dialog:xdccserver:sclick:18: {
  if ($gettok($did($dname,18,1),1,32) == rclick) {
    packmanagerpopup $did(18).sel $gettok($gettok($did(18).seltext,6,32),1,9)
  }
}

alias packmanagerpopup {
  popups New packmanagerpop 16 16
  popups SetMetrics packmanagerpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem packmanagerpop end + Add Pack(s) $cr addpacks
  popups AddItem packmanagerpop end + Remove Pack $cr removepack $1 $2-
  popups AddItem packmanagerpop end + 
  popups AddItem packmanagerpop end + Clear Packs $cr clearpacks
  popup packmanagerpop $mouse.dx $mouse.dy
}

on *:dialog:xdccserver:sclick:25: {
  if ($gettok($did($dname,25,1),1,32) == rclick) {
    netschanspopup $did(25).sel $gettok($gettok($did(25).seltext,6,32),1,9)
  }
}

alias netschanspopup {
  popups New netschanspop 16 16
  popups SetMetrics netschanspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem netschanspop end + Add Net/Chan $cr addnetchan
  popups AddItem netschanspop end + Remove Net/Chan $cr removenetchan $1 $2-
  popup netschanspop $mouse.dx $mouse.dy
}

dialog setadvert {
  title "New Advert Destination"
  size -1 -1 239 245
  option pixels
  tab "Advertise", 1, 6 74 225 135
  box "Network/Channel", 2, 15 98 207 98, tab 1
  text "Network:", 3, 30 128 50 16, tab 1 right
  text "Channel:", 4, 30 156 50 16, tab 1 right
  edit "", 5, 80 124 121 23, tab 1
  edit "", 6, 80 152 121 23, tab 1
  button "OK", 7, 157 214 75 22, disable ok
  icon 8, -2 0 242 64, $scriptdir $+ libraries\icons\xdccadheader.png, noborder
}

on *:dialog:setadvert:init:0: {
  did -ar $dname 5 $network
  did -f $dname 5
}

on *:dialog:setadvert:edit:5: {
  if ($did($dname,5)) && ($did($dname,6)) {
    did -e $dname 7
  }
}

on *:dialog:setadvert:edit:6: {
  if ($did($dname,5)) && ($did($dname,6)) {
    did -e $dname 7
  }
}

on *:dialog:setadvert:sclick:7: {
  did -a xdccserver 25 + 0 0 0 $did($dname,5) $+ $chr(9) $+ + 0 0 0 $did($dname,6)
  ;hadd xdccsrv chan $addtok($hget(xdccsrv,chan),$did($dname,5) $+ $chr(44) $+ $did($dname,6),32)
}

on *:dialog:xdccserver:sclick:32: {
  hadd xdccsrv filessent 0
  hadd xdccsrv amountsent 0
  did -ar $dname 30 $hget(xdccsrv,filessent)
  did -ar $dname 31 $bytes($hget(xdccsrv,amountsent)).suf
}  

;---MORE ALIASES---

alias addnetchan {
  dialog -m setadvert setadvert
}

alias removenetchan {
  did -d xdccserver 25 $did(xdccserver,25).sel
}

alias savenetchan {
  hadd xdccsrv chan $null
  var %c = 2
  while (%c <= $did(xdccserver,25,1).lines) {
    var %net = $gettok($gettok($did(xdccserver,25,%c),1,9),6,32)
    var %chan = $gettok($gettok($did(xdccserver,25,%c),2,9),5,32)
    hadd xdccsrv chan $addtok($hget(xdccsrv,chan),%net $+ $chr(44) $+ %chan,32)
    inc %c
  }
}

alias loadnetschans {
  var %c = 1
  while (%c <= $numtok($hget(xdccsrv,chan),32)) {
    var %ad = $gettok($hget(xdccsrv,chan),%c,32) 
    var %net = $gettok(%ad,1,44)
    var %chan = $gettok(%ad,2,44)
    did -a xdccserver 25 + 0 0 0 %net $+ $chr(9) $+ + 0 0 0 %chan
    inc %c
  }
}

alias addpacks {
  var %num = $msfile(c:\,Select Packs for XDCC Server,OK)
  if (%num > 0) {
    var %l = 1
    while (%l <= %num) {
      did -a xdccserver 18 + 0 0 0 $msfile(%l) $+ $chr(9) $+ + 0 0 0 $file($msfile(%l)).size $+ $chr(9) $+ + 0 0 0 0
      inc %l
    }
  }
}

alias removepack {
  if ($1) {
    did -d xdccserver 18 $did(xdccserver,18,1).sel
    return
  }
}

alias clearpacks {
  var %i = $input(Really delete all packs?,qv,$null)
  if (%i == $ok) {
    did -r xdccserver 18
  }
}

alias savepacklist {
  .remove $packsfile
  var %c = 2
  while (%c <= $did(xdccserver,18,1).lines) {
    var %file = $gettok($gettok($did(xdccserver,18,%c),1,9),6-,32)
    var %size = $gettok($gettok($did(xdccserver,18,%c),2,9),5,32)
    var %sent = $gettok($gettok($did(xdccserver,18,%c),3,9),5,32)
    write $packsfile $+(%file,*,%size,*,%sent)
    inc %c
  }
}

alias loadpacklist {
  var %p = 1
  while (%p <= $lines($packsfile)) {
    var %pack = $read($packsfile,%p)
    var %file = $gettok(%pack,1,42)
    var %size = $gettok(%pack,2,42)
    var %sent = $gettok(%pack,3,42)
    did -a xdccserver 18 + 0 0 0 %file $+ $chr(9) $+ + 0 0 0 %size $+ $chr(9) $+ + 0 0 0 %sent
    inc %p
  }
}

alias makeadvert {
  .remove $advertfile
  write $advertfile $s.head(XDCC Server) $s.sep $s.head(Serving) $s.encleft $+ $s.value($lines($packsfile)) $+ $s.encright $s.head(Packs)
  write $advertfile $s.head(Queues) $s.encleft $+ $s.value($lines($queuefile) $+ / $+ $hget(xdccsrv,maxqueue)) $+ $s.encright $s.sep $s.head(Min Speed) $s.encleft $+ $s.value($bytes($hget(xdccsrv,mincps)).suf $+ /s) $+ $s.encright $s.sep $s.head(Current Speed) $s.encleft $+ $s.value($bytes($xdccspeed).suf $+ /s) $+ $s.encright  
  var %p = 1
  hadd xdccsrv posted 0
  while (%p <= $lines($packsfile)) {
    var %pack = $read($packsfile,%p)
    var %file = $gettok(%pack,1,42)
    var %size = $gettok(%pack,2,42)
    var %sent = $gettok(%pack,3,42)
    hadd xdccsrv posted $calc($hget(xdccsrv,posted) + %size)
    write $advertfile  $+ . $+ %p $+  %sent $+ x $chr(91) $+ $bytes(%size).suf $+ $chr(93) $nopath(%file)
    inc %p
  }
}

alias displayadvert {
  makeadvert
  if ($hget(xdccsrv,active) == 1) {
    window -hl @advert
    loadbuf @advert $advertfile
    playadvert
  }
}

alias playadvert {
  var %pack = $line(@advert,1)
  if (%pack) {
    var %a = 1
    while (%a <= $numtok($hget(xdccsrv,chan),32)) {
      var %ad = $gettok($hget(xdccsrv,chan),%a,32)
      var %net = $gettok(%ad,1,44)
      var %chan = $gettok(%ad,2,44)
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          scon %n msg %chan $iif($istok($hget(various,mono),%chan,44),$strip(%pack),%pack)
        }
        inc %n
      }
      inc %a
    }
    dline @advert 1
    .timer 1 1 playadvert
  }
  else {
    var %a = 1
    while (%a <= $numtok($hget(xdccsrv,chan),32)) {
      var %ad = $gettok($hget(xdccsrv,chan),%a,32)
      var %net = $gettok(%ad,1,44)
      var %chan = $gettok(%ad,2,44)
      var %n = 1
      while (%n <= $scon(0)) {
        if (%net == $scon(%n).network) {
          var %ad = $s.head(Files Sent) $s.encleft $+ $s.value($hget(xdccsrv,filessent)) $+ $s.encright $s.sep $s.head(Posted) $s.encleft $+ $s.value($bytes($hget(xdccsrv,posted)).suf) $+ $s.encright $s.sep $s.head(Leeched) $s.encleft $+ $s.value($bytes($hget(xdccsrv,amountsent)).suf) $+ $s.encright
          scon %n msg %chan $iif($istok($hget(various,mono),%chan,44),$strip(%ad),%ad)
        }
        inc %n
      }
      inc %a
    }
  }
}

alias addtoqueue {
  write $queuefile $1-
}

alias doxdccsend {
  .timer 1 0 window -a $1
  .timercheckcps 0 15 checkcps
  var %send = $read($queuefile,1)
  var %nick = $gettok(%send,1,32)
  var %pack = $remove($gettok(%send,2,32),$chr(35))
  var %file = $read($packsfile,%pack)
  dcc send %nick $gettok(%file,1,42)
  hinc xdccsrv filessent
  theme.text $s.head(XDCC Server sending file) $s.encleft $+ $s.value($nopath($gettok(%file,1,42))) $+ $s.encright $s.head(to) $s.encleft $+ $s.value(%nick) $+ $s.encright
  write -dl1 $queuefile
}


alias xdccsrvon {
  hadd xdccsrv active 1
  .enable #xdccserver
}

alias xdccsrvoff {
  hadd xdccsrv active 0
  write -c $queuefile
  .disable #xdccserver
}

alias xdccspeed {
  var %speed = 0, %s = 1
  while (%s <= $send(0)) {
    var %speed = $calc(%speed + $send(%s).cps)
    inc %s
  }
  return %speed
}

alias xdccsrvstats {
  say $s.head(XDCC Server Stats... Posted) $s.encleft $+ $s.value($bytes($hget(xdccsrv,posted)).suf) $+ $s.encright $s.sep $s.head(Served) $s.encleft $+ $s.value($hget(xdccsrv,filessent)) $+ $s.encright $s.head(files totalling) $s.encleft $+ $s.value($bytes($hget(xdccsrv,amountsent)).suf) $+ $s.encright $s.sep $s.head(Current speed) $s.encleft $+ $s.value($bytes($xdccspeed).suf $+ /s) $+ $s.encright
}

;---EVENTS---

alias xdcchandle {
  if ($2-3 == XDCC SEND) {
    if ($hget(xdccsrv,active) == 1) {
      if ($4 <= $lines($packsfile)) {
        if ($send(0) < $hget(xdccsrv,totalxfers)) {
          if ($numsends($1) < $hget(xdccsrv,xfersperuser)) {
            addtoqueue $1 $4
            theme.text $s.head(XDCC send request from) $s.encleft $+ $s.value($1) $+ $s.encright $s.head(for pack) $s.encleft $+ $s.value($4) $+ $s.encright
            incpack $4
            .timer 1 0 doxdccsend $active $1
          }
          else {
            if ($lines($queuefile) < $hget(xdccsrv,maxqueue)) {
              if ($numqueues($1) < $hget(xdccsrv,qperuser)) {
                addtoqueue $1 $4
                .timer 1 5 .notice $1 Your request will be placed in queue position $lines($queuefile) as the server is busy. To remove your queue(s) at a later time type "/ctcp $me XDCC REMOVE $lines($queuefile) $+ " or just "REMOVE" to delete your entire queue. Time left approx $timeleft 
                theme.text $s.head(XDCC send request from) $s.encleft $+ $s.value($1) $+ $s.encright $s.head(for pack) $s.encleft $+ $s.value($4) $+ $s.encright $s.head(placed in queue position) $s.encleft $+ $s.value($lines($queuefile)) $+ $s.encright
              }
              else {
                .notice $1 You already have $numqueues($1) files queued. Please try later.
              }
            }
            else {
              .notice $1 The maximum queues have already been reached. Please try later.
            }
          }
        }
        else {
          if ($lines($queuefile) < $hget(xdccsrv,maxqueue)) {
            if ($numqueues($nick) < $hget(xdccsrv,qperuser)) {
              addtoqueue $1 $4
              .timer 1 5 .notice $1 Your request will be placed in queue position $lines($queuefile) as the server is busy. To remove your queue(s) at a later time type "/ctcp $me XDCC REMOVE $lines($queuefile) $+ " or just "REMOVE" to delete your entire queue. Time left approx $timeleft 
              theme.text $s.head(XDCC send request from) $s.encleft $+ $s.value($1) $+ $s.encright $s.head(for pack) $s.encleft $+ $s.value($4) $+ $s.encright $s.head(placed in queue position) $s.encleft $+ $s.value($lines($queuefile)) $+ $s.encright
            }
            else {
              .notice $1 You already have $numqueues($1) files queued. Please try later.
            }
          }
          else {
            .notice $1 The maximum queues have already been reached. Please try later.
          }
        }
      }
      else {
        .notice $1 Invalid pack number. Please try again.
      }
    }
    else {
      .notice $1 $me $+ 's XDCC Server is not active at the moment. Please try again later.
    }
  }
  if ($2-3 == XDCC REMOVE) {
    if ($4) {
      if ($hget(xdccsrv,active) == 1) {
        var %pack = $remove($4,$chr(35))
        theme.text $s.head(XDCC remove request for pack) $s.encleft $+ $s.value(%pack) $+ $s.encright $s.head(from) $s.encleft $+ $s.value($1) $+ $s.encright
        if ($gettok($read($queuefile,%pack),1,32) == $1) {
          var %f = $gettok($read($queuefile,%pack),2,32)
          write -dl $+ %pack $queuefile
          .notice $1 Queued file $chr(35) $+ %pack $qt($numtofile(%f)) has been removed.
        }
      }
    }
    else if ($hget(xdccsrv,active) == 1) {
      theme.text $s.head(XDCC remove request from) $s.encleft $+ $s.value($1) $+ $s.encright
      removeq $1
      .notice $1 Queues for $replace($qt($hget(xdccsrv,$1)),$chr(44),$chr(32) $+ $chr(44) $+ $chr(32)) have been removed.
    }
  }
  if ($2-3 == XDCC QUEUES) {
    if ($hget(xdccsrv,active) == 1) {
      var %l = 1, %q = $null, %nick = $1
      while (%l <= $lines($queuefile)) {
        var %queue = $read($queuefile,%l)
        tokenize 32 %queue
        if ($1 == %nick) {
          var %q = %q $chr(35) $+ %l $qt($numtofile($2))
        }
        inc %l
      }
      theme.text $s.head(XDCC queues request from) $s.encleft $+ $s.value(%nick) $+ $s.encright      
      if (%q) {
        .notice %nick You have the following files queued: %q
      }
      else {
        .notice %nick You have no files queued.
      }
    }    
  }
}

#xdccserver off

on *:filesent:*: {
  .timercheckcps off
  hadd xdccsrv amountsent $calc($hget(xdccsrv,amountsent) + $file($filename).size)
  var %send = $read($queuefile,1)
  if (%send) {
    if ($send(0) < $hget(xdccsrv,totalxfers)) {
      .timer 1 0 doxdccsend $active $nick
    }
  }
}

on *:sendfail:*: {
  .timercheckcps off
  var %send = $read($queuefile,1)
  if (%send) {
    .timer 1 0 doxdccsend $active $nick
  }
}

#xdccserver end

alias checkcps {
  var %l = 1
  while (%l <= $send(0)) {
    if ($send(%l).cps < $hget(xdccsrv,mincps)) {
      .notice $send(%l) Your transfer rate of $bytes($send(%l).cps).suf $+ /s has fallen below the minimum requirement of $bytes($hget(xdccsrv,mincps)).suf $+ /s so the transfer of file $qt($send(%l).file) has been terminated.
      close -s $send(%l)
      .timercheckcps off
      .timer 1 0 doxdccsend $active $send(%l)
    }
    inc %l
  }
}

alias timeleft {
  var %size = 0, %l = 2
  while (%l <= $lines($queuefile)) {
    var %q = $read($queuefile,%l)
    var %p = $remove($gettok(%q,2,32),$chr(35))
    var %r = $read($packsfile,%p)
    var %s = $gettok(%r,2,42)
    var %size = $calc(%size + %s)
    inc %l
  }
  var %n = 1
  while (%n <= $send(0)) {
    var %size = $calc(%size + $calc($send(%n).size - $send(%n).sent))
    inc %n
  }
  var %secs = $calc(%size / $send(1).cps)
  return $duration(%secs)
}

alias incpack {
  var %pack = $read($packsfile,$1), %p = $1
  tokenize 42 %pack
  var %l = $calc($3 + 1)
  write -l $+ %p $packsfile $+($1,*,$2,*,%l)
}

alias removeq {
  var %q = 1
  hadd xdccsrv $1 $null
  while ($read($queuefile,s,$1)) {
    hadd xdccsrv $1 $addtok($hget(xdccsrv,$1),$numtofile($remove($ifmatch,$chr(35))),44)
    write -ds $+ $1 $queuefile
  }
}

alias numtofile {
  return $nopath($gettok($read($packsfile,$1),1,42))
}

alias numqueues {
  var %l = 1, %c = 0
  while (%l <= $lines($queuefile)) {
    if ($1 isin $read($queuefile,%l)) {
      inc %c
    }
    inc %l
  }
  return %c
}

alias numsends {
  var %l = 1, %c = 0
  while (%l <= $send(0)) {
    if ($send(%l) == $1) {
      inc %c
    }
    inc %l
  }
  return %c
}
